/* A Bison parser, made by GNU Bison 3.5.1.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 26 "src/p.y"


/*
 * DESCRIPTION
 *   Simple context-free grammar for parsing the control file.
 *
 */

#include "config.h"

#ifdef HAVE_STDIO_H
#include <stdio.h>
#endif

#ifdef HAVE_STDLIB_H
#include <stdlib.h>
#endif

#ifdef HAVE_ERRNO_H
#include <errno.h>
#endif

#ifdef HAVE_CTYPE_H
#include <ctype.h>
#endif

#ifdef HAVE_PWD_H
#include <pwd.h>
#endif

#ifdef HAVE_GRP_H
#include <grp.h>
#endif

#ifdef HAVE_SYS_TYPES_H
#include <sys/types.h>
#endif

#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif

#ifdef HAVE_TIME_H
#include <time.h>
#endif

#ifdef HAVE_SYS_SOCKET_H
#include <sys/socket.h>
#endif

#ifdef HAVE_ASM_PARAM_H
#include <asm/param.h>
#endif

#ifdef HAVE_STRING_H
#include <string.h>
#endif

#ifdef HAVE_STRINGS_H
#include <strings.h>
#endif

#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif

#ifdef HAVE_SYSLOG_H
#include <syslog.h>
#endif

#ifdef HAVE_NETINET_IN_SYSTM_H
#include <netinet/in_systm.h>
#endif

#ifdef HAVE_NETINET_IN_H
#include <netinet/in.h>
#endif

#ifdef HAVE_NETINET_IP_H
#include <netinet/ip.h>
#endif

#ifdef HAVE_NETINET_IP_ICMP_H
#include <netinet/ip_icmp.h>
#endif

#ifdef HAVE_REGEX_H
#include <regex.h>
#endif

#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#ifdef HAVE_OPENSSL
#include <openssl/ssl.h>
#endif

#include "monit.h"
#include "protocol.h"
#include "engine.h"
#include "alert.h"
#include "ProcessTree.h"
#include "device.h"
#include "processor.h"
#include "md5.h"
#include "sha1.h"
#include "checksum.h"
#include "process_sysdep.h"

// libmonit
#include "io/File.h"
#include "util/Str.h"
#include "thread/Thread.h"


/* ------------------------------------------------------------- Definitions */


struct precedence_t {
        bool daemon;
        bool logfile;
        bool pidfile;
};

struct rate_t {
        unsigned int count;
        unsigned int cycles;
};

/* yacc interface */
void  yyerror(const char *,...) __attribute__((format (printf, 1, 2)));
void  yyerror2(const char *,...) __attribute__((format (printf, 1, 2)));
void  yywarning(const char *,...) __attribute__((format (printf, 1, 2)));
void  yywarning2(const char *,...) __attribute__((format (printf, 1, 2)));

/* lexer interface */
int yylex(void);
extern FILE *yyin;
extern int lineno;
extern int arglineno;
extern char *yytext;
extern char *argyytext;
extern char *currentfile;
extern char *argcurrentfile;
extern int buffer_stack_ptr;

/* Local variables */
static int cfg_errflag = 0;
static Service_T tail = NULL;
static Service_T current = NULL;
static Request_T urlrequest = NULL;
static command_t command = NULL;
static command_t command1 = NULL;
static command_t command2 = NULL;
static Service_T depend_list = NULL;
static struct Uid_T uidset = {};
static struct Gid_T gidset = {};
static struct Pid_T pidset = {};
static struct Pid_T ppidset = {};
static struct FsFlag_T fsflagset = {};
static struct NonExist_T nonexistset = {};
static struct Exist_T existset = {};
static struct Status_T statusset = {};
static struct Perm_T permset = {};
static struct Size_T sizeset = {};
static struct Uptime_T uptimeset = {};
static struct ResponseTime_T responsetimeset = {};
static struct LinkStatus_T linkstatusset = {};
static struct LinkSpeed_T linkspeedset = {};
static struct LinkSaturation_T linksaturationset = {};
static struct Bandwidth_T bandwidthset = {};
static struct Match_T matchset = {};
static struct Icmp_T icmpset = {};
static struct Mail_T mailset = {};
static struct SslOptions_T sslset = {};
static struct Port_T portset = {};
static struct MailServer_T mailserverset = {};
static struct Mmonit_T mmonitset = {};
static struct FileSystem_T filesystemset = {};
static struct Resource_T resourceset = {};
static struct Checksum_T checksumset = {};
static struct Timestamp_T timestampset = {};
static struct ActionRate_T actionrateset = {};
static struct precedence_t ihp = {false, false, false};
static struct rate_t rate = {1, 1};
static struct rate_t rate1 = {1, 1};
static struct rate_t rate2 = {1, 1};
static char * htpasswd_file = NULL;
static unsigned int repeat = 0;
static unsigned int repeat1 = 0;
static unsigned int repeat2 = 0;
static Digest_Type digesttype = Digest_Cleartext;

#define BITMAP_MAX (sizeof(long long) * 8)


/* -------------------------------------------------------------- Prototypes */

static void  preparse(void);
static void  postparse(void);
static bool _parseOutgoingAddress(const char *ip, Outgoing_T *outgoing);
static void  addmail(char *, Mail_T, Mail_T *);
static Service_T createservice(Service_Type, char *, char *, State_Type (*)(Service_T));
static void  addservice(Service_T);
static void  adddependant(char *);
static void  addservicegroup(char *);
static void  addport(Port_T *, Port_T);
static void  addhttpheader(Port_T, const char *);
static void  addresource(Resource_T);
static void  addtimestamp(Timestamp_T);
static void  addactionrate(ActionRate_T);
static void  addsize(Size_T);
static void  adduptime(Uptime_T);
static void  addpid(Pid_T);
static void  addppid(Pid_T);
static void  addfsflag(FsFlag_T);
static void  addnonexist(NonExist_T);
static void  addexist(Exist_T);
static void  addlinkstatus(Service_T, LinkStatus_T);
static void  addlinkspeed(Service_T, LinkSpeed_T);
static void  addlinksaturation(Service_T, LinkSaturation_T);
static void  addbandwidth(Bandwidth_T *, Bandwidth_T);
static void  addfilesystem(FileSystem_T);
static void  addicmp(Icmp_T);
static void  addgeneric(Port_T, char*, char*);
static void  addcommand(int, unsigned);
static void  addargument(char *);
static void  addmmonit(Mmonit_T);
static void  addmailserver(MailServer_T);
static bool addcredentials(char *, char *, Digest_Type, bool);
#ifdef HAVE_LIBPAM
static void  addpamauth(char *, int);
#endif
static void  addhtpasswdentry(char *, char *, Digest_Type);
static uid_t get_uid(char *, uid_t);
static gid_t get_gid(char *, gid_t);
static void  addchecksum(Checksum_T);
static void  addperm(Perm_T);
static void  addmatch(Match_T, int, int);
static void  addmatchpath(Match_T, Action_Type);
static void  addstatus(Status_T);
static Uid_T adduid(Uid_T);
static Gid_T addgid(Gid_T);
static void  addeuid(uid_t);
static void  addegid(gid_t);
static void  addeventaction(EventAction_T *, Action_Type, Action_Type);
static void  prepare_urlrequest(URL_T U);
static void  seturlrequest(int, char *);
static void  setlogfile(char *);
static void  setpidfile(char *);
static void  reset_sslset(void);
static void  reset_mailset(void);
static void  reset_mailserverset(void);
static void  reset_mmonitset(void);
static void  reset_portset(void);
static void  reset_resourceset(void);
static void  reset_timestampset(void);
static void  reset_actionrateset(void);
static void  reset_sizeset(void);
static void  reset_uptimeset(void);
static void  reset_responsetimeset(void);
static void  reset_pidset(void);
static void  reset_ppidset(void);
static void  reset_fsflagset(void);
static void  reset_nonexistset(void);
static void  reset_existset(void);
static void  reset_linkstatusset(void);
static void  reset_linkspeedset(void);
static void  reset_linksaturationset(void);
static void  reset_bandwidthset(void);
static void  reset_checksumset(void);
static void  reset_permset(void);
static void  reset_uidset(void);
static void  reset_gidset(void);
static void  reset_statusset(void);
static void  reset_filesystemset(void);
static void  reset_icmpset(void);
static void  reset_rateset(struct rate_t *);
static void  check_name(char *);
static int   check_perm(int);
static void  check_exec(char *);
static int   cleanup_hash_string(char *);
static void  check_depend(void);
static void  setsyslog(char *);
static command_t copycommand(command_t);
static int verifyMaxForward(int);
static void _setPEM(char **store, char *path, const char *description, bool isFile);
static void _setSSLOptions(SslOptions_T options);
#ifdef HAVE_OPENSSL
static void _setSSLVersion(short version);
#endif
static void _unsetSSLVersion(short version);
static void addsecurityattribute(char *, Action_Type, Action_Type);
static void addfiledescriptors(Operator_Type, bool, long long, float, Action_Type, Action_Type);


#line 368 "src/y.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_SRC_Y_TAB_H_INCLUDED
# define YY_YY_SRC_Y_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    IF = 258,
    ELSE = 259,
    THEN = 260,
    FAILED = 261,
    SET = 262,
    LOGFILE = 263,
    FACILITY = 264,
    DAEMON = 265,
    SYSLOG = 266,
    MAILSERVER = 267,
    HTTPD = 268,
    ALLOW = 269,
    REJECTOPT = 270,
    ADDRESS = 271,
    INIT = 272,
    TERMINAL = 273,
    BATCH = 274,
    READONLY = 275,
    CLEARTEXT = 276,
    MD5HASH = 277,
    SHA1HASH = 278,
    CRYPT = 279,
    DELAY = 280,
    PEMFILE = 281,
    PEMKEY = 282,
    PEMCHAIN = 283,
    ENABLE = 284,
    DISABLE = 285,
    SSLTOKEN = 286,
    CIPHER = 287,
    CLIENTPEMFILE = 288,
    ALLOWSELFCERTIFICATION = 289,
    SELFSIGNED = 290,
    VERIFY = 291,
    CERTIFICATE = 292,
    CACERTIFICATEFILE = 293,
    CACERTIFICATEPATH = 294,
    VALID = 295,
    INTERFACE = 296,
    LINK = 297,
    PACKET = 298,
    BYTEIN = 299,
    BYTEOUT = 300,
    PACKETIN = 301,
    PACKETOUT = 302,
    SPEED = 303,
    SATURATION = 304,
    UPLOAD = 305,
    DOWNLOAD = 306,
    TOTAL = 307,
    UP = 308,
    DOWN = 309,
    IDFILE = 310,
    STATEFILE = 311,
    SEND = 312,
    EXPECT = 313,
    CYCLE = 314,
    COUNT = 315,
    REMINDER = 316,
    REPEAT = 317,
    LIMITS = 318,
    SENDEXPECTBUFFER = 319,
    EXPECTBUFFER = 320,
    FILECONTENTBUFFER = 321,
    HTTPCONTENTBUFFER = 322,
    PROGRAMOUTPUT = 323,
    NETWORKTIMEOUT = 324,
    PROGRAMTIMEOUT = 325,
    STARTTIMEOUT = 326,
    STOPTIMEOUT = 327,
    RESTARTTIMEOUT = 328,
    PIDFILE = 329,
    START = 330,
    STOP = 331,
    PATHTOK = 332,
    RSAKEY = 333,
    HOST = 334,
    HOSTNAME = 335,
    PORT = 336,
    IPV4 = 337,
    IPV6 = 338,
    TYPE = 339,
    UDP = 340,
    TCP = 341,
    TCPSSL = 342,
    PROTOCOL = 343,
    CONNECTION = 344,
    ALERT = 345,
    NOALERT = 346,
    MAILFORMAT = 347,
    UNIXSOCKET = 348,
    SIGNATURE = 349,
    TIMEOUT = 350,
    RETRY = 351,
    RESTART = 352,
    CHECKSUM = 353,
    EVERY = 354,
    NOTEVERY = 355,
    DEFAULT = 356,
    HTTP = 357,
    HTTPS = 358,
    APACHESTATUS = 359,
    FTP = 360,
    SMTP = 361,
    SMTPS = 362,
    POP = 363,
    POPS = 364,
    IMAP = 365,
    IMAPS = 366,
    CLAMAV = 367,
    NNTP = 368,
    NTP3 = 369,
    MYSQL = 370,
    MYSQLS = 371,
    DNS = 372,
    WEBSOCKET = 373,
    MQTT = 374,
    SSH = 375,
    DWP = 376,
    LDAP2 = 377,
    LDAP3 = 378,
    RDATE = 379,
    RSYNC = 380,
    TNS = 381,
    PGSQL = 382,
    POSTFIXPOLICY = 383,
    SIP = 384,
    LMTP = 385,
    GPS = 386,
    RADIUS = 387,
    MEMCACHE = 388,
    REDIS = 389,
    MONGODB = 390,
    SIEVE = 391,
    SPAMASSASSIN = 392,
    FAIL2BAN = 393,
    STRING = 394,
    PATH = 395,
    MAILADDR = 396,
    MAILFROM = 397,
    MAILREPLYTO = 398,
    MAILSUBJECT = 399,
    MAILBODY = 400,
    SERVICENAME = 401,
    STRINGNAME = 402,
    NUMBER = 403,
    PERCENT = 404,
    LOGLIMIT = 405,
    CLOSELIMIT = 406,
    DNSLIMIT = 407,
    KEEPALIVELIMIT = 408,
    REPLYLIMIT = 409,
    REQUESTLIMIT = 410,
    STARTLIMIT = 411,
    WAITLIMIT = 412,
    GRACEFULLIMIT = 413,
    CLEANUPLIMIT = 414,
    REAL = 415,
    CHECKPROC = 416,
    CHECKFILESYS = 417,
    CHECKFILE = 418,
    CHECKDIR = 419,
    CHECKHOST = 420,
    CHECKSYSTEM = 421,
    CHECKFIFO = 422,
    CHECKPROGRAM = 423,
    CHECKNET = 424,
    THREADS = 425,
    CHILDREN = 426,
    METHOD = 427,
    GET = 428,
    HEAD = 429,
    STATUS = 430,
    ORIGIN = 431,
    VERSIONOPT = 432,
    READ = 433,
    WRITE = 434,
    OPERATION = 435,
    SERVICETIME = 436,
    DISK = 437,
    RESOURCE = 438,
    MEMORY = 439,
    TOTALMEMORY = 440,
    LOADAVG1 = 441,
    LOADAVG5 = 442,
    LOADAVG15 = 443,
    SWAP = 444,
    MODE = 445,
    ACTIVE = 446,
    PASSIVE = 447,
    MANUAL = 448,
    ONREBOOT = 449,
    NOSTART = 450,
    LASTSTATE = 451,
    CORE = 452,
    CPU = 453,
    TOTALCPU = 454,
    CPUUSER = 455,
    CPUSYSTEM = 456,
    CPUWAIT = 457,
    CPUNICE = 458,
    CPUHARDIRQ = 459,
    CPUSOFTIRQ = 460,
    CPUSTEAL = 461,
    CPUGUEST = 462,
    CPUGUESTNICE = 463,
    GROUP = 464,
    REQUEST = 465,
    DEPENDS = 466,
    BASEDIR = 467,
    SLOT = 468,
    EVENTQUEUE = 469,
    SECRET = 470,
    HOSTHEADER = 471,
    UID = 472,
    EUID = 473,
    GID = 474,
    MMONIT = 475,
    INSTANCE = 476,
    USERNAME = 477,
    PASSWORD = 478,
    TIME = 479,
    ATIME = 480,
    CTIME = 481,
    MTIME = 482,
    CHANGED = 483,
    MILLISECOND = 484,
    SECOND = 485,
    MINUTE = 486,
    HOUR = 487,
    DAY = 488,
    MONTH = 489,
    SSLV2 = 490,
    SSLV3 = 491,
    TLSV1 = 492,
    TLSV11 = 493,
    TLSV12 = 494,
    TLSV13 = 495,
    CERTMD5 = 496,
    AUTO = 497,
    NOSSLV2 = 498,
    NOSSLV3 = 499,
    NOTLSV1 = 500,
    NOTLSV11 = 501,
    NOTLSV12 = 502,
    NOTLSV13 = 503,
    BYTE = 504,
    KILOBYTE = 505,
    MEGABYTE = 506,
    GIGABYTE = 507,
    INODE = 508,
    SPACE = 509,
    TFREE = 510,
    PERMISSION = 511,
    SIZE = 512,
    MATCH = 513,
    NOT = 514,
    IGNORE = 515,
    ACTION = 516,
    UPTIME = 517,
    RESPONSETIME = 518,
    EXEC = 519,
    UNMONITOR = 520,
    PING = 521,
    PING4 = 522,
    PING6 = 523,
    ICMP = 524,
    ICMPECHO = 525,
    NONEXIST = 526,
    EXIST = 527,
    INVALID = 528,
    DATA = 529,
    RECOVERED = 530,
    PASSED = 531,
    SUCCEEDED = 532,
    URL = 533,
    CONTENT = 534,
    PID = 535,
    PPID = 536,
    FSFLAG = 537,
    REGISTER = 538,
    CREDENTIALS = 539,
    URLOBJECT = 540,
    ADDRESSOBJECT = 541,
    TARGET = 542,
    TIMESPEC = 543,
    HTTPHEADER = 544,
    MAXFORWARD = 545,
    FIPS = 546,
    SECURITY = 547,
    ATTRIBUTE = 548,
    FILEDESCRIPTORS = 549,
    GREATER = 550,
    GREATEROREQUAL = 551,
    LESS = 552,
    LESSOREQUAL = 553,
    EQUAL = 554,
    NOTEQUAL = 555
  };
#endif
/* Tokens.  */
#define IF 258
#define ELSE 259
#define THEN 260
#define FAILED 261
#define SET 262
#define LOGFILE 263
#define FACILITY 264
#define DAEMON 265
#define SYSLOG 266
#define MAILSERVER 267
#define HTTPD 268
#define ALLOW 269
#define REJECTOPT 270
#define ADDRESS 271
#define INIT 272
#define TERMINAL 273
#define BATCH 274
#define READONLY 275
#define CLEARTEXT 276
#define MD5HASH 277
#define SHA1HASH 278
#define CRYPT 279
#define DELAY 280
#define PEMFILE 281
#define PEMKEY 282
#define PEMCHAIN 283
#define ENABLE 284
#define DISABLE 285
#define SSLTOKEN 286
#define CIPHER 287
#define CLIENTPEMFILE 288
#define ALLOWSELFCERTIFICATION 289
#define SELFSIGNED 290
#define VERIFY 291
#define CERTIFICATE 292
#define CACERTIFICATEFILE 293
#define CACERTIFICATEPATH 294
#define VALID 295
#define INTERFACE 296
#define LINK 297
#define PACKET 298
#define BYTEIN 299
#define BYTEOUT 300
#define PACKETIN 301
#define PACKETOUT 302
#define SPEED 303
#define SATURATION 304
#define UPLOAD 305
#define DOWNLOAD 306
#define TOTAL 307
#define UP 308
#define DOWN 309
#define IDFILE 310
#define STATEFILE 311
#define SEND 312
#define EXPECT 313
#define CYCLE 314
#define COUNT 315
#define REMINDER 316
#define REPEAT 317
#define LIMITS 318
#define SENDEXPECTBUFFER 319
#define EXPECTBUFFER 320
#define FILECONTENTBUFFER 321
#define HTTPCONTENTBUFFER 322
#define PROGRAMOUTPUT 323
#define NETWORKTIMEOUT 324
#define PROGRAMTIMEOUT 325
#define STARTTIMEOUT 326
#define STOPTIMEOUT 327
#define RESTARTTIMEOUT 328
#define PIDFILE 329
#define START 330
#define STOP 331
#define PATHTOK 332
#define RSAKEY 333
#define HOST 334
#define HOSTNAME 335
#define PORT 336
#define IPV4 337
#define IPV6 338
#define TYPE 339
#define UDP 340
#define TCP 341
#define TCPSSL 342
#define PROTOCOL 343
#define CONNECTION 344
#define ALERT 345
#define NOALERT 346
#define MAILFORMAT 347
#define UNIXSOCKET 348
#define SIGNATURE 349
#define TIMEOUT 350
#define RETRY 351
#define RESTART 352
#define CHECKSUM 353
#define EVERY 354
#define NOTEVERY 355
#define DEFAULT 356
#define HTTP 357
#define HTTPS 358
#define APACHESTATUS 359
#define FTP 360
#define SMTP 361
#define SMTPS 362
#define POP 363
#define POPS 364
#define IMAP 365
#define IMAPS 366
#define CLAMAV 367
#define NNTP 368
#define NTP3 369
#define MYSQL 370
#define MYSQLS 371
#define DNS 372
#define WEBSOCKET 373
#define MQTT 374
#define SSH 375
#define DWP 376
#define LDAP2 377
#define LDAP3 378
#define RDATE 379
#define RSYNC 380
#define TNS 381
#define PGSQL 382
#define POSTFIXPOLICY 383
#define SIP 384
#define LMTP 385
#define GPS 386
#define RADIUS 387
#define MEMCACHE 388
#define REDIS 389
#define MONGODB 390
#define SIEVE 391
#define SPAMASSASSIN 392
#define FAIL2BAN 393
#define STRING 394
#define PATH 395
#define MAILADDR 396
#define MAILFROM 397
#define MAILREPLYTO 398
#define MAILSUBJECT 399
#define MAILBODY 400
#define SERVICENAME 401
#define STRINGNAME 402
#define NUMBER 403
#define PERCENT 404
#define LOGLIMIT 405
#define CLOSELIMIT 406
#define DNSLIMIT 407
#define KEEPALIVELIMIT 408
#define REPLYLIMIT 409
#define REQUESTLIMIT 410
#define STARTLIMIT 411
#define WAITLIMIT 412
#define GRACEFULLIMIT 413
#define CLEANUPLIMIT 414
#define REAL 415
#define CHECKPROC 416
#define CHECKFILESYS 417
#define CHECKFILE 418
#define CHECKDIR 419
#define CHECKHOST 420
#define CHECKSYSTEM 421
#define CHECKFIFO 422
#define CHECKPROGRAM 423
#define CHECKNET 424
#define THREADS 425
#define CHILDREN 426
#define METHOD 427
#define GET 428
#define HEAD 429
#define STATUS 430
#define ORIGIN 431
#define VERSIONOPT 432
#define READ 433
#define WRITE 434
#define OPERATION 435
#define SERVICETIME 436
#define DISK 437
#define RESOURCE 438
#define MEMORY 439
#define TOTALMEMORY 440
#define LOADAVG1 441
#define LOADAVG5 442
#define LOADAVG15 443
#define SWAP 444
#define MODE 445
#define ACTIVE 446
#define PASSIVE 447
#define MANUAL 448
#define ONREBOOT 449
#define NOSTART 450
#define LASTSTATE 451
#define CORE 452
#define CPU 453
#define TOTALCPU 454
#define CPUUSER 455
#define CPUSYSTEM 456
#define CPUWAIT 457
#define CPUNICE 458
#define CPUHARDIRQ 459
#define CPUSOFTIRQ 460
#define CPUSTEAL 461
#define CPUGUEST 462
#define CPUGUESTNICE 463
#define GROUP 464
#define REQUEST 465
#define DEPENDS 466
#define BASEDIR 467
#define SLOT 468
#define EVENTQUEUE 469
#define SECRET 470
#define HOSTHEADER 471
#define UID 472
#define EUID 473
#define GID 474
#define MMONIT 475
#define INSTANCE 476
#define USERNAME 477
#define PASSWORD 478
#define TIME 479
#define ATIME 480
#define CTIME 481
#define MTIME 482
#define CHANGED 483
#define MILLISECOND 484
#define SECOND 485
#define MINUTE 486
#define HOUR 487
#define DAY 488
#define MONTH 489
#define SSLV2 490
#define SSLV3 491
#define TLSV1 492
#define TLSV11 493
#define TLSV12 494
#define TLSV13 495
#define CERTMD5 496
#define AUTO 497
#define NOSSLV2 498
#define NOSSLV3 499
#define NOTLSV1 500
#define NOTLSV11 501
#define NOTLSV12 502
#define NOTLSV13 503
#define BYTE 504
#define KILOBYTE 505
#define MEGABYTE 506
#define GIGABYTE 507
#define INODE 508
#define SPACE 509
#define TFREE 510
#define PERMISSION 511
#define SIZE 512
#define MATCH 513
#define NOT 514
#define IGNORE 515
#define ACTION 516
#define UPTIME 517
#define RESPONSETIME 518
#define EXEC 519
#define UNMONITOR 520
#define PING 521
#define PING4 522
#define PING6 523
#define ICMP 524
#define ICMPECHO 525
#define NONEXIST 526
#define EXIST 527
#define INVALID 528
#define DATA 529
#define RECOVERED 530
#define PASSED 531
#define SUCCEEDED 532
#define URL 533
#define CONTENT 534
#define PID 535
#define PPID 536
#define FSFLAG 537
#define REGISTER 538
#define CREDENTIALS 539
#define URLOBJECT 540
#define ADDRESSOBJECT 541
#define TARGET 542
#define TIMESPEC 543
#define HTTPHEADER 544
#define MAXFORWARD 545
#define FIPS 546
#define SECURITY 547
#define ATTRIBUTE 548
#define FILEDESCRIPTORS 549
#define GREATER 550
#define GREATEROREQUAL 551
#define LESS 552
#define LESSOREQUAL 553
#define EQUAL 554
#define NOTEQUAL 555

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 324 "src/p.y"

        URL_T url;
        Address_T address;
        float real;
        int   number;
        char *string;

#line 1028 "src/y.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_SRC_Y_TAB_H_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  69
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1949

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  307
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  247
/* YYNRULES -- Number of rules.  */
#define YYNRULES  829
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1610

#define YYUNDEFTOK  2
#define YYMAXUTOK   555


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   303,     2,
       2,     2,     2,     2,   304,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   305,     2,   306,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   301,     2,   302,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   378,   378,   379,   382,   383,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   415,   416,   419,   420,   421,   422,   423,
     424,   425,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,   438,   439,   440,   441,   442,   445,
     446,   449,   450,   451,   452,   453,   454,   455,   456,   457,
     458,   459,   460,   461,   462,   463,   464,   465,   466,   469,
     470,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   489,   490,   491,
     492,   495,   496,   499,   500,   501,   502,   503,   504,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   516,   517,
     520,   521,   522,   523,   524,   525,   526,   527,   528,   529,
     530,   531,   532,   535,   536,   539,   540,   541,   542,   543,
     544,   545,   546,   547,   548,   549,   550,   551,   552,   553,
     556,   557,   560,   561,   562,   563,   564,   565,   566,   567,
     568,   569,   570,   571,   572,   575,   576,   579,   580,   581,
     582,   583,   584,   585,   586,   587,   588,   589,   590,   591,
     592,   593,   596,   597,   600,   601,   602,   603,   604,   605,
     606,   607,   608,   609,   610,   613,   617,   620,   626,   636,
     641,   644,   649,   654,   657,   660,   665,   671,   674,   675,
     678,   681,   684,   687,   690,   693,   696,   699,   702,   705,
     708,   711,   714,   717,   722,   727,   735,   738,   743,   746,
     750,   756,   761,   766,   774,   777,   778,   781,   787,   788,
     791,   794,   795,   796,   797,   800,   801,   806,   811,   814,
     817,   818,   821,   825,   829,   833,   837,   840,   844,   847,
     850,   853,   856,   859,   864,   870,   871,   874,   888,   895,
     904,   905,   908,   909,   912,   919,   922,   929,   932,   939,
     942,   949,   952,   959,   962,   969,   972,   983,   992,   999,
    1014,  1015,  1018,  1027,  1038,  1039,  1042,  1045,  1048,  1049,
    1050,  1051,  1054,  1081,  1082,  1085,  1086,  1087,  1088,  1089,
    1090,  1091,  1092,  1093,  1097,  1103,  1109,  1115,  1121,  1127,
    1128,  1131,  1136,  1141,  1145,  1149,  1155,  1156,  1159,  1160,
    1163,  1166,  1171,  1176,  1179,  1187,  1191,  1195,  1199,  1203,
    1203,  1210,  1210,  1217,  1217,  1224,  1224,  1231,  1238,  1239,
    1242,  1248,  1251,  1256,  1259,  1262,  1269,  1278,  1283,  1286,
    1291,  1296,  1301,  1309,  1315,  1330,  1335,  1341,  1349,  1352,
    1357,  1360,  1366,  1369,  1374,  1375,  1378,  1379,  1382,  1385,
    1390,  1394,  1398,  1401,  1406,  1409,  1414,  1419,  1422,  1427,
    1437,  1447,  1448,  1451,  1452,  1453,  1454,  1455,  1456,  1457,
    1458,  1459,  1460,  1461,  1462,  1465,  1473,  1483,  1484,  1487,
    1488,  1489,  1490,  1491,  1492,  1495,  1502,  1511,  1512,  1515,
    1516,  1517,  1518,  1519,  1520,  1523,  1532,  1538,  1544,  1550,
    1559,  1565,  1571,  1579,  1580,  1583,  1584,  1585,  1586,  1589,
    1592,  1597,  1602,  1608,  1611,  1616,  1619,  1623,  1628,  1629,
    1632,  1633,  1636,  1641,  1644,  1647,  1650,  1653,  1656,  1659,
    1662,  1667,  1670,  1675,  1678,  1681,  1684,  1687,  1690,  1693,
    1697,  1700,  1703,  1707,  1710,  1713,  1718,  1721,  1724,  1729,
    1732,  1735,  1738,  1741,  1744,  1747,  1750,  1753,  1756,  1759,
    1762,  1767,  1775,  1785,  1786,  1789,  1792,  1795,  1798,  1803,
    1804,  1807,  1810,  1815,  1816,  1819,  1822,  1827,  1828,  1831,
    1834,  1837,  1850,  1856,  1865,  1868,  1873,  1878,  1879,  1882,
    1885,  1890,  1891,  1894,  1897,  1900,  1901,  1902,  1903,  1904,
    1905,  1908,  1918,  1921,  1926,  1930,  1936,  1941,  1947,  1948,
    1953,  1958,  1959,  1962,  1967,  1968,  1971,  1974,  1977,  1980,
    1984,  1988,  1992,  1996,  2000,  2004,  2008,  2012,  2016,  2022,
    2026,  2033,  2039,  2045,  2053,  2057,  2063,  2068,  2078,  2083,
    2088,  2091,  2096,  2099,  2104,  2107,  2112,  2115,  2120,  2123,
    2128,  2133,  2138,  2144,  2152,  2158,  2159,  2162,  2166,  2169,
    2173,  2178,  2181,  2184,  2185,  2188,  2189,  2190,  2191,  2192,
    2193,  2194,  2195,  2196,  2197,  2198,  2199,  2200,  2201,  2202,
    2203,  2204,  2205,  2206,  2207,  2208,  2209,  2210,  2211,  2212,
    2213,  2214,  2215,  2216,  2217,  2220,  2221,  2224,  2225,  2228,
    2229,  2230,  2231,  2234,  2238,  2242,  2248,  2251,  2254,  2260,
    2263,  2267,  2272,  2279,  2282,  2283,  2286,  2289,  2296,  2305,
    2311,  2312,  2315,  2316,  2317,  2318,  2319,  2320,  2321,  2324,
    2330,  2331,  2334,  2335,  2336,  2337,  2340,  2345,  2352,  2359,
    2365,  2371,  2377,  2383,  2389,  2395,  2401,  2407,  2413,  2418,
    2423,  2430,  2435,  2440,  2445,  2452,  2457,  2464,  2471,  2478,
    2498,  2499,  2500,  2503,  2504,  2508,  2513,  2518,  2525,  2530,
    2535,  2542,  2543,  2546,  2547,  2548,  2549,  2552,  2559,  2567,
    2568,  2569,  2570,  2571,  2572,  2573,  2574,  2577,  2578,  2579,
    2580,  2581,  2582,  2585,  2586,  2587,  2589,  2590,  2592,  2595,
    2598,  2606,  2609,  2612,  2616,  2619,  2622,  2625,  2630,  2641,
    2652,  2662,  2674,  2675,  2680,  2687,  2688,  2693,  2700,  2703,
    2706,  2709,  2712,  2717,  2720,  2723,  2728,  2732,  2739,  2745,
    2746,  2747,  2750,  2757,  2764,  2771,  2780,  2787,  2794,  2801,
    2810,  2817,  2826,  2833,  2842,  2849,  2858,  2864,  2865,  2866,
    2867,  2868,  2871,  2876,  2883,  2891,  2898,  2906,  2914,  2921,
    2927,  2934,  2942,  2945,  2951,  2957,  2964,  2970,  2977,  2983,
    2990,  2993,  2998,  3004,  3012,  3018,  3026,  3034,  3040,  3047,
    3051,  3056,  3063,  3068,  3076,  3084,  3092,  3100,  3108,  3116,
    3126,  3134,  3142,  3150,  3158,  3166,  3176,  3179,  3180,  3181
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IF", "ELSE", "THEN", "FAILED", "SET",
  "LOGFILE", "FACILITY", "DAEMON", "SYSLOG", "MAILSERVER", "HTTPD",
  "ALLOW", "REJECTOPT", "ADDRESS", "INIT", "TERMINAL", "BATCH", "READONLY",
  "CLEARTEXT", "MD5HASH", "SHA1HASH", "CRYPT", "DELAY", "PEMFILE",
  "PEMKEY", "PEMCHAIN", "ENABLE", "DISABLE", "SSLTOKEN", "CIPHER",
  "CLIENTPEMFILE", "ALLOWSELFCERTIFICATION", "SELFSIGNED", "VERIFY",
  "CERTIFICATE", "CACERTIFICATEFILE", "CACERTIFICATEPATH", "VALID",
  "INTERFACE", "LINK", "PACKET", "BYTEIN", "BYTEOUT", "PACKETIN",
  "PACKETOUT", "SPEED", "SATURATION", "UPLOAD", "DOWNLOAD", "TOTAL", "UP",
  "DOWN", "IDFILE", "STATEFILE", "SEND", "EXPECT", "CYCLE", "COUNT",
  "REMINDER", "REPEAT", "LIMITS", "SENDEXPECTBUFFER", "EXPECTBUFFER",
  "FILECONTENTBUFFER", "HTTPCONTENTBUFFER", "PROGRAMOUTPUT",
  "NETWORKTIMEOUT", "PROGRAMTIMEOUT", "STARTTIMEOUT", "STOPTIMEOUT",
  "RESTARTTIMEOUT", "PIDFILE", "START", "STOP", "PATHTOK", "RSAKEY",
  "HOST", "HOSTNAME", "PORT", "IPV4", "IPV6", "TYPE", "UDP", "TCP",
  "TCPSSL", "PROTOCOL", "CONNECTION", "ALERT", "NOALERT", "MAILFORMAT",
  "UNIXSOCKET", "SIGNATURE", "TIMEOUT", "RETRY", "RESTART", "CHECKSUM",
  "EVERY", "NOTEVERY", "DEFAULT", "HTTP", "HTTPS", "APACHESTATUS", "FTP",
  "SMTP", "SMTPS", "POP", "POPS", "IMAP", "IMAPS", "CLAMAV", "NNTP",
  "NTP3", "MYSQL", "MYSQLS", "DNS", "WEBSOCKET", "MQTT", "SSH", "DWP",
  "LDAP2", "LDAP3", "RDATE", "RSYNC", "TNS", "PGSQL", "POSTFIXPOLICY",
  "SIP", "LMTP", "GPS", "RADIUS", "MEMCACHE", "REDIS", "MONGODB", "SIEVE",
  "SPAMASSASSIN", "FAIL2BAN", "STRING", "PATH", "MAILADDR", "MAILFROM",
  "MAILREPLYTO", "MAILSUBJECT", "MAILBODY", "SERVICENAME", "STRINGNAME",
  "NUMBER", "PERCENT", "LOGLIMIT", "CLOSELIMIT", "DNSLIMIT",
  "KEEPALIVELIMIT", "REPLYLIMIT", "REQUESTLIMIT", "STARTLIMIT",
  "WAITLIMIT", "GRACEFULLIMIT", "CLEANUPLIMIT", "REAL", "CHECKPROC",
  "CHECKFILESYS", "CHECKFILE", "CHECKDIR", "CHECKHOST", "CHECKSYSTEM",
  "CHECKFIFO", "CHECKPROGRAM", "CHECKNET", "THREADS", "CHILDREN", "METHOD",
  "GET", "HEAD", "STATUS", "ORIGIN", "VERSIONOPT", "READ", "WRITE",
  "OPERATION", "SERVICETIME", "DISK", "RESOURCE", "MEMORY", "TOTALMEMORY",
  "LOADAVG1", "LOADAVG5", "LOADAVG15", "SWAP", "MODE", "ACTIVE", "PASSIVE",
  "MANUAL", "ONREBOOT", "NOSTART", "LASTSTATE", "CORE", "CPU", "TOTALCPU",
  "CPUUSER", "CPUSYSTEM", "CPUWAIT", "CPUNICE", "CPUHARDIRQ", "CPUSOFTIRQ",
  "CPUSTEAL", "CPUGUEST", "CPUGUESTNICE", "GROUP", "REQUEST", "DEPENDS",
  "BASEDIR", "SLOT", "EVENTQUEUE", "SECRET", "HOSTHEADER", "UID", "EUID",
  "GID", "MMONIT", "INSTANCE", "USERNAME", "PASSWORD", "TIME", "ATIME",
  "CTIME", "MTIME", "CHANGED", "MILLISECOND", "SECOND", "MINUTE", "HOUR",
  "DAY", "MONTH", "SSLV2", "SSLV3", "TLSV1", "TLSV11", "TLSV12", "TLSV13",
  "CERTMD5", "AUTO", "NOSSLV2", "NOSSLV3", "NOTLSV1", "NOTLSV11",
  "NOTLSV12", "NOTLSV13", "BYTE", "KILOBYTE", "MEGABYTE", "GIGABYTE",
  "INODE", "SPACE", "TFREE", "PERMISSION", "SIZE", "MATCH", "NOT",
  "IGNORE", "ACTION", "UPTIME", "RESPONSETIME", "EXEC", "UNMONITOR",
  "PING", "PING4", "PING6", "ICMP", "ICMPECHO", "NONEXIST", "EXIST",
  "INVALID", "DATA", "RECOVERED", "PASSED", "SUCCEEDED", "URL", "CONTENT",
  "PID", "PPID", "FSFLAG", "REGISTER", "CREDENTIALS", "URLOBJECT",
  "ADDRESSOBJECT", "TARGET", "TIMESPEC", "HTTPHEADER", "MAXFORWARD",
  "FIPS", "SECURITY", "ATTRIBUTE", "FILEDESCRIPTORS", "GREATER",
  "GREATEROREQUAL", "LESS", "LESSOREQUAL", "EQUAL", "NOTEQUAL", "'{'",
  "'}'", "':'", "'@'", "'['", "']'", "$accept", "cfgfile",
  "statement_list", "statement", "optproclist", "optproc", "optfilelist",
  "optfile", "optfilesyslist", "optfilesys", "optdirlist", "optdir",
  "opthostlist", "opthost", "optnetlist", "optnet", "optsystemlist",
  "optsystem", "optfifolist", "optfifo", "optprogramlist", "optprogram",
  "setalert", "setdaemon", "setterminal", "startdelay", "setinit",
  "setonreboot", "setexpectbuffer", "setlimits", "limitlist", "limit",
  "setfips", "setlog", "seteventqueue", "setidfile", "setstatefile",
  "setpid", "setmmonits", "mmonitlist", "mmonit", "mmonitoptlist",
  "mmonitopt", "credentials", "setssl", "ssl", "ssloptionlist",
  "ssloption", "sslexpire", "expireoperator", "sslchecksum",
  "checksumoperator", "sslversionlist", "sslversion", "certmd5",
  "setmailservers", "setmailformat", "mailserverlist", "mailserver",
  "mailserveroptlist", "mailserveropt", "sethttpd", "httpdlist",
  "httpdoption", "pemfile", "clientpemfile", "allowselfcert", "httpdport",
  "httpdsocket", "httpdsocketoptionlist", "httpdsocketoption", "sigenable",
  "sigdisable", "signature", "bindaddress", "allow", "$@1", "$@2", "$@3",
  "$@4", "allowuserlist", "allowuser", "readonly", "checkproc",
  "checkfile", "checkfilesys", "checkdir", "checkhost", "checknet",
  "checksystem", "checkfifo", "checkprogram", "start", "stop", "restart",
  "argumentlist", "useroptionlist", "argument", "useroption", "username",
  "password", "hostname", "connection", "connectionoptlist",
  "connectionopt", "connectionurl", "connectionurloptlist",
  "connectionurlopt", "connectionunix", "connectionuxoptlist",
  "connectionuxopt", "icmp", "icmpoptlist", "icmpopt", "host", "port",
  "unixsocket", "ip", "type", "typeoptlist", "typeopt", "outgoing",
  "protocol", "sendexpect", "websocketlist", "websocket", "smtplist",
  "smtp", "mqttlist", "mqtt", "mysqllist", "mysql", "target", "maxforward",
  "siplist", "sip", "httplist", "http", "status", "method", "request",
  "responsesum", "hostheader", "httpheaderlist", "secret", "radiuslist",
  "radius", "apache_stat_list", "apache_stat", "exist", "pid", "ppid",
  "uptime", "responsetime", "icmpcount", "icmpsize", "icmptimeout",
  "icmpoutgoing", "stoptimeout", "starttimeout", "restarttimeout",
  "programtimeout", "nettimeout", "connectiontimeout", "retry",
  "actionrate", "urloption", "urloperator", "alert", "alertmail",
  "noalertmail", "eventoptionlist", "eventoption", "formatlist",
  "formatoptionlist", "formatoption", "every", "mode", "onreboot", "group",
  "depend", "dependlist", "dependant", "statusvalue", "resourceprocess",
  "resourceprocesslist", "resourceprocessopt", "resourcesystem",
  "resourcesystemlist", "resourcesystemopt", "resourcecpuproc",
  "resourcecpu", "resourcecpuid", "resourcemem", "resourcememproc",
  "resourceswap", "resourcethreads", "resourcechild", "resourceload",
  "resourceloadavg", "coremultiplier", "resourceread", "resourcewrite",
  "value", "timestamptype", "timestamp", "operator", "time", "totaltime",
  "currenttime", "repeat", "action", "action1", "action2", "rateXcycles",
  "rateXYcycles", "rate1", "rate2", "recovery_success", "recovery_failure",
  "checksum", "hashtype", "inode", "space", "read", "write", "servicetime",
  "fsflag", "unit", "permission", "match", "matchflagnot", "size", "uid",
  "euid", "secattr", "filedescriptorssystem", "filedescriptorsprocess",
  "filedescriptorsprocesstotal", "gid", "linkstatus", "linkspeed",
  "linksaturation", "upload", "download", "icmptype", "reminder", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   123,   125,    58,    64,    91,    93
};
# endif

#define YYPACT_NINF (-1338)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-743)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    1071,    84,   -84,   -69,   -56,   -46,    40,    91,   117,   163,
     170,   334,  1071, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338,    44,   183,   239, -1338, -1338,   389,   121,   289,   309,
     152,   359,   317,   319,   209,    52,   -41,   267, -1338,   -42,
     -32,   480,   483,   491,   555, -1338,   496,   514,    57, -1338,
   -1338,   533,   402,   679,   816,   929,  1121,  1213,   816,  1524,
     592, -1338,   537,   547,    -4, -1338,  1694, -1338, -1338, -1338,
   -1338, -1338,   420, -1338, -1338,  1030, -1338, -1338, -1338,   497,
     494, -1338,   267,   380,   365,   373,  1371,   616,   539,   584,
      72,   386,   603,   605,   548,   610,   459,   593,   614,   102,
     459,   459,   624,   459,   -97,   469,   599,   148,   626,   631,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338,   -16, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338,   176,   -34, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,   113, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
     122, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338,    35, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338,   128, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,  1488,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
     -55, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338,   642,   763, -1338,   650,   472,   656, -1338,
     730,    13,   678,   683,   731,   734,   531,   722, -1338,   696,
     724,   575, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338,    21,   478, -1338, -1338, -1338, -1338,
   -1338,   586,   589, -1338, -1338,     1, -1338,   674, -1338,   704,
     380,   612, -1338,  1030,  1371, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338,   419, -1338,   764, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338,   237, -1338, -1338, -1338,   135,   620,   820,   963,   963,
     963,   963,   467,   963,   963, -1338, -1338, -1338,   963,   963,
     379,   647,   963,   776,    30,   963,  1642, -1338, -1338, -1338,
   -1338, -1338, -1338,   729, -1338, -1338,   336,   594, -1338,   644,
     871, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338,   631, -1338,   633,  1371,   616,    41, -1338, -1338, -1338,
   -1338,   213,   963,   647,   385,   963,   697, -1338,   385,   711,
     -87,   963,   963,   963,  -123,  1135,  1442,   797,   312,   383,
     930,   732,   963,   963,   963,   655,   935,   963,   963, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,   963,
    1597, -1338, -1338,   963, -1338, -1338, -1338,   963,   804, -1338,
     844, -1338,   883,   349,   858, -1338, -1338, -1338, -1338, -1338,
   -1338,   876, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338,   779,   899, -1338,   904,
     906,   911,   757,   926,   928, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338,   766,   768,   771,   774,   777,
     784,   785,   792,   796,   802, -1338, -1338,   812,   813,   818,
     819,   823,   828,   832,   836,   838, -1338, -1338, -1338, -1338,
   -1338, -1338,   959,   994, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338,    23,   714,  1053, -1338,  1094,  1006,   118,   123,   -25,
   -1338, -1338, -1338,  1023,  1029,   166,   194,   311,   885,   886,
    1095, -1338,   963,  1032, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338,  1033,  1034,   247,   247,   963,   963,   247,   247,   247,
     247,   776,   776,   776,  1035,    70, -1338, -1338,  1173,   901,
    1095, -1338,   261, -1338,  1182, -1338,   963,  1041,   169, -1338,
    1045,   278, -1338,  1046,   302, -1338, -1338, -1338,  1371,  1229,
   -1338, -1338, -1338,  1051,  1102,   776,   776,   776,  1104,  1056,
   -1338, -1338,   662,  1060,   668,   681,   741,   266,   331,   356,
     776,   963,   375,   963,   247, -1338, -1338, -1338,  1131, -1338,
   -1338, -1338,  1131,   776,   776,   776,  1069,  1074,  1076,   963,
     963,   776,   247,   247,   410, -1338,  1220,   247,  1079,   776,
   -1338,   472,     8, -1338, -1338, -1338, -1338, -1338, -1338,  1091,
    1103,  1105,  1106,  1108,  1221,    78,   228,  1109,  1110,  1111,
    1113,  1114,   879,   870,  1124,  1125, -1338,  1118,  1119,  1120,
    1122,  1132,  1133,  1137,  1139,  1142, -1338,  1013, -1338,  1053,
     616, -1338,  1039, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338,   776,   776,   776,   776,   776,   776, -1338,   814,  1143,
   -1338,   530,  1144,  1234, -1338, -1338, -1338, -1338,   420,   420,
     447,   471,   591,   716,  1123,  1130,  1289,  1290,  1295,   927,
   -1338,  1242,   464, -1338, -1338,   530,    27,  1153,   464,   247,
    1075, -1338,  1077, -1338,  1084, -1338,  1304,  1053,   776,     7,
    1301,  1303,  1311,   776,   420,   776,   776,   927,   776,   776,
   -1338, -1338, -1338, -1338,  1129,   420,  1140,   420,  1088,  1089,
    1316,   479,    27,  1174,   247,   749,    65,    65,    65,  1052,
   -1338,    65,    65,    65, -1338,  1320,  1321,  1323,  1184,    69,
     108,  1183,  1187,  1332,   762,   833,    27,  1189,   464,  1190,
     776,  1336,  1043,  1043, -1338,  1206,  1108,  1108,  1108,  1221,
   -1338,  1108, -1338, -1338, -1338, -1338,   367,   481,  1199, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338,  1305,   420,   420,   420,   420,   707,   760,   773,   778,
     788, -1338,   616, -1338, -1338,  1349,  1352,  1357,  1359,  1360,
    1362,   215,   776,   776, -1338,   105,  1230,  1236,   570,  1741,
    1225,  1231,   963, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
    1363,   776,  1375,  1152,  1152,  1203,   420,  1207,   420, -1338,
   -1338, -1338, -1338, -1338, -1338,   464,   464,   464, -1338, -1338,
   -1338, -1338, -1338,   776, -1338, -1338, -1338, -1338, -1338,   459,
   -1338, -1338,  1382,   215,   105,  1383,  1386,   776,  1382, -1338,
   -1338, -1338, -1338,  1053,   616,  1387,  1255,  1390,   464,   464,
     464,  1392,   776,  1393,  1395,   776,  1396,  1400,   776,  1152,
     776,  1152,   776,   776,   464,    27,  1257,  1403,   776,   842,
     776,   776,  1270,  1263,  1266,  1273, -1338, -1338, -1338, -1338,
   -1338,  1418,  1420,  1421, -1338,    65,  1422,  1423,  1424,    65,
     464,   464,   464,   776,  1152,  1152,  1152,  1152,   222,   231,
     464, -1338, -1338, -1338, -1338,  1431,   776,  1382, -1338,  1432,
     464,  1300,  1302, -1338,  1108,  1108,  1108, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
     464,   464,   464,   464,   464,   464,    26,   385, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338,  1438,  1440,  1444,  1308, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338,  1446, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338,  1548, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338,    39, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,  1224, -1338,
    1307,   464,  1452,   692, -1338, -1338, -1338, -1338,  1152, -1338,
    1152, -1338, -1338,  1382,  1454,   303,   134, -1338,  1456,  1458,
     464,   464,  1462, -1338,   616, -1338,   464,   776,   464,  1382,
   -1338, -1338,   464,  1463,   464,   464,  1465,   464,   464,  1466,
     776,  1471,   776,  1472,  1476, -1338,  1478,   776,   464,  1483,
     776,   776,  1484,  1487, -1338, -1338,  1264, -1338,   464,   464,
     464,  1490,   464,   464,   464,  1491,  1382,  1382,  1493,  1494,
     776,   776,   776,   776,   352,   516,   583,   652,  1382,   464,
    1499, -1338,   464, -1338, -1338, -1338,  1382,  1382,  1382,  1382,
    1382,  1382,  1210,  1367,   464,   464,   464, -1338,   464,  1645,
     431,   431,  1372,   963,   963,   963,   963,   963,   963,   963,
     963,   963,   963, -1338, -1338,  1548, -1338,   808,   808,    -3,
      -3,  1368,  1374,  1366,  1376,    39, -1338,   808,  -126,  1314,
   -1338,   805,  1382,   464, -1338, -1338, -1338, -1338, -1338,   464,
    1416,   -22, -1338,   562, -1338, -1338,   464,   464,  1493,  1382,
     464, -1338,  1382,  1512,  1382, -1338, -1338,   464, -1338, -1338,
     464, -1338, -1338,   464,  1514,   464,  1521,   464,   464,   464,
    1525,  1382,   464,  1528,  1530,   464,   464, -1338,  1382,  1382,
    1382,   464,  1493,  1493,  1493,   464, -1338, -1338,   154, -1338,
     464,  1532,  1534,  1550,  1551,   615, -1338, -1338, -1338,   776,
     615,   776,   615,   776,   615,   776, -1338,  1382,   464,  1382,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338,  1409, -1338,  1382,
    1382,  1382,  1382, -1338, -1338, -1338,  1419,   869,   963,   923,
    1425, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338,  1411,  1414,  1415,  1426,  1433,  1434,  1439,  1441,  1443,
    1445, -1338, -1338, -1338, -1338,  1469, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338,   424,  1448, -1338,
   -1338, -1338,  1430, -1338, -1338, -1338, -1338, -1338,  1382,  1382,
      79, -1338,   776,   776,   776,  1493,  1493, -1338, -1338,  1382,
   -1338,   464, -1338,  1382,  1382,  1382,   464,  1382,   464,  1382,
    1382,  1382,   464, -1338,  1382,   464,   464,  1382,  1382, -1338,
   -1338, -1338,  1382, -1338, -1338, -1338,  1493,  1564, -1338,  1382,
     464,   464,   464,   464,   776,  1566,   776,  1567,   776,  1574,
     776,  1575, -1338,  1382, -1338,  1361, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338,  1449, -1338, -1338, -1338,  -158,  1453,  1464,
    1467,  1468,  1470,  1477,  1480,  1481,  1482,  1485,    16, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338,  1539, -1338, -1338,  1596,
    1598,  1600, -1338, -1338, -1338,  1382, -1338, -1338, -1338,  1382,
   -1338,  1382, -1338, -1338, -1338,  1382, -1338,  1382,  1382, -1338,
   -1338, -1338, -1338,   776, -1338,  1382,  1382,  1382,  1382,  1606,
     464,  1607,   464,  1613,   464,  1615,   464, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338,  1043,  1043,  1498, -1338,   464,   464,   464, -1338,
   -1338, -1338, -1338, -1338, -1338,  1633, -1338, -1338, -1338, -1338,
     464,  1382,   464,  1382,   464,  1382,   464,  1382,  1500,  1502,
   -1338, -1338, -1338, -1338,   464,  1382, -1338,  1382, -1338,  1382,
   -1338,  1382, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       2,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     3,     4,     6,     8,     9,    20,    22,    19,
      21,    23,    10,    11,    17,    18,    16,    12,     7,    13,
      14,    15,    33,    59,    79,   101,   118,   133,   150,   165,
     182,     0,     0,     0,   303,   202,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   224,   625,
       0,     0,     0,     0,     0,   364,     0,     0,     0,     1,
       5,    24,    25,    26,    27,    28,    32,    29,    30,    31,
     226,   225,   200,   294,   578,   290,   302,   199,   250,   231,
     232,   208,   777,   233,   591,     0,   203,   204,   205,     0,
       0,   238,   234,   245,     0,     0,     0,   827,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      34,    35,    36,    37,    48,    49,    50,    38,    39,    40,
      47,    51,    52,   625,   590,    53,    54,    55,    56,    57,
      58,    41,    42,    43,    44,    45,    46,   792,   792,    60,
      61,    62,    63,    64,    66,    68,    67,    75,    76,    77,
      78,    65,    72,    69,    74,    73,    70,    71,     0,    80,
      81,    82,    83,    84,    85,    87,    86,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,    88,    89,    90,
       0,   102,   103,   104,   105,   106,   108,   110,   109,   114,
     115,   116,   117,   107,   111,   112,   113,     0,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,     0,   134,   135,   136,   137,   143,   147,   144,
     145,   146,   148,   149,   138,   139,   140,   141,   142,     0,
     151,   152,   153,   154,   163,   155,   156,   157,   158,   159,
     160,   161,   162,   164,   166,   167,   168,   169,   170,   172,
     174,   173,   178,   179,   180,   181,   171,   175,   176,   177,
       0,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,     0,     0,   198,     0,   292,     0,   291,
     387,     0,     0,     0,     0,     0,   248,     0,   316,     0,
       0,     0,   305,   304,   306,   307,   308,   312,   313,   330,
     331,   309,   310,   311,     0,     0,   778,   779,   780,   781,
     206,     0,     0,   631,   632,     0,   627,   228,   230,   237,
     245,     0,   235,     0,     0,   609,   596,   597,   611,   612,
     619,   617,   599,   621,   598,   620,   616,   623,   605,   607,
     622,   613,   618,   595,   624,   602,   606,   610,   603,   608,
     601,   600,   614,   615,   604,     0,   593,     0,   195,   353,
     354,   355,   356,   359,   358,   357,   360,   361,   365,   378,
     379,   576,   374,   362,   363,   439,     0,     0,   709,   709,
     709,   709,     0,   709,   709,   690,   691,   692,   709,   709,
       0,     0,   709,   742,   439,   709,   742,   650,   652,   653,
     654,   655,   656,   693,   657,   658,   572,   570,   592,   574,
       0,   634,   635,   636,   637,   638,   639,   640,   641,   642,
     646,   643,   644,     0,     0,   827,   759,   703,   704,   705,
     706,   759,   709,   793,     0,   709,     0,   793,     0,     0,
       0,   709,   709,   709,     0,   709,   709,     0,   439,   439,
       0,     0,   709,   709,   709,     0,     0,   709,   709,   678,
     669,   670,   671,   672,   673,   674,   675,   676,   677,   709,
     742,   660,   665,   709,   663,   664,   662,   709,     0,   227,
       0,   294,     0,     0,     0,   274,   276,   278,   280,   282,
     284,     0,   286,   275,   277,   279,   281,   283,   285,   298,
     299,   300,   301,   295,   296,   297,     0,     0,   288,     0,
       0,     0,   347,   335,     0,   332,   314,   327,   329,   250,
     315,   317,   319,   326,   328,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   247,   251,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   207,   209,   629,   630,
     289,   628,     0,     0,   239,   241,   242,   243,   244,   236,
     246,     0,     0,   625,   594,   828,     0,     0,     0,   576,
     375,   376,   366,     0,     0,     0,     0,     0,     0,     0,
       0,   417,   709,     0,   716,   710,   711,   712,   713,   714,
     715,     0,     0,     0,     0,   709,   709,     0,     0,     0,
       0,   742,   742,   742,     0,     0,   743,   744,     0,     0,
       0,   417,     0,   651,     0,   694,   709,     0,   572,   368,
       0,   570,   370,     0,   574,   372,   633,   645,     0,     0,
     587,   760,   761,     0,     0,   742,   742,   742,     0,     0,
     585,   586,     0,     0,     0,     0,     0,     0,     0,     0,
     742,   709,     0,   709,     0,   433,   433,   433,     0,   433,
     433,   433,     0,   742,   742,   742,     0,     0,     0,   709,
     709,   742,     0,     0,     0,   661,     0,     0,     0,   742,
     201,   293,   270,   385,   384,   386,   287,   579,   388,   336,
     337,   338,     0,     0,   351,     0,   318,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   272,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   229,     0,   626,   625,
     827,   829,     0,   380,   382,   381,   383,   377,   367,   440,
     442,   742,   742,   742,   742,   742,   742,   407,     0,     0,
     391,   742,     0,     0,   687,   688,   702,   701,   777,   777,
       0,     0,   777,   777,     0,     0,     0,     0,     0,   717,
     740,     0,     0,   407,   391,   742,   702,     0,     0,     0,
       0,   369,     0,   371,     0,   373,     0,   625,   742,   742,
       0,     0,     0,   742,   777,   742,   742,   717,   742,   742,
     787,   786,   791,   790,   702,   777,   702,   777,   702,     0,
       0,     0,   702,     0,     0,   777,   742,   742,   742,     0,
     433,   742,   742,   742,   433,     0,     0,     0,     0,   777,
     777,     0,     0,     0,   777,   777,   702,     0,     0,     0,
     742,     0,   270,   270,   271,     0,     0,     0,     0,   351,
     350,   340,   348,   352,   334,   249,     0,     0,     0,   320,
     258,   260,   259,   257,   261,   254,   255,   252,   253,   262,
     263,   256,   777,   777,   777,   777,     0,     0,     0,     0,
       0,   240,   827,   196,   577,     0,     0,     0,     0,     0,
       0,   742,   742,   742,   441,   742,     0,     0,     0,     0,
       0,     0,   709,   418,   419,   420,   421,   423,   422,   424,
       0,   742,     0,   726,   726,   702,   777,   702,   777,   682,
     681,   684,   683,   666,   667,     0,     0,     0,   718,   719,
     720,   721,   722,   742,   741,   735,   736,   731,   734,     0,
     737,   738,   748,   742,   742,     0,     0,   742,   748,   689,
     573,   571,   575,   625,   827,     0,     0,     0,     0,     0,
       0,     0,   742,     0,     0,   742,     0,     0,   742,   726,
     742,   726,   742,   742,     0,   702,     0,     0,   742,   777,
     742,   742,     0,     0,     0,     0,   434,   435,   436,   437,
     438,     0,     0,     0,   826,   742,     0,     0,     0,   742,
       0,     0,     0,   742,   726,   726,   726,   726,   777,   777,
       0,   680,   679,   686,   685,     0,   742,   748,   668,     0,
       0,     0,     0,   267,   342,   344,   346,   333,   349,   321,
     323,   322,   324,   325,   273,   210,   211,   212,   213,   214,
     215,   216,   217,   220,   221,   218,   219,   222,   223,   197,
       0,     0,     0,     0,     0,     0,     0,     0,   412,   414,
     413,   408,   410,   411,   409,     0,     0,     0,     0,   443,
     444,   402,   404,   403,   392,   393,   394,   400,   395,   396,
     399,   398,   401,   397,     0,   491,   492,   447,   445,   448,
     454,   521,   521,     0,   458,   499,   499,   474,   475,   461,
     462,   463,   471,   472,   507,   507,   455,     0,   503,   480,
     456,   464,   465,   481,   483,   484,   485,   473,   517,   486,
     487,   541,   489,   482,   466,   476,   479,   457,     0,   581,
       0,     0,     0,     0,   727,   695,   698,   697,   726,   700,
     726,   561,   562,   748,     0,   728,     0,   560,     0,     0,
       0,     0,     0,   649,   827,   588,     0,   742,     0,   748,
     795,   708,     0,     0,     0,     0,     0,     0,     0,     0,
     742,     0,   742,     0,     0,   776,     0,   742,     0,     0,
     742,   742,     0,     0,   569,   566,     0,   567,     0,     0,
       0,     0,     0,     0,     0,     0,   748,   748,   753,     0,
     742,   742,   742,   742,     0,     0,     0,     0,   748,     0,
       0,   659,     0,   648,   268,   269,   748,   748,   748,   748,
     748,   748,   265,     0,     0,     0,     0,   452,     0,   446,
     459,   460,     0,   709,   709,   709,   709,   709,   709,   709,
     709,   709,   709,   546,   547,   453,   544,   477,   478,   468,
     469,     0,     0,     0,     0,   490,   493,   467,   470,   488,
     580,     0,   748,     0,   583,   582,   696,   699,   559,     0,
       0,   728,   732,     0,   739,   749,     0,     0,   753,   748,
       0,   589,   748,     0,   748,   783,   758,     0,   785,   784,
       0,   789,   788,     0,     0,     0,     0,     0,     0,     0,
       0,   748,     0,     0,     0,     0,     0,   568,   748,   748,
     748,     0,   753,   753,   753,     0,   809,   811,     0,   810,
       0,     0,     0,     0,     0,     0,   723,   724,   725,   742,
       0,   742,     0,   742,     0,   742,   812,   748,     0,   748,
     796,   797,   798,   799,   807,   808,   266,     0,   584,   748,
     748,   748,   748,   450,   451,   449,     0,     0,   709,     0,
       0,   538,   523,   524,   522,   527,   528,   525,   526,   529,
     548,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   545,   501,   502,   500,     0,   509,   510,   508,   497,
     495,   498,   496,   494,   505,   506,   504,     0,     0,   519,
     520,   518,     0,   543,   542,   564,   565,   415,   748,   748,
       0,   733,   745,   745,   745,   753,   753,   416,   804,   748,
     782,     0,   756,   748,   748,   748,     0,   748,     0,   748,
     748,   748,     0,   762,   748,     0,     0,   748,   748,   426,
     427,   428,   748,   430,   431,   432,   753,     0,   754,   748,
       0,     0,     0,     0,   742,     0,   742,     0,   742,     0,
     742,     0,   802,   748,   647,     0,   405,   800,   801,   389,
     536,   532,   533,     0,   535,   534,   537,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   270,   515,
     514,   516,   540,   806,   563,   729,     0,   746,   747,     0,
       0,     0,   406,   390,   805,   748,   794,   707,   771,   748,
     773,   748,   774,   775,   764,   748,   763,   748,   748,   767,
     766,   425,   429,   745,   813,   748,   748,   748,   748,     0,
       0,     0,     0,     0,     0,     0,     0,   803,   264,   531,
     539,   530,   549,   550,   551,   552,   553,   554,   555,   556,
     557,   558,   270,   270,     0,   730,     0,     0,     0,   757,
     770,   772,   765,   769,   768,     0,   817,   814,   823,   820,
       0,   748,     0,   748,     0,   748,     0,   748,     0,     0,
     511,   750,   751,   752,     0,   748,   818,   748,   815,   748,
     824,   748,   821,   512,   513,   755,   819,   816,   825,   822
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1338, -1338, -1338,  1634, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
    1545, -1338, -1338,  1309, -1338,   -83,  1115, -1338,  -798, -1338,
    -319,  -825, -1338,  -338,  -337, -1338, -1338, -1338,  1571,  1147,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
      47,  -832,   801, -1338, -1338, -1338, -1338, -1338, -1338, -1338,
   -1338, -1338,  1679,  1690,  1759,  -104,  -403,  -383,  -556,  -381,
    -130, -1338,  1581,   877, -1338,  1588,   882, -1338, -1338,  1036,
   -1338, -1338,   150, -1338,  -288,  1038,  1252, -1338,  -764, -1338,
   -1338, -1338,  -755,  -603, -1338,   404,   565, -1338, -1338, -1338,
     558, -1338, -1338, -1338, -1338, -1338,   576, -1338, -1338, -1338,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,   425,   983,
   -1338, -1338,  1602,  -592, -1338, -1338, -1338, -1338,  1044,  1073,
    1037,  1126, -1338,  -377,  -257,  1822,  -534,  -446,  1830,  1708,
   -1338,  -322,  -350,  -139,  1369,  -299,  1838,  1846,  1854,  1862,
    1870, -1338,  1272, -1338, -1338, -1338,  1306, -1338, -1338,  1226,
   -1338, -1338, -1338, -1338, -1338, -1338, -1338, -1338,  -197, -1338,
   -1338, -1338, -1338,   990,   -15,   354,  -394,   910,  -295,  -483,
     438, -1143,  -102, -1239,  -911,  -807,  -416, -1337,   -63,  -620,
   -1338,  1275, -1338, -1338, -1338, -1338, -1338, -1338,   264,   160,
   -1338,  1563, -1338,  1040, -1338, -1338, -1338, -1338, -1338,  1078,
   -1338, -1338, -1338, -1338, -1338,  1047,  -434
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    11,    12,    13,    71,   130,    72,   159,    73,   179,
      74,   201,    75,   218,    76,   233,    77,   250,    78,   264,
      79,   281,    14,    15,    16,   295,    17,    18,    19,    20,
     325,   567,    21,    22,    23,    24,    25,    26,    27,   102,
     103,   339,   574,   342,    28,   519,   324,   556,  1069,  1357,
     520,   855,   881,   521,   522,    29,    30,    84,    85,   297,
     523,    31,    86,   313,   314,   315,   316,   317,   318,   716,
     869,   319,   320,   321,   322,   323,   713,   856,   857,   858,
     861,   862,   864,    32,    33,    34,    35,    36,    37,    38,
      39,    40,   131,   132,   133,   391,   589,   392,   591,   524,
     525,   528,   134,   905,  1084,   135,   901,  1071,   136,   761,
     913,   224,   826,   996,   600,   760,   601,  1085,   914,  1239,
    1365,  1087,   915,   916,  1265,  1266,  1257,  1394,  1267,  1406,
    1259,  1398,  1409,  1410,  1268,  1411,  1240,  1374,  1375,  1376,
    1377,  1378,  1379,  1487,  1413,  1269,  1414,  1255,  1256,   137,
     138,   139,   140,   917,   997,   998,   999,  1000,   642,   639,
     645,   592,   300,   918,   919,   141,  1074,   662,   142,   143,
     144,   375,   376,   107,   335,   336,   145,   146,   147,   148,
     149,   441,   442,   292,   150,   416,   417,   262,   490,   491,
     418,   492,   493,   494,   419,   495,   420,   421,   422,   423,
     636,   424,   425,   768,   455,   171,   611,   943,  1339,  1145,
    1282,   951,   952,  1285,   626,   627,   628,  1509,  1157,  1329,
     172,   654,   191,   192,   193,   194,   195,   196,   330,   173,
     174,   456,   175,   151,   152,   153,   263,   154,   155,   156,
     244,   245,   246,   247,   248,   830,   378
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     634,   577,   578,   312,   445,   612,   613,   614,   590,   617,
     618,   650,   665,  1284,   619,   620,   426,   427,   624,   429,
     576,   632,   582,   638,   641,   584,   644,  1031,  1032,  1038,
     852,   853,  -742,   747,   529,   530,   571,   531,  1562,  1563,
    1280,   468,   108,   590,   590,   109,   590,   545,   546,   547,
     104,   430,   496,   548,   549,    80,   550,   551,   659,   552,
     553,   663,    60,   651,   652,   966,  1232,   667,   668,   669,
     586,   672,   674,   117,   696,  1395,   104,    61,   686,   687,
     688,   992,   747,   692,   693,   747,  1510,  1511,   747,  1458,
      62,   298,    41,   397,    42,   694,    43,    44,   118,   697,
      63,    45,    46,   698,   545,   546,   547,  1082,   395,   593,
     548,   549,  1014,   550,   551,    47,   552,   553,  1261,   460,
     497,  1078,   649,   594,   702,   993,   630,    96,   460,   780,
     595,  1550,   597,   655,   470,    83,   306,  1283,  1505,    48,
      49,  1086,  1066,   331,   332,   333,   334,    50,  1551,    51,
    1088,  1016,   532,   533,   396,   625,  1082,  1457,    52,   670,
     994,  1407,   906,   907,  1408,   331,   332,   333,   334,   653,
     471,    99,   100,   498,    53,   625,    54,   472,   473,   474,
     475,   630,   446,   397,    81,  1284,    64,  1079,  1080,   908,
    1086,   431,   587,   909,   588,   587,  1575,   588,   554,  1088,
     910,   911,  1038,  1038,  1038,   776,   777,   778,   762,   945,
     946,   381,   382,   625,   593,  1262,  1263,   105,   781,   503,
     504,   770,   771,   436,   947,   457,   110,  1506,   594,   945,
     946,   948,   584,   197,   214,   651,   652,    65,   277,   800,
     801,   802,   789,   443,   947,   458,   306,    97,    98,  1264,
     397,   948,  1066,   625,   820,   554,   575,   743,   595,   106,
     597,   397,   745,    66,   637,  1214,   744,   835,   836,   837,
     397,   746,   398,   399,  1216,   843,   397,   821,    55,   824,
     400,   401,   571,   851,   402,   444,   403,   404,   405,   406,
     407,   461,   462,   496,   463,   841,   842,   653,    56,   584,
     408,   409,  1089,   570,    57,   751,   893,   854,   629,    67,
     910,   911,   469,  1090,   752,   854,    68,   534,   326,   327,
     328,   329,   995,   555,   397,   738,   796,  1591,  1592,  1593,
     410,    82,   586,   753,    69,   895,   896,   897,   898,   899,
     900,   464,   754,   437,   438,   920,   447,   448,   449,   450,
     467,  1089,   595,   596,   597,  1605,   476,   326,   327,   328,
     329,   411,  1090,   625,   412,  1280,   465,   466,   912,   955,
     956,  1093,   411,   640,   413,    58,   389,   390,    83,   414,
     865,   411,   965,   967,  1067,   413,   587,   971,   588,   973,
     974,   593,   976,   977,   413,   766,   415,   643,   949,   950,
     447,   448,   449,   450,   451,   157,   987,   767,    87,   786,
    1001,  1002,  1003,   598,   814,  1006,  1007,  1008,   949,   950,
    1093,   767,    88,  1284,  1284,  1284,   767,   599,   213,    89,
    1025,   637,   276,   452,  1029,   453,   657,   447,   448,   449,
     450,  1146,   389,   390,   740,   866,   584,   867,   413,    90,
     755,  1284,   657,    91,   587,   454,   588,    93,  1059,   756,
      94,   345,   593,   346,   347,   348,   349,   350,   351,   655,
     656,   326,   327,   328,   329,   389,   390,   120,   121,   816,
     326,   327,   328,   329,   868,  1075,  1076,  1077,   703,  1094,
     704,   767,    53,   122,  1067,   587,  1180,   588,  1182,   123,
    1335,   124,   125,   306,   818,  1142,  1039,    92,   352,   502,
      95,  1507,  1507,  1507,   353,  1040,   767,   354,  1140,   587,
     587,   588,   588,   822,  1072,   383,   384,  1154,  1091,  1366,
    1165,  1210,  1211,  1212,  1213,   767,   119,  1158,  1159,   945,
     946,  1162,   557,  1044,   558,   559,   560,   561,   562,   563,
     564,   565,   101,   587,   947,   588,  1173,   111,   846,  1176,
     112,   948,  1179,  1499,  1181,  1500,  1183,  1184,   113,  1186,
     767,   114,  1189,   115,  1192,  1193,  1072,  1091,   675,   676,
     677,   678,  1070,  1336,  1337,  1338,  1083,   906,   907,  1201,
     598,   116,   126,  1205,   355,   925,   127,  1209,   389,   390,
     892,   293,   356,  1367,   543,   544,  1368,   767,   120,   121,
    1220,   128,   294,   129,   908,  1508,  1508,  1508,   909,   927,
    1041,  1233,  1507,    53,   122,   910,   911,   985,   296,  1042,
     123,   767,   124,   125,  1070,  1083,   357,   337,   358,   767,
     359,  1369,   338,   360,  1073,   615,   616,  1370,  1092,   679,
     680,   681,   682,   503,   504,  1097,  1098,  1099,   964,   621,
     622,   629,   158,   341,  1340,  1276,   343,  1277,  1427,   326,
     327,   328,   329,  1564,   344,   361,   362,   377,   625,   379,
     363,   364,   178,   365,   660,   661,   958,   387,   366,   640,
     367,   368,   369,   370,   503,   504,  1073,  1092,   371,   372,
     373,   374,  1453,  1454,  1455,   689,   690,   505,   506,   507,
     508,   509,   510,   511,   512,   513,   514,   515,   516,   517,
     518,   583,  1253,   126,   380,   747,  1508,   127,   949,   950,
    1291,  1342,   393,   389,   390,   306,  1371,  1588,  1589,   643,
     929,   502,   128,   385,   129,   386,  1027,  1336,  1337,  1338,
     388,  1293,  1281,   394,   120,   121,   345,   432,   346,   347,
     348,   349,   350,   351,  1304,   428,  1306,   945,   946,    53,
     122,  1310,   590,   439,  1313,  1314,   123,   440,   124,   125,
     566,   499,   947,   389,   390,   684,   685,  1274,   500,   948,
     433,   434,   435,   912,  1331,  1332,  1333,  1334,   501,   573,
    1344,   805,   806,   352,   526,  1512,  1513,   808,   809,   353,
     527,   587,   354,   588,  1336,  1337,  1338,   535,  1068,   200,
     810,   811,  1081,   536,  1164,   537,   827,   828,   538,   831,
     832,   833,   539,  1151,  1152,  1153,  1532,  1422,  1423,  1424,
     326,   327,   328,   329,   541,  1155,  1336,  1337,  1338,  1381,
    1382,  1383,  1384,  1385,  1386,  1387,  1388,  1389,  1390,  1372,
    1372,   587,   540,   588,   542,   931,  1169,  1170,  1171,   126,
    1068,  1081,   568,   127,  1253,   569,  1392,  1392,  1396,  1396,
     812,   813,  1185,  1336,  1337,  1338,  1404,   572,   128,   355,
     129,   120,   121,   875,   876,  1163,   580,   356,   990,   877,
     878,  1363,  1364,  1034,  1035,  1036,    53,   122,  1206,  1207,
    1208,  1021,   585,   123,   602,   124,   125,   603,  1218,   623,
    1341,  1343,  1345,  1465,   625,  1467,   635,  1469,  1223,  1471,
     646,   357,   217,   358,   648,   359,  1049,  1050,   360,   505,
     506,   507,   508,   509,   510,   511,   512,   513,   514,   515,
     516,   517,   518,   902,   903,   664,   949,   950,  1226,  1227,
    1228,  1229,  1230,  1231,  1221,   326,   327,   328,   329,   666,
     361,   362,   683,  1254,  1483,   363,   364,   691,   365,   699,
    1005,   702,  1023,   366,  1009,   367,   368,   369,   370,  1051,
    1052,  1190,   700,   371,   372,   373,   374,   705,   326,   327,
     328,   329,  1053,  1054,   120,   121,   126,  1055,  1056,   707,
     127,   326,   327,   328,   329,   706,   739,  1057,  1058,    53,
     122,   447,   448,   449,   450,   128,   123,   129,   124,   125,
     503,   504,   923,   924,  1415,  1416,   930,   932,   708,  1272,
    1464,  1275,  1481,  1482,   709,  1466,   710,  1468,  1539,  1470,
    1541,   711,  1543,   655,  1545,   163,   183,   205,  1288,  1289,
     712,   268,  1484,  1485,  1292,  -339,  1294,   714,   972,   717,
    1296,   718,  1298,  1299,   719,  1301,  1302,   720,     1,   979,
     721,   981,   326,   327,   328,   329,  1311,   722,   723,   991,
    1278,   326,   327,   328,   329,   724,  1318,  1319,  1320,   725,
    1322,  1323,  1324,  1015,  1017,   726,  1295,   736,  1022,  1024,
    1373,  1373,   176,   198,   215,   727,   728,  1347,   278,   126,
    1349,   729,   730,   127,   232,  1254,   731,  1393,  1393,  1397,
    1397,   732,  1359,  1360,  1361,   733,  1362,  1405,   128,   734,
     129,   735,   737,  1326,  1327,   104,  1045,  1046,  1047,  1048,
     177,   199,   216,   741,   742,  1346,   279,   938,   939,   940,
     941,   942,   749,  1350,  1351,  1352,  1353,  1354,  1355,   750,
     757,  1418,   331,   332,   333,   334,   759,  1419,   782,   758,
     763,   764,   765,   779,  1425,  1426,   783,   788,  1429,   790,
    1148,   604,  1150,   792,   794,  1433,   120,   121,  1434,   798,
     799,  1435,   803,  1437,   804,  1439,  1440,  1441,   807,  1417,
    1444,    53,   122,  1447,  1448,   829,   249,   838,   123,  1452,
     124,   125,   839,  1456,   840,   848,  1428,   850,  1459,  1430,
    -341,  1432,     2,     3,     4,     5,     6,     7,     8,     9,
      10,   863,  -343,   891,  -345,   859,  1473,   860,  1443,   870,
     871,   872,   873,  1191,   874,  1449,  1450,  1451,   605,   606,
     607,   608,   609,   610,   879,   880,   882,   883,   884,   894,
     885,   345,   933,   346,   347,   348,   349,   350,   351,   934,
     886,   887,  1215,  1217,  1472,   888,  1474,   889,   120,   121,
     890,   904,   921,   922,   935,   936,  1476,  1477,  1478,  1479,
     937,   944,   957,    53,   122,   960,   968,   961,   969,   978,
     123,   126,   124,   125,   962,   127,   970,   982,   352,   983,
     980,   984,  1004,   988,   353,  1010,  1011,   354,  1012,  1515,
     128,  1018,   129,  1013,  1519,  1019,  1521,  1020,  1026,  1028,
    1525,  1030,   854,  1527,  1528,  1033,   345,  1043,   346,   347,
     348,   349,   350,   351,  1060,  1503,  1504,  1061,  1535,  1536,
    1537,  1538,  1062,   604,  1063,  1064,  1514,  1065,  1141,  1095,
    1516,  1517,  1518,  1138,  1520,  1096,  1522,  1523,  1524,  1139,
    1143,  1526,  1144,  1147,  1529,  1530,  1156,  1149,  1160,  1531,
     671,  1161,  1166,   352,  1167,  1168,  1534,  1172,  1174,   353,
    1175,  1177,   354,   126,   355,  1178,  1187,   127,  1188,  1194,
    1547,  1195,   356,   345,  1196,   346,   347,   348,   349,   350,
     351,  1197,   128,  1198,   129,  1199,  1200,  1202,  1203,  1204,
     605,   606,   607,   608,   609,   610,  1219,  1222,  1581,  1224,
    1583,  1225,  1585,  1234,  1587,  1235,   357,  1237,   358,  1236,
     359,  1238,  1569,   360,  1270,  1271,  1570,  1273,  1571,  1279,
     352,  1286,  1572,  1287,  1573,  1574,   353,  1290,  1297,   354,
    1300,  1303,  1576,  1577,  1578,  1579,  1305,  1307,  1595,   355,
    1597,  1308,  1599,  1309,  1601,   361,   362,   356,  1312,  1315,
     363,   364,  1316,   365,  1317,  1321,  1325,  1328,   366,  1330,
     367,   368,   369,   370,  1348,  1356,  1358,  1399,   371,   372,
     373,   374,  1380,  1400,  1401,  1420,  1402,  1431,  1596,  1436,
    1598,   357,  1600,   358,  1602,   359,  1438,   280,   360,  1412,
    1442,   797,  1606,  1445,  1607,  1446,  1608,  1460,  1609,  1461,
     505,   506,   507,   508,   509,   510,   355,   512,   513,   514,
     515,   516,   517,   518,   356,  1462,  1463,  1475,  1480,  1488,
     361,   362,  1489,  1490,  1486,   363,   364,  1498,   365,  1502,
    1533,  1540,  1542,   366,  1491,   367,   368,   369,   370,  1544,
    1546,  1492,  1493,   371,   372,   373,   374,  1494,   357,  1495,
     358,  1496,   359,  1497,  1548,   360,  1501,  1549,  1565,   120,
     121,  1566,  1552,  1567,   769,  1568,   963,   772,   773,   774,
     775,  1580,  1582,  1553,    53,   122,  1554,  1555,  1584,  1556,
    1586,   123,   787,   124,   125,  1242,  1557,   361,   362,  1558,
    1559,  1560,   363,   364,  1561,   365,   397,  1590,  1594,  1603,
     366,  1604,   367,   368,   369,   370,    70,   340,   701,   579,
     371,   372,   373,   374,   715,   299,   222,   815,   817,   819,
    1037,   954,   823,   223,   825,   953,   631,   785,   784,  1403,
     604,  1258,   477,  1260,   405,   406,   407,   478,  1241,   254,
    1391,   795,   844,   845,   847,   793,   479,   849,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   673,  1243,  1244,
    1245,  1246,  1247,  1248,  1249,  1250,  1251,  1252,   301,    59,
     302,   791,   581,   647,   126,   748,   695,   975,   127,  1421,
     303,   459,   633,   304,   305,   306,   658,   307,   308,   834,
       0,     0,     0,   128,     0,   129,     0,   605,   606,   607,
     608,   609,   610,     0,     0,   625,     0,     0,     0,     0,
     412,   160,   180,   202,   219,   234,   251,   265,   282,     0,
     926,   928,   161,   181,   203,   220,   235,   252,   266,   283,
     503,   504,     0,     0,     0,   309,     0,     0,     0,   959,
       0,   477,   489,   405,   406,   407,   478,   310,   311,     0,
     625,     0,     0,     0,     0,   479,     0,   480,   481,   482,
     483,   484,   485,   486,   487,   488,     0,     0,     0,     0,
       0,   986,   398,   399,   989,     0,     0,     0,     0,     0,
     400,   401,     0,     0,   402,     0,   403,   404,   405,   406,
     407,   162,   182,   204,   221,   236,   253,   267,   284,     0,
     408,   409,  1100,  1101,  1102,  1103,  1104,  1105,  1106,  1107,
    1108,  1109,  1110,  1111,  1112,  1113,  1114,  1115,  1116,  1117,
    1118,  1119,  1120,  1121,  1122,  1123,  1124,  1125,  1126,  1127,
    1128,  1129,  1130,  1131,  1132,  1133,  1134,  1135,  1136,  1137,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   164,   184,   206,   225,   237,   255,
     269,   285,   165,   185,   207,   226,   238,   256,   270,   286,
     166,   186,   208,   227,   239,   257,   271,   287,   167,   187,
     209,   228,   240,   258,   272,   288,   168,   188,   210,   229,
     241,   259,   273,   289,   169,   189,   211,   230,   242,   260,
     274,   290,   170,   190,   212,   231,   243,   261,   275,   291
};

static const yytype_int16 yycheck[] =
{
     416,   339,   339,    86,   143,   399,   400,   401,   391,   403,
     404,   445,   458,  1156,   408,   409,   120,   121,   412,   123,
     339,   415,   344,   426,   427,   375,   429,   852,   853,   861,
      22,    23,     5,   589,    21,    22,   335,    24,    22,    23,
      62,     6,    74,   426,   427,    77,   429,    26,    27,    28,
      92,   148,   249,    32,    33,    11,    35,    36,   452,    38,
      39,   455,   146,    22,    23,    58,    40,   461,   462,   463,
      95,   465,   466,    16,   490,    78,    92,   146,   472,   473,
     474,    16,   638,   477,   478,   641,  1423,  1424,   644,  1328,
     146,    95,     8,   148,    10,   489,    12,    13,    41,   493,
     146,    17,    18,   497,    26,    27,    28,   905,     6,    79,
      32,    33,    43,    35,    36,    31,    38,    39,    79,     6,
     175,    16,   444,    93,    98,    60,   414,    75,     6,    59,
     217,   289,   219,   256,     6,   139,    31,     3,    59,    55,
      56,   905,    37,   142,   143,   144,   145,    63,   306,    65,
     905,    43,   139,   140,    52,   148,   954,     3,    74,   282,
      95,   287,    57,    58,   290,   142,   143,   144,   145,   256,
      42,   212,   213,   228,    90,   148,    92,    49,    50,    51,
      52,   469,     6,   148,   140,  1328,   146,    82,    83,    84,
     954,   288,   217,    88,   219,   217,  1533,   219,   177,   954,
      95,    96,  1034,  1035,  1036,   621,   622,   623,   602,    75,
      76,   139,   140,   148,    79,   176,   177,   259,   148,   222,
     223,   615,   616,    75,    90,   259,   258,   148,    93,    75,
      76,    97,   582,    73,    74,    22,    23,   146,    78,   655,
     656,   657,   636,   259,    90,   279,    31,   195,   196,   210,
     148,    97,    37,   148,   670,   177,   339,   139,   217,   301,
     219,   148,   139,   146,    95,    43,   148,   683,   684,   685,
     148,   148,   170,   171,    43,   691,   148,   671,   194,   673,
     178,   179,   581,   699,   182,   301,   184,   185,   186,   187,
     188,   178,   179,   490,   181,   689,   690,   256,   214,   649,
     198,   199,   905,   302,   220,   139,   740,   299,   278,   146,
      95,    96,   277,   905,   148,   299,   146,   304,   249,   250,
     251,   252,   257,   302,   148,   302,   648,  1566,  1567,  1568,
     228,   148,    95,   139,     0,   751,   752,   753,   754,   755,
     756,   228,   148,   195,   196,   761,   224,   225,   226,   227,
     228,   954,   217,   218,   219,  1594,   228,   249,   250,   251,
     252,   259,   954,   148,   262,    62,   253,   254,   263,   785,
     786,   905,   259,    95,   272,   291,   139,   140,   139,   277,
     302,   259,   798,   799,   279,   272,   217,   803,   219,   805,
     806,    79,   808,   809,   272,   148,   294,    95,   264,   265,
     224,   225,   226,   227,   228,     3,   822,   160,    19,   148,
     826,   827,   828,   278,   148,   831,   832,   833,   264,   265,
     954,   160,   301,  1566,  1567,  1568,   160,   292,    74,   140,
     846,    95,    78,   257,   850,   259,   451,   224,   225,   226,
     227,   924,   139,   140,   583,   217,   796,   219,   272,   140,
     139,  1594,   467,   301,   217,   279,   219,   140,   892,   148,
     141,    42,    79,    44,    45,    46,    47,    48,    49,   256,
     257,   249,   250,   251,   252,   139,   140,    75,    76,   148,
     249,   250,   251,   252,   256,   901,   902,   903,   139,   905,
     141,   160,    90,    91,   279,   217,   979,   219,   981,    97,
     148,    99,   100,    31,   148,   921,   139,   148,    89,    37,
     301,  1422,  1423,  1424,    95,   148,   160,    98,   912,   217,
     217,   219,   219,   148,   901,   139,   140,   943,   905,    98,
     964,  1014,  1015,  1016,  1017,   160,     3,   953,   954,    75,
      76,   957,    64,   881,    66,    67,    68,    69,    70,    71,
      72,    73,   285,   217,    90,   219,   972,    77,   148,   975,
      77,    97,   978,   139,   980,   141,   982,   983,    77,   985,
     160,    16,   988,    77,   990,   991,   953,   954,   266,   267,
     268,   269,   901,   231,   232,   233,   905,    57,    58,  1005,
     278,    77,   190,  1009,   175,   148,   194,  1013,   139,   140,
     739,     9,   183,   172,    29,    30,   175,   160,    75,    76,
    1026,   209,    75,   211,    84,  1422,  1423,  1424,    88,   148,
     139,  1067,  1533,    90,    91,    95,    96,   148,    81,   148,
      97,   160,    99,   100,   953,   954,   217,   140,   219,   160,
     221,   210,   148,   224,   901,   178,   179,   216,   905,   266,
     267,   268,   269,   222,   223,    85,    86,    87,   797,   280,
     281,   278,   260,   283,   148,  1148,   301,  1150,  1288,   249,
     250,   251,   252,  1498,   301,   256,   257,    61,   148,   140,
     261,   262,     3,   264,   299,   300,   788,   139,   269,    95,
     271,   272,   273,   274,   222,   223,   953,   954,   279,   280,
     281,   282,  1322,  1323,  1324,    50,    51,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   302,  1103,   190,   140,  1281,  1533,   194,   264,   265,
    1164,   148,   139,   139,   140,    31,   305,  1562,  1563,    95,
     149,    37,   209,   140,   211,   140,   848,   231,   232,   233,
     140,  1167,  1155,   139,    75,    76,    42,   288,    44,    45,
      46,    47,    48,    49,  1180,   141,  1182,    75,    76,    90,
      91,  1187,  1155,   147,  1190,  1191,    97,   146,    99,   100,
     302,   139,    90,   139,   140,    53,    54,    95,    25,    97,
     191,   192,   193,   263,  1210,  1211,  1212,  1213,   148,    95,
     148,   139,   140,    89,   148,  1425,  1426,   139,   140,    95,
      80,   217,    98,   219,   231,   232,   233,   139,   901,     3,
     139,   140,   905,   140,   963,    94,   676,   677,    94,   679,
     680,   681,   301,   935,   936,   937,  1456,   275,   276,   277,
     249,   250,   251,   252,   148,   949,   231,   232,   233,  1243,
    1244,  1245,  1246,  1247,  1248,  1249,  1250,  1251,  1252,  1240,
    1241,   217,   140,   219,   140,   149,   968,   969,   970,   190,
     953,   954,   286,   194,  1255,   286,  1257,  1258,  1259,  1260,
     139,   140,   984,   231,   232,   233,  1267,   213,   209,   175,
     211,    75,    76,    14,    15,   958,   284,   183,   149,    29,
      30,  1239,  1239,   856,   857,   858,    90,    91,  1010,  1011,
    1012,   149,   148,    97,   294,    99,   100,    97,  1020,   272,
    1215,  1216,  1217,  1339,   148,  1341,   197,  1343,  1030,  1345,
      59,   217,     3,   219,   301,   221,   229,   230,   224,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   139,   140,   258,   264,   265,  1060,  1061,
    1062,  1063,  1064,  1065,  1027,   249,   250,   251,   252,   258,
     256,   257,    42,  1103,  1368,   261,   262,    42,   264,   175,
     830,    98,   149,   269,   834,   271,   272,   273,   274,   229,
     230,   149,   148,   279,   280,   281,   282,   139,   249,   250,
     251,   252,   229,   230,    75,    76,   190,   229,   230,   230,
     194,   249,   250,   251,   252,   139,   302,   229,   230,    90,
      91,   224,   225,   226,   227,   209,    97,   211,    99,   100,
     222,   223,   768,   769,   229,   230,   772,   773,   139,  1141,
    1335,  1143,   173,   174,   140,  1340,   140,  1342,  1464,  1344,
    1466,   140,  1468,   256,  1470,    72,    73,    74,  1160,  1161,
     303,    78,   139,   140,  1166,   139,  1168,   139,   804,   303,
    1172,   303,  1174,  1175,   303,  1177,  1178,   303,     7,   815,
     303,   817,   249,   250,   251,   252,  1188,   303,   303,   825,
    1153,   249,   250,   251,   252,   303,  1198,  1199,  1200,   303,
    1202,  1203,  1204,   839,   840,   303,  1169,   148,   844,   845,
    1240,  1241,    72,    73,    74,   303,   303,  1219,    78,   190,
    1222,   303,   303,   194,     3,  1255,   303,  1257,  1258,  1259,
    1260,   303,  1234,  1235,  1236,   303,  1238,  1267,   209,   303,
     211,   303,   148,  1206,  1207,    92,   882,   883,   884,   885,
      72,    73,    74,    59,   148,  1218,    78,   230,   231,   232,
     233,   234,   139,  1226,  1227,  1228,  1229,  1230,  1231,   140,
     285,  1273,   142,   143,   144,   145,    81,  1279,     5,   293,
     148,   148,   148,   148,  1286,  1287,   285,     5,  1290,   148,
     926,   228,   928,   148,   148,  1297,    75,    76,  1300,   148,
      98,  1303,    98,  1305,   148,  1307,  1308,  1309,   148,  1272,
    1312,    90,    91,  1315,  1316,    84,     3,   148,    97,  1321,
      99,   100,   148,  1325,   148,     5,  1289,   148,  1330,  1292,
     139,  1294,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    20,   139,   230,   139,   139,  1348,   139,  1311,   140,
     140,   140,   139,   989,   140,  1318,  1319,  1320,   295,   296,
     297,   298,   299,   300,   140,   140,   148,   148,   148,   230,
     148,    42,   149,    44,    45,    46,    47,    48,    49,   149,
     148,   148,  1018,  1019,  1347,   148,  1349,   148,    75,    76,
     148,   148,   148,    59,     5,     5,  1359,  1360,  1361,  1362,
       5,    59,   149,    90,    91,   230,     5,   230,     5,   180,
      97,   190,    99,   100,   230,   194,     5,   229,    89,   230,
     180,     5,   270,   149,    95,     5,     5,    98,     5,  1431,
     209,   148,   211,   149,  1436,   148,  1438,     5,   149,   149,
    1442,     5,   299,  1445,  1446,   139,    42,   148,    44,    45,
      46,    47,    48,    49,     5,  1418,  1419,     5,  1460,  1461,
    1462,  1463,     5,   228,     5,     5,  1429,     5,     5,   139,
    1433,  1434,  1435,   148,  1437,   139,  1439,  1440,  1441,   148,
       5,  1444,   230,   180,  1447,  1448,     4,   180,     5,  1452,
     255,     5,     5,    89,   139,     5,  1459,     5,     5,    95,
       5,     5,    98,   190,   175,     5,   149,   194,     5,   139,
    1473,   148,   183,    42,   148,    44,    45,    46,    47,    48,
      49,   148,   209,     5,   211,     5,     5,     5,     5,     5,
     295,   296,   297,   298,   299,   300,     5,     5,  1540,   139,
    1542,   139,  1544,     5,  1546,     5,   217,   139,   219,     5,
     221,     5,  1515,   224,   230,   148,  1519,     5,  1521,     5,
      89,     5,  1525,     5,  1527,  1528,    95,     5,     5,    98,
       5,     5,  1535,  1536,  1537,  1538,     5,     5,  1580,   175,
    1582,     5,  1584,     5,  1586,   256,   257,   183,     5,     5,
     261,   262,     5,   264,   230,     5,     5,     4,   269,     5,
     271,   272,   273,   274,     5,   295,   139,   139,   279,   280,
     281,   282,   140,   139,   148,    99,   140,     5,  1581,     5,
    1583,   217,  1585,   219,  1587,   221,     5,     3,   224,   215,
       5,   302,  1595,     5,  1597,     5,  1599,     5,  1601,     5,
     235,   236,   237,   238,   239,   240,   175,   242,   243,   244,
     245,   246,   247,   248,   183,     5,     5,   148,   139,   148,
     256,   257,   148,   148,   139,   261,   262,    98,   264,   139,
       6,     5,     5,   269,   148,   271,   272,   273,   274,     5,
       5,   148,   148,   279,   280,   281,   282,   148,   217,   148,
     219,   148,   221,   148,   233,   224,   148,   148,    59,    75,
      76,     5,   149,     5,   614,     5,   302,   617,   618,   619,
     620,     5,     5,   149,    90,    91,   149,   149,     5,   149,
       5,    97,   632,    99,   100,    77,   149,   256,   257,   149,
     149,   149,   261,   262,   149,   264,   148,   139,     5,   139,
     269,   139,   271,   272,   273,   274,    12,   102,   501,   340,
     279,   280,   281,   282,   539,    84,    75,   667,   668,   669,
     859,   784,   672,    75,   674,   783,   414,   631,   630,  1265,
     228,  1106,   184,  1115,   186,   187,   188,   189,  1102,    77,
    1255,   644,   692,   693,   694,   641,   198,   697,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   255,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,    14,     1,
      16,   638,   343,   441,   190,   589,   490,   807,   194,  1281,
      26,   158,   416,    29,    30,    31,   451,    33,    34,   682,
      -1,    -1,    -1,   209,    -1,   211,    -1,   295,   296,   297,
     298,   299,   300,    -1,    -1,   148,    -1,    -1,    -1,    -1,
     262,    72,    73,    74,    75,    76,    77,    78,    79,    -1,
     770,   771,    72,    73,    74,    75,    76,    77,    78,    79,
     222,   223,    -1,    -1,    -1,    81,    -1,    -1,    -1,   789,
      -1,   184,   294,   186,   187,   188,   189,    93,    94,    -1,
     148,    -1,    -1,    -1,    -1,   198,    -1,   200,   201,   202,
     203,   204,   205,   206,   207,   208,    -1,    -1,    -1,    -1,
      -1,   821,   170,   171,   824,    -1,    -1,    -1,    -1,    -1,
     178,   179,    -1,    -1,   182,    -1,   184,   185,   186,   187,
     188,    72,    73,    74,    75,    76,    77,    78,    79,    -1,
     198,   199,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    72,    73,    74,    75,    76,    77,
      78,    79,    72,    73,    74,    75,    76,    77,    78,    79,
      72,    73,    74,    75,    76,    77,    78,    79,    72,    73,
      74,    75,    76,    77,    78,    79,    72,    73,    74,    75,
      76,    77,    78,    79,    72,    73,    74,    75,    76,    77,
      78,    79,    72,    73,    74,    75,    76,    77,    78,    79
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,     7,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   308,   309,   310,   329,   330,   331,   333,   334,   335,
     336,   339,   340,   341,   342,   343,   344,   345,   351,   362,
     363,   368,   390,   391,   392,   393,   394,   395,   396,   397,
     398,     8,    10,    12,    13,    17,    18,    31,    55,    56,
      63,    65,    74,    90,    92,   194,   214,   220,   291,   476,
     146,   146,   146,   146,   146,   146,   146,   146,   146,     0,
     310,   311,   313,   315,   317,   319,   321,   323,   325,   327,
      11,   140,   148,   139,   364,   365,   369,    19,   301,   140,
     140,   301,   148,   140,   141,   301,    75,   195,   196,   212,
     213,   285,   346,   347,    92,   259,   301,   480,    74,    77,
     258,    77,    77,    77,    16,    77,    77,    16,    41,     3,
      75,    76,    91,    97,    99,   100,   190,   194,   209,   211,
     312,   399,   400,   401,   409,   412,   415,   456,   457,   458,
     459,   472,   475,   476,   477,   483,   484,   485,   486,   487,
     491,   540,   541,   542,   544,   545,   546,     3,   260,   314,
     399,   400,   401,   456,   472,   475,   483,   484,   485,   486,
     487,   512,   527,   536,   537,   539,   540,   546,     3,   316,
     399,   400,   401,   456,   472,   475,   483,   484,   485,   486,
     487,   529,   530,   531,   532,   533,   534,   536,   540,   546,
       3,   318,   399,   400,   401,   456,   472,   475,   483,   484,
     485,   486,   487,   512,   536,   540,   546,     3,   320,   399,
     400,   401,   409,   412,   418,   472,   475,   483,   484,   485,
     486,   487,     3,   322,   399,   400,   401,   472,   475,   483,
     484,   485,   486,   487,   547,   548,   549,   550,   551,     3,
     324,   399,   400,   401,   459,   472,   475,   483,   484,   485,
     486,   487,   494,   543,   326,   399,   400,   401,   456,   472,
     475,   483,   484,   485,   486,   487,   512,   536,   540,   546,
       3,   328,   399,   400,   401,   472,   475,   483,   484,   485,
     486,   487,   490,     9,    75,   332,    81,   366,    95,   365,
     469,    14,    16,    26,    29,    30,    31,    33,    34,    81,
      93,    94,   352,   370,   371,   372,   373,   374,   375,   378,
     379,   380,   381,   382,   353,   337,   249,   250,   251,   252,
     535,   142,   143,   144,   145,   481,   482,   140,   148,   348,
     347,   283,   350,   301,   301,    42,    44,    45,    46,    47,
      48,    49,    89,    95,    98,   175,   183,   217,   219,   221,
     224,   256,   257,   261,   262,   264,   269,   271,   272,   273,
     274,   279,   280,   281,   282,   478,   479,    61,   553,   140,
     140,   139,   140,   139,   140,   140,   140,   139,   140,   139,
     140,   402,   404,   139,   139,     6,    52,   148,   170,   171,
     178,   179,   182,   184,   185,   186,   187,   188,   198,   199,
     228,   259,   262,   272,   277,   294,   492,   493,   497,   501,
     503,   504,   505,   506,   508,   509,   402,   402,   141,   402,
     148,   288,   288,   191,   192,   193,    75,   195,   196,   147,
     146,   488,   489,   259,   301,   480,     6,   224,   225,   226,
     227,   228,   257,   259,   279,   511,   538,   259,   279,   538,
       6,   178,   179,   181,   228,   253,   254,   228,     6,   277,
       6,    42,    49,    50,    51,    52,   228,   184,   189,   198,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   294,
     495,   496,   498,   499,   500,   502,   505,   175,   228,   139,
      25,   148,    37,   222,   223,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   352,
     357,   360,   361,   367,   406,   407,   148,    80,   408,    21,
      22,    24,   139,   140,   304,   139,   140,    94,    94,   301,
     140,   148,   140,    29,    30,    26,    27,    28,    32,    33,
      35,    36,    38,    39,   177,   302,   354,    64,    66,    67,
      68,    69,    70,    71,    72,    73,   302,   338,   286,   286,
     302,   482,   213,    95,   349,   352,   357,   360,   361,   350,
     284,   481,   478,   302,   479,   148,    95,   217,   219,   403,
     404,   405,   468,    79,    93,   217,   218,   219,   278,   292,
     421,   423,   294,    97,   228,   295,   296,   297,   298,   299,
     300,   513,   513,   513,   513,   178,   179,   513,   513,   513,
     513,   280,   281,   272,   513,   148,   521,   522,   523,   278,
     421,   423,   513,   493,   523,   197,   507,    95,   403,   466,
      95,   403,   465,    95,   403,   467,    59,   489,   301,   478,
     553,    22,    23,   256,   528,   256,   257,   511,   528,   513,
     299,   300,   474,   513,   258,   474,   258,   513,   513,   513,
     282,   255,   513,   255,   513,   266,   267,   268,   269,   266,
     267,   268,   269,    42,    53,    54,   513,   513,   513,    50,
      51,    42,   513,   513,   513,   496,   523,   513,   513,   175,
     148,   366,    98,   139,   141,   139,   139,   230,   139,   140,
     140,   140,   303,   383,   139,   353,   376,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   303,   148,   148,   302,   302,
     480,    59,   148,   139,   148,   139,   148,   405,   468,   139,
     140,   139,   148,   139,   148,   139,   148,   285,   293,    81,
     422,   416,   513,   148,   148,   148,   148,   160,   510,   510,
     513,   513,   510,   510,   510,   510,   523,   523,   523,   148,
      59,   148,     5,   285,   422,   416,   148,   510,     5,   513,
     148,   466,   148,   465,   148,   467,   478,   302,   148,    98,
     523,   523,   523,    98,   148,   139,   140,   148,   139,   140,
     139,   140,   139,   140,   148,   510,   148,   510,   148,   510,
     523,   513,   148,   510,   513,   510,   419,   419,   419,    84,
     552,   419,   419,   419,   552,   523,   523,   523,   148,   148,
     148,   513,   513,   523,   510,   510,   148,   510,     5,   510,
     148,   523,    22,    23,   299,   358,   384,   385,   386,   139,
     139,   387,   388,    20,   389,   302,   217,   219,   256,   377,
     140,   140,   140,   139,   140,    14,    15,    29,    30,   140,
     140,   359,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   230,   480,   553,   230,   523,   523,   523,   523,   523,
     523,   413,   139,   140,   148,   410,    57,    58,    84,    88,
      95,    96,   263,   417,   425,   429,   430,   460,   470,   471,
     523,   148,    59,   535,   535,   148,   510,   148,   510,   149,
     535,   149,   535,   149,   149,     5,     5,     5,   230,   231,
     232,   233,   234,   514,    59,    75,    76,    90,    97,   264,
     265,   518,   519,   413,   410,   523,   523,   149,   519,   510,
     230,   230,   230,   302,   480,   523,    58,   523,     5,     5,
       5,   523,   535,   523,   523,   514,   523,   523,   180,   535,
     180,   535,   229,   230,     5,   148,   510,   523,   149,   510,
     149,   535,    16,    60,    95,   257,   420,   461,   462,   463,
     464,   523,   523,   523,   270,   419,   523,   523,   523,   419,
       5,     5,     5,   149,    43,   535,    43,   535,   148,   148,
       5,   149,   535,   149,   535,   523,   149,   519,   149,   523,
       5,   358,   358,   139,   387,   387,   387,   389,   388,   139,
     148,   139,   148,   148,   360,   535,   535,   535,   535,   229,
     230,   229,   230,   229,   230,   229,   230,   229,   230,   553,
       5,     5,     5,     5,     5,     5,    37,   279,   352,   355,
     357,   414,   470,   471,   473,   523,   523,   523,    16,    82,
      83,   352,   355,   357,   411,   424,   425,   428,   429,   430,
     460,   470,   471,   473,   523,   139,   139,    85,    86,    87,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   148,   148,
     513,     5,   523,     5,   230,   516,   516,   180,   535,   180,
     535,   519,   519,   519,   523,   402,     4,   525,   523,   523,
       5,     5,   523,   525,   480,   553,     5,   139,     5,   519,
     519,   519,     5,   523,     5,     5,   523,     5,     5,   523,
     516,   523,   516,   523,   523,   519,   523,   149,     5,   523,
     149,   535,   523,   523,   139,   148,   148,   148,     5,     5,
       5,   523,     5,     5,     5,   523,   519,   519,   519,   523,
     516,   516,   516,   516,    43,   535,    43,   535,   519,     5,
     523,   525,     5,   519,   139,   139,   519,   519,   519,   519,
     519,   519,    40,   474,     5,     5,     5,   139,     5,   426,
     443,   443,    77,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   406,   407,   454,   455,   433,   433,   437,
     437,    79,   176,   177,   210,   431,   432,   435,   441,   452,
     230,   148,   519,     5,    95,   519,   516,   516,   525,     5,
      62,   403,   517,     3,   518,   520,     5,     5,   519,   519,
       5,   553,   519,   523,   519,   525,   519,     5,   519,   519,
       5,   519,   519,     5,   523,     5,   523,     5,     5,     5,
     523,   519,     5,   523,   523,     5,     5,   230,   519,   519,
     519,     5,   519,   519,   519,     5,   525,   525,     4,   526,
       5,   523,   523,   523,   523,   148,   231,   232,   233,   515,
     148,   515,   148,   515,   148,   515,   525,   519,     5,   519,
     525,   525,   525,   525,   525,   525,   295,   356,   139,   519,
     519,   519,   519,   360,   361,   427,    98,   172,   175,   210,
     216,   305,   406,   407,   444,   445,   446,   447,   448,   449,
     140,   513,   513,   513,   513,   513,   513,   513,   513,   513,
     513,   455,   406,   407,   434,    78,   406,   407,   438,   139,
     139,   148,   140,   432,   406,   407,   436,   287,   290,   439,
     440,   442,   215,   451,   453,   229,   230,   525,   519,   519,
      99,   517,   275,   276,   277,   519,   519,   526,   525,   519,
     525,     5,   525,   519,   519,   519,     5,   519,     5,   519,
     519,   519,     5,   525,   519,     5,     5,   519,   519,   525,
     525,   525,   519,   526,   526,   526,   519,     3,   520,   519,
       5,     5,     5,     5,   515,   523,   515,   523,   515,   523,
     515,   523,   525,   519,   525,   148,   525,   525,   525,   525,
     139,   173,   174,   513,   139,   140,   139,   450,   148,   148,
     148,   148,   148,   148,   148,   148,   148,   148,    98,   139,
     141,   148,   139,   525,   525,    59,   148,   521,   522,   524,
     524,   524,   526,   526,   525,   519,   525,   525,   525,   519,
     525,   519,   525,   525,   525,   519,   525,   519,   519,   525,
     525,   525,   526,     6,   525,   519,   519,   519,   519,   523,
       5,   523,     5,   523,     5,   523,     5,   525,   233,   148,
     289,   306,   149,   149,   149,   149,   149,   149,   149,   149,
     149,   149,    22,    23,   358,    59,     5,     5,     5,   525,
     525,   525,   525,   525,   525,   524,   525,   525,   525,   525,
       5,   519,     5,   519,     5,   519,     5,   519,   358,   358,
     139,   520,   520,   520,     5,   519,   525,   519,   525,   519,
     525,   519,   525,   139,   139,   520,   525,   525,   525,   525
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   307,   308,   308,   309,   309,   310,   310,   310,   310,
     310,   310,   310,   310,   310,   310,   310,   310,   310,   310,
     310,   310,   310,   310,   310,   310,   310,   310,   310,   310,
     310,   310,   310,   311,   311,   312,   312,   312,   312,   312,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   312,
     312,   312,   312,   312,   312,   312,   312,   312,   312,   313,
     313,   314,   314,   314,   314,   314,   314,   314,   314,   314,
     314,   314,   314,   314,   314,   314,   314,   314,   314,   315,
     315,   316,   316,   316,   316,   316,   316,   316,   316,   316,
     316,   316,   316,   316,   316,   316,   316,   316,   316,   316,
     316,   317,   317,   318,   318,   318,   318,   318,   318,   318,
     318,   318,   318,   318,   318,   318,   318,   318,   319,   319,
     320,   320,   320,   320,   320,   320,   320,   320,   320,   320,
     320,   320,   320,   321,   321,   322,   322,   322,   322,   322,
     322,   322,   322,   322,   322,   322,   322,   322,   322,   322,
     323,   323,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   324,   324,   324,   325,   325,   326,   326,   326,
     326,   326,   326,   326,   326,   326,   326,   326,   326,   326,
     326,   326,   327,   327,   328,   328,   328,   328,   328,   328,
     328,   328,   328,   328,   328,   329,   329,   329,   330,   331,
     332,   332,   333,   334,   334,   334,   335,   336,   337,   337,
     338,   338,   338,   338,   338,   338,   338,   338,   338,   338,
     338,   338,   338,   338,   339,   340,   340,   340,   341,   341,
     341,   342,   343,   344,   345,   346,   346,   347,   348,   348,
     349,   349,   349,   349,   349,   350,   350,   351,   352,   352,
     353,   353,   354,   354,   354,   354,   354,   354,   354,   354,
     354,   354,   354,   354,   355,   356,   356,   357,   357,   357,
     358,   358,   359,   359,   360,   360,   360,   360,   360,   360,
     360,   360,   360,   360,   360,   360,   360,   361,   362,   363,
     364,   364,   365,   365,   366,   366,   367,   367,   367,   367,
     367,   367,   368,   369,   369,   370,   370,   370,   370,   370,
     370,   370,   370,   370,   371,   372,   373,   374,   375,   376,
     376,   377,   377,   377,   377,   377,   378,   378,   379,   379,
     380,   380,   381,   382,   382,   382,   382,   382,   382,   383,
     382,   384,   382,   385,   382,   386,   382,   382,   387,   387,
     388,   389,   389,   390,   390,   390,   390,   391,   392,   392,
     393,   394,   395,   395,   396,   397,   398,   398,   399,   399,
     400,   400,   401,   401,   402,   402,   403,   403,   404,   404,
     405,   405,   405,   405,   406,   406,   407,   408,   408,   409,
     409,   410,   410,   411,   411,   411,   411,   411,   411,   411,
     411,   411,   411,   411,   411,   412,   412,   413,   413,   414,
     414,   414,   414,   414,   414,   415,   415,   416,   416,   417,
     417,   417,   417,   417,   417,   418,   418,   418,   418,   418,
     418,   418,   418,   419,   419,   420,   420,   420,   420,   421,
     421,   422,   423,   424,   424,   425,   425,   425,   426,   426,
     427,   427,   428,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   429,   429,   429,   429,   429,   429,   429,   429,   429,
     429,   430,   430,   431,   431,   432,   432,   432,   432,   433,
     433,   434,   434,   435,   435,   436,   436,   437,   437,   438,
     438,   438,   438,   438,   439,   439,   440,   441,   441,   442,
     442,   443,   443,   444,   444,   444,   444,   444,   444,   444,
     444,   445,   446,   446,   447,   447,   448,   449,   450,   450,
     451,   452,   452,   453,   454,   454,   455,   455,   455,   455,
     455,   455,   455,   455,   455,   455,   455,   455,   455,   456,
     456,   457,   458,   459,   460,   460,   461,   462,   463,   464,
     465,   465,   466,   466,   467,   467,   468,   468,   469,   469,
     470,   471,   472,   472,   473,   474,   474,   475,   475,   475,
     475,   476,   477,   478,   478,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   479,   479,   479,   479,   479,
     479,   479,   479,   479,   479,   480,   480,   481,   481,   482,
     482,   482,   482,   483,   483,   483,   484,   484,   484,   485,
     485,   485,   486,   487,   488,   488,   489,   490,   490,   491,
     492,   492,   493,   493,   493,   493,   493,   493,   493,   494,
     495,   495,   496,   496,   496,   496,   497,   497,   498,   499,
     499,   499,   499,   499,   499,   499,   499,   499,   499,   500,
     500,   501,   501,   501,   501,   502,   502,   503,   504,   505,
     506,   506,   506,   507,   507,   508,   508,   508,   509,   509,
     509,   510,   510,   511,   511,   511,   511,   512,   512,   513,
     513,   513,   513,   513,   513,   513,   513,   514,   514,   514,
     514,   514,   514,   515,   515,   515,   516,   516,   517,   517,
     517,   518,   518,   518,   518,   518,   518,   518,   519,   520,
     521,   522,   523,   523,   523,   524,   524,   524,   525,   525,
     525,   525,   525,   526,   526,   526,   527,   527,   527,   528,
     528,   528,   529,   529,   529,   529,   530,   530,   530,   530,
     531,   531,   532,   532,   533,   533,   534,   535,   535,   535,
     535,   535,   536,   536,   537,   537,   537,   537,   537,   537,
     537,   537,   538,   538,   539,   539,   540,   540,   541,   541,
     542,   542,   543,   543,   544,   544,   545,   546,   546,   547,
     547,   547,   548,   549,   550,   550,   550,   550,   550,   550,
     551,   551,   551,   551,   551,   551,   552,   553,   553,   553
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     4,     7,     8,     4,     3,
       0,     3,     2,     3,     3,     3,     4,     5,     0,     2,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     2,     3,     3,     5,     4,     6,
       4,     3,     3,     3,     3,     2,     3,     2,     0,     2,
       3,     1,     1,     1,     1,     0,     2,     5,     1,     4,
       0,     2,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     5,     0,     1,     4,     5,     5,
       0,     1,     0,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     5,     5,
       1,     2,     2,     4,     0,     2,     1,     1,     1,     1,
       1,     1,     3,     0,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     2,     1,     2,     3,     0,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       1,     1,     2,     5,     4,     2,     3,     3,     3,     0,
       4,     0,     5,     0,     5,     0,     5,     2,     1,     2,
       1,     0,     1,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     2,     4,     5,     6,     3,     4,
       3,     4,     3,     4,     1,     2,     1,     2,     1,     1,
       2,     2,     2,     2,     2,     2,     2,     0,     2,     9,
       9,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     9,     9,     0,     2,     1,
       1,     1,     1,     1,     1,     8,     8,     0,     2,     1,
       1,     1,     1,     1,     1,     9,     8,     8,     8,     9,
       8,     8,     8,     0,     2,     1,     1,     1,     1,     0,
       2,     2,     2,     1,     1,     2,     3,     2,     0,     2,
       1,     1,     2,     3,     2,     2,     2,     2,     2,     3,
       3,     2,     2,     2,     2,     2,     2,     3,     3,     3,
       3,     2,     2,     2,     2,     2,     2,     3,     3,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     2,
       3,     2,     2,     1,     2,     2,     2,     2,     2,     0,
       2,     1,     1,     0,     2,     1,     1,     0,     2,     1,
       1,     4,     5,     5,     2,     2,     2,     0,     2,     1,
       1,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     2,     2,     2,     2,     2,     2,     0,     2,
       2,     0,     2,     1,     1,     2,     1,     1,     2,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     7,
       6,     6,     6,     9,     4,     4,     2,     2,     3,     2,
       0,     3,     0,     3,     0,     3,     0,     3,     0,     3,
       3,     2,     7,     7,     3,     1,     1,     3,     6,     7,
       1,     2,     2,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     4,     1,     2,     2,
       2,     1,     1,     3,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     1,     2,     1,     8,     6,     6,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     6,
       1,     2,     1,     1,     1,     1,     4,     4,     4,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     4,
       4,     4,     4,     4,     4,     4,     4,     3,     3,     4,
       1,     1,     1,     0,     1,     5,     6,     5,     5,     6,
       5,     1,     1,     1,     1,     1,     1,     9,     6,     0,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     1,     0,     3,
       4,     1,     3,     4,     1,     1,     1,     1,     1,     1,
       2,     3,     0,     1,     1,     0,     1,     1,     0,     2,
       6,     6,     6,     0,     2,     6,     8,    10,     7,     0,
       1,     1,     8,     9,     9,    10,     9,     9,    10,    10,
      10,     9,    10,     9,     9,     9,     6,     0,     1,     1,
       1,     1,     8,     7,     7,     7,     4,     4,     7,     7,
       4,     4,     0,     1,     9,     6,     8,     8,     8,     8,
       9,     9,     8,     9,     8,     9,     9,     8,     8,     7,
       7,     7,     7,     9,    10,    11,    12,    10,    11,    12,
      10,    11,    12,    10,    11,    12,     2,     0,     2,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyo, yytype, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[+yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[+*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 195:
#line 613 "src/p.y"
                                                    {
                        mailset.events = Event_All;
                        addmail((yyvsp[-2].string), &mailset, &Run.maillist);
                  }
#line 3513 "src/y.tab.c"
    break;

  case 196:
#line 617 "src/p.y"
                                                                            {
                        addmail((yyvsp[-5].string), &mailset, &Run.maillist);
                  }
#line 3521 "src/y.tab.c"
    break;

  case 197:
#line 620 "src/p.y"
                                                                                {
                        mailset.events = ~mailset.events;
                        addmail((yyvsp[-6].string), &mailset, &Run.maillist);
                  }
#line 3530 "src/y.tab.c"
    break;

  case 198:
#line 626 "src/p.y"
                                               {
                        if (! (Run.flags & Run_Daemon) || ihp.daemon) {
                                ihp.daemon     = true;
                                Run.flags      |= Run_Daemon;
                                Run.polltime   = (yyvsp[-1].number);
                                Run.startdelay = (yyvsp[0].number);
                        }
                  }
#line 3543 "src/y.tab.c"
    break;

  case 199:
#line 636 "src/p.y"
                                     {
                        Run.flags |= Run_Batch;
                  }
#line 3551 "src/y.tab.c"
    break;

  case 200:
#line 641 "src/p.y"
                              {
                        (yyval.number) = 0;
                  }
#line 3559 "src/y.tab.c"
    break;

  case 201:
#line 644 "src/p.y"
                                     {
                        (yyval.number) = (yyvsp[0].number);
                  }
#line 3567 "src/y.tab.c"
    break;

  case 202:
#line 649 "src/p.y"
                           {
                        Run.flags |= Run_Foreground;
                  }
#line 3575 "src/y.tab.c"
    break;

  case 203:
#line 654 "src/p.y"
                                     {
                        Run.onreboot = Onreboot_Start;
                  }
#line 3583 "src/y.tab.c"
    break;

  case 204:
#line 657 "src/p.y"
                                       {
                        Run.onreboot = Onreboot_Nostart;
                  }
#line 3591 "src/y.tab.c"
    break;

  case 205:
#line 660 "src/p.y"
                                         {
                        Run.onreboot = Onreboot_Laststate;
                  }
#line 3599 "src/y.tab.c"
    break;

  case 206:
#line 665 "src/p.y"
                                               {
                        // Note: deprecated (replaced by "set limits" statement's "sendExpectBuffer" option)
                        Run.limits.sendExpectBuffer = (yyvsp[-1].number) * (yyvsp[0].number);
                  }
#line 3608 "src/y.tab.c"
    break;

  case 210:
#line 678 "src/p.y"
                                                   {
                        Run.limits.sendExpectBuffer = (yyvsp[-1].number) * (yyvsp[0].number);
                  }
#line 3616 "src/y.tab.c"
    break;

  case 211:
#line 681 "src/p.y"
                                                    {
                        Run.limits.fileContentBuffer = (yyvsp[-1].number) * (yyvsp[0].number);
                  }
#line 3624 "src/y.tab.c"
    break;

  case 212:
#line 684 "src/p.y"
                                                    {
                        Run.limits.httpContentBuffer = (yyvsp[-1].number) * (yyvsp[0].number);
                  }
#line 3632 "src/y.tab.c"
    break;

  case 213:
#line 687 "src/p.y"
                                                {
                        Run.limits.programOutput = (yyvsp[-1].number) * (yyvsp[0].number);
                  }
#line 3640 "src/y.tab.c"
    break;

  case 214:
#line 690 "src/p.y"
                                                        {
                        Run.limits.networkTimeout = (yyvsp[-1].number);
                  }
#line 3648 "src/y.tab.c"
    break;

  case 215:
#line 693 "src/p.y"
                                                   {
                        Run.limits.networkTimeout = (yyvsp[-1].number) * 1000;
                  }
#line 3656 "src/y.tab.c"
    break;

  case 216:
#line 696 "src/p.y"
                                                        {
                        Run.limits.programTimeout = (yyvsp[-1].number);
                  }
#line 3664 "src/y.tab.c"
    break;

  case 217:
#line 699 "src/p.y"
                                                   {
                        Run.limits.programTimeout = (yyvsp[-1].number) * 1000;
                  }
#line 3672 "src/y.tab.c"
    break;

  case 218:
#line 702 "src/p.y"
                                                     {
                        Run.limits.stopTimeout = (yyvsp[-1].number);
                  }
#line 3680 "src/y.tab.c"
    break;

  case 219:
#line 705 "src/p.y"
                                                {
                        Run.limits.stopTimeout = (yyvsp[-1].number) * 1000;
                  }
#line 3688 "src/y.tab.c"
    break;

  case 220:
#line 708 "src/p.y"
                                                      {
                        Run.limits.startTimeout = (yyvsp[-1].number);
                  }
#line 3696 "src/y.tab.c"
    break;

  case 221:
#line 711 "src/p.y"
                                                 {
                        Run.limits.startTimeout = (yyvsp[-1].number) * 1000;
                  }
#line 3704 "src/y.tab.c"
    break;

  case 222:
#line 714 "src/p.y"
                                                        {
                        Run.limits.restartTimeout = (yyvsp[-1].number);
                  }
#line 3712 "src/y.tab.c"
    break;

  case 223:
#line 717 "src/p.y"
                                                   {
                        Run.limits.restartTimeout = (yyvsp[-1].number) * 1000;
                  }
#line 3720 "src/y.tab.c"
    break;

  case 224:
#line 722 "src/p.y"
                           {
                        Run.flags |= Run_FipsEnabled;
                  }
#line 3728 "src/y.tab.c"
    break;

  case 225:
#line 727 "src/p.y"
                                     {
                        if (! Run.files.log || ihp.logfile) {
                                ihp.logfile = true;
                                setlogfile((yyvsp[0].string));
                                Run.flags &= ~Run_UseSyslog;
                                Run.flags |= Run_Log;
                        }
                  }
#line 3741 "src/y.tab.c"
    break;

  case 226:
#line 735 "src/p.y"
                                     {
                        setsyslog(NULL);
                  }
#line 3749 "src/y.tab.c"
    break;

  case 227:
#line 738 "src/p.y"
                                                     {
                        setsyslog((yyvsp[0].string)); FREE((yyvsp[0].string));
                  }
#line 3757 "src/y.tab.c"
    break;

  case 228:
#line 743 "src/p.y"
                                              {
                        Run.eventlist_dir = (yyvsp[0].string);
                  }
#line 3765 "src/y.tab.c"
    break;

  case 229:
#line 746 "src/p.y"
                                                          {
                        Run.eventlist_dir = (yyvsp[-2].string);
                        Run.eventlist_slots = (yyvsp[0].number);
                  }
#line 3774 "src/y.tab.c"
    break;

  case 230:
#line 750 "src/p.y"
                                             {
                        Run.eventlist_dir = Str_dup(MYEVENTLISTBASE);
                        Run.eventlist_slots = (yyvsp[0].number);
                  }
#line 3783 "src/y.tab.c"
    break;

  case 231:
#line 756 "src/p.y"
                                  {
                        Run.files.id = (yyvsp[0].string);
                  }
#line 3791 "src/y.tab.c"
    break;

  case 232:
#line 761 "src/p.y"
                                     {
                        Run.files.state = (yyvsp[0].string);
                  }
#line 3799 "src/y.tab.c"
    break;

  case 233:
#line 766 "src/p.y"
                                   {
                        if (! Run.files.pid || ihp.pidfile) {
                                ihp.pidfile = true;
                                setpidfile((yyvsp[0].string));
                        }
                  }
#line 3810 "src/y.tab.c"
    break;

  case 237:
#line 781 "src/p.y"
                                          {
                        mmonitset.url = (yyvsp[-1].url);
                        addmmonit(&mmonitset);
                  }
#line 3819 "src/y.tab.c"
    break;

  case 240:
#line 791 "src/p.y"
                                        {
                        mmonitset.timeout = (yyvsp[-1].number) * 1000; // net timeout is in milliseconds internally
                  }
#line 3827 "src/y.tab.c"
    break;

  case 246:
#line 801 "src/p.y"
                                       {
                        Run.flags &= ~Run_MmonitCredentials;
                  }
#line 3835 "src/y.tab.c"
    break;

  case 247:
#line 806 "src/p.y"
                                                     {
                        _setSSLOptions(&(Run.ssl));
                  }
#line 3843 "src/y.tab.c"
    break;

  case 248:
#line 811 "src/p.y"
                           {
                        sslset.flags = SSL_Enabled;
                  }
#line 3851 "src/y.tab.c"
    break;

  case 252:
#line 821 "src/p.y"
                                    {
                        sslset.flags = SSL_Enabled;
                        sslset.verify = true;
                  }
#line 3860 "src/y.tab.c"
    break;

  case 253:
#line 825 "src/p.y"
                                     {
                        sslset.flags = SSL_Enabled;
                        sslset.verify = false;
                  }
#line 3869 "src/y.tab.c"
    break;

  case 254:
#line 829 "src/p.y"
                                       {
                        sslset.flags = SSL_Enabled;
                        sslset.allowSelfSigned = true;
                  }
#line 3878 "src/y.tab.c"
    break;

  case 255:
#line 833 "src/p.y"
                                           {
                        sslset.flags = SSL_Enabled;
                        sslset.allowSelfSigned = false;
                  }
#line 3887 "src/y.tab.c"
    break;

  case 256:
#line 837 "src/p.y"
                                                {
                        sslset.flags = SSL_Enabled;
                  }
#line 3895 "src/y.tab.c"
    break;

  case 257:
#line 840 "src/p.y"
                                    {
                        FREE(sslset.ciphers);
                        sslset.ciphers = (yyvsp[0].string);
                  }
#line 3904 "src/y.tab.c"
    break;

  case 258:
#line 844 "src/p.y"
                                   {
                        _setPEM(&(sslset.pemfile), (yyvsp[0].string), "SSL server PEM file", true);
                  }
#line 3912 "src/y.tab.c"
    break;

  case 259:
#line 847 "src/p.y"
                                    {
                        _setPEM(&(sslset.pemchain), (yyvsp[0].string), "SSL certificate chain PEM file", true);
                  }
#line 3920 "src/y.tab.c"
    break;

  case 260:
#line 850 "src/p.y"
                                  {
                        _setPEM(&(sslset.pemkey), (yyvsp[0].string), "SSL server private key PEM file", true);
                  }
#line 3928 "src/y.tab.c"
    break;

  case 261:
#line 853 "src/p.y"
                                         {
                        _setPEM(&(sslset.clientpemfile), (yyvsp[0].string), "SSL client PEM file", true);
                  }
#line 3936 "src/y.tab.c"
    break;

  case 262:
#line 856 "src/p.y"
                                             {
                        _setPEM(&(sslset.CACertificateFile), (yyvsp[0].string), "SSL CA certificates file", true);
                  }
#line 3944 "src/y.tab.c"
    break;

  case 263:
#line 859 "src/p.y"
                                             {
                        _setPEM(&(sslset.CACertificatePath), (yyvsp[0].string), "SSL CA certificates directory", false);
                  }
#line 3952 "src/y.tab.c"
    break;

  case 264:
#line 864 "src/p.y"
                                                              {
                        sslset.flags = SSL_Enabled;
                        portset.target.net.ssl.certificate.minimumDays = (yyvsp[-1].number);
                  }
#line 3961 "src/y.tab.c"
    break;

  case 267:
#line 874 "src/p.y"
                                                               {
                        sslset.flags = SSL_Enabled;
                        sslset.checksum = (yyvsp[0].string);
                        switch (cleanup_hash_string(sslset.checksum)) {
                                case 32:
                                        sslset.checksumType = Hash_Md5;
                                        break;
                                case 40:
                                        sslset.checksumType = Hash_Sha1;
                                        break;
                                default:
                                        yyerror2("Unknown checksum type: [%s] is not MD5 nor SHA1", sslset.checksum);
                        }
                  }
#line 3980 "src/y.tab.c"
    break;

  case 268:
#line 888 "src/p.y"
                                                                       {
                        sslset.flags = SSL_Enabled;
                        sslset.checksum = (yyvsp[0].string);
                        if (cleanup_hash_string(sslset.checksum) != 32)
                                yyerror2("Unknown checksum type: [%s] is not MD5", sslset.checksum);
                        sslset.checksumType = Hash_Md5;
                  }
#line 3992 "src/y.tab.c"
    break;

  case 269:
#line 895 "src/p.y"
                                                                        {
                        sslset.flags = SSL_Enabled;
                        sslset.checksum = (yyvsp[0].string);
                        if (cleanup_hash_string(sslset.checksum) != 40)
                                yyerror2("Unknown checksum type: [%s] is not SHA1", sslset.checksum);
                        sslset.checksumType = Hash_Sha1;
                  }
#line 4004 "src/y.tab.c"
    break;

  case 274:
#line 912 "src/p.y"
                        {
#if defined OPENSSL_NO_SSL2 || ! defined HAVE_SSLV2 || ! defined HAVE_OPENSSL
                        yyerror("Your SSL Library does not support SSL version 2");
#else
                        _setSSLVersion(SSL_V2);
#endif
                  }
#line 4016 "src/y.tab.c"
    break;

  case 275:
#line 919 "src/p.y"
                          {
                        _unsetSSLVersion(SSL_V2);
                  }
#line 4024 "src/y.tab.c"
    break;

  case 276:
#line 922 "src/p.y"
                        {
#if defined OPENSSL_NO_SSL3 || ! defined HAVE_OPENSSL
                        yyerror("Your SSL Library does not support SSL version 3");
#else
                        _setSSLVersion(SSL_V3);
#endif
                  }
#line 4036 "src/y.tab.c"
    break;

  case 277:
#line 929 "src/p.y"
                          {
                        _unsetSSLVersion(SSL_V3);
                  }
#line 4044 "src/y.tab.c"
    break;

  case 278:
#line 932 "src/p.y"
                        {
#if defined OPENSSL_NO_TLS1_METHOD || ! defined HAVE_OPENSSL
                        yyerror("Your SSL Library does not support TLS version 1.0");
#else
                        _setSSLVersion(SSL_TLSV1);
#endif
                  }
#line 4056 "src/y.tab.c"
    break;

  case 279:
#line 939 "src/p.y"
                          {
                        _unsetSSLVersion(SSL_TLSV1);
                  }
#line 4064 "src/y.tab.c"
    break;

  case 280:
#line 942 "src/p.y"
                         {
#if defined OPENSSL_NO_TLS1_1_METHOD || ! defined HAVE_TLSV1_1 || ! defined HAVE_OPENSSL
                        yyerror("Your SSL Library does not support TLS version 1.1");
#else
                        _setSSLVersion(SSL_TLSV11);
#endif
                }
#line 4076 "src/y.tab.c"
    break;

  case 281:
#line 949 "src/p.y"
                           {
                        _unsetSSLVersion(SSL_TLSV11);
                  }
#line 4084 "src/y.tab.c"
    break;

  case 282:
#line 952 "src/p.y"
                         {
#if defined OPENSSL_NO_TLS1_2_METHOD || ! defined HAVE_TLSV1_2 || ! defined HAVE_OPENSSL
                        yyerror("Your SSL Library does not support TLS version 1.2");
#else
                        _setSSLVersion(SSL_TLSV12);
#endif
                }
#line 4096 "src/y.tab.c"
    break;

  case 283:
#line 959 "src/p.y"
                           {
                        _unsetSSLVersion(SSL_TLSV12);
                  }
#line 4104 "src/y.tab.c"
    break;

  case 284:
#line 962 "src/p.y"
                         {
#if defined OPENSSL_NO_TLS1_3_METHOD || ! defined HAVE_TLSV1_3 || ! defined HAVE_OPENSSL
                        yyerror("Your SSL Library does not support TLS version 1.3");
#else
                        _setSSLVersion(SSL_TLSV13);
#endif
                }
#line 4116 "src/y.tab.c"
    break;

  case 285:
#line 969 "src/p.y"
                           {
                        _unsetSSLVersion(SSL_TLSV13);
                  }
#line 4124 "src/y.tab.c"
    break;

  case 286:
#line 972 "src/p.y"
                       {
                        // Enable just TLS 1.2 and 1.3 by default
#if ! defined OPENSSL_NO_TLS1_2_METHOD && defined HAVE_TLSV1_2 && defined HAVE_OPENSSL
                        _setSSLVersion(SSL_TLSV12);
#endif
#if ! defined OPENSSL_NO_TLS1_3_METHOD && defined HAVE_TLSV1_3 && defined HAVE_OPENSSL
                        _setSSLVersion(SSL_TLSV13);
#endif
                  }
#line 4138 "src/y.tab.c"
    break;

  case 287:
#line 983 "src/p.y"
                                 { // Backward compatibility
                        sslset.flags = SSL_Enabled;
                        sslset.checksum = (yyvsp[0].string);
                        if (cleanup_hash_string(sslset.checksum) != 32)
                                yyerror2("Unknown checksum type: [%s] is not MD5", sslset.checksum);
                        sslset.checksumType = Hash_Md5;
                  }
#line 4150 "src/y.tab.c"
    break;

  case 288:
#line 992 "src/p.y"
                                                                    {
                        if (((yyvsp[-1].number)) > SMTP_TIMEOUT)
                                Run.mailserver_timeout = (yyvsp[-1].number);
                        Run.mail_hostname = (yyvsp[0].string);
                  }
#line 4160 "src/y.tab.c"
    break;

  case 289:
#line 999 "src/p.y"
                                                          {
                        if (mailset.from) {
                                Run.MailFormat.from = mailset.from;
                        } else {
                                Run.MailFormat.from = Address_new();
                                Run.MailFormat.from->address = Str_dup(ALERT_FROM);
                        }
                        if (mailset.replyto)
                                Run.MailFormat.replyto = mailset.replyto;
                        Run.MailFormat.subject = mailset.subject ?  mailset.subject : Str_dup(ALERT_SUBJECT);
                        Run.MailFormat.message = mailset.message ?  mailset.message : Str_dup(ALERT_MESSAGE);
                        reset_mailset();
                  }
#line 4178 "src/y.tab.c"
    break;

  case 292:
#line 1018 "src/p.y"
                                           {
                        /* Restore the current text overridden by lookahead */
                        FREE(argyytext);
                        argyytext = Str_dup((yyvsp[-1].string));

                        mailserverset.host = (yyvsp[-1].string);
                        mailserverset.port = PORT_SMTP;
                        addmailserver(&mailserverset);
                  }
#line 4192 "src/y.tab.c"
    break;

  case 293:
#line 1027 "src/p.y"
                                                       {
                        /* Restore the current text overridden by lookahead */
                        FREE(argyytext);
                        argyytext = Str_dup((yyvsp[-3].string));

                        mailserverset.host = (yyvsp[-3].string);
                        mailserverset.port = (yyvsp[-1].number);
                        addmailserver(&mailserverset);
                  }
#line 4206 "src/y.tab.c"
    break;

  case 296:
#line 1042 "src/p.y"
                           {
                        mailserverset.username = (yyvsp[0].string);
                  }
#line 4214 "src/y.tab.c"
    break;

  case 297:
#line 1045 "src/p.y"
                           {
                        mailserverset.password = (yyvsp[0].string);
                  }
#line 4222 "src/y.tab.c"
    break;

  case 302:
#line 1054 "src/p.y"
                                      {
                        if (sslset.flags & SSL_Enabled) {
#ifdef HAVE_OPENSSL
                                if (sslset.pemfile) {
                                        if (sslset.pemchain || sslset.pemkey) {
                                                yyerror("SSL server option pemfile and pemchain|pemkey are mutually exclusive");
                                        } else if (! file_checkStat(sslset.pemfile, "SSL server PEM file", S_IRWXU)) {
                                                yyerror("SSL server PEM file permissions check failed");
                                        } else {
                                                _setSSLOptions(&(Run.httpd.socket.net.ssl));
                                        }
                                } else if (sslset.pemchain && sslset.pemkey) {
                                        if (! file_checkStat(sslset.pemkey, "SSL server private key PEM file", S_IRWXU)) {
                                                yyerror("SSL server private key PEM file permissions check failed");
                                        } else {
                                                _setSSLOptions(&(Run.httpd.socket.net.ssl));
                                        }
                                } else {
                                        yyerror("SSL server PEM file is required (please use ssl pemfile option)");
                                }
#else
                                yyerror("SSL is not supported");
#endif
                        }
                  }
#line 4252 "src/y.tab.c"
    break;

  case 314:
#line 1097 "src/p.y"
                               {
                        _setPEM(&(sslset.pemfile), (yyvsp[0].string), "SSL server PEM file", true);
                  }
#line 4260 "src/y.tab.c"
    break;

  case 315:
#line 1103 "src/p.y"
                                     {
                        _setPEM(&(sslset.clientpemfile), (yyvsp[0].string), "SSL client PEM file", true);
                  }
#line 4268 "src/y.tab.c"
    break;

  case 316:
#line 1109 "src/p.y"
                                         {
                        sslset.flags = SSL_Enabled;
                        sslset.allowSelfSigned = true;
                  }
#line 4277 "src/y.tab.c"
    break;

  case 317:
#line 1115 "src/p.y"
                              {
                        Run.httpd.flags |= Httpd_Net;
                        Run.httpd.socket.net.port = (yyvsp[0].number);
                  }
#line 4286 "src/y.tab.c"
    break;

  case 318:
#line 1121 "src/p.y"
                                                        {
                        Run.httpd.flags |= Httpd_Unix;
                        Run.httpd.socket.unix.path = (yyvsp[-1].string);
                  }
#line 4295 "src/y.tab.c"
    break;

  case 321:
#line 1131 "src/p.y"
                               {
                        Run.httpd.flags |= Httpd_UnixUid;
                        Run.httpd.socket.unix.uid = get_uid((yyvsp[0].string), 0);
                        FREE((yyvsp[0].string));
                    }
#line 4305 "src/y.tab.c"
    break;

  case 322:
#line 1136 "src/p.y"
                               {
                        Run.httpd.flags |= Httpd_UnixGid;
                        Run.httpd.socket.unix.gid = get_gid((yyvsp[0].string), 0);
                        FREE((yyvsp[0].string));
                    }
#line 4315 "src/y.tab.c"
    break;

  case 323:
#line 1141 "src/p.y"
                               {
                        Run.httpd.flags |= Httpd_UnixUid;
                        Run.httpd.socket.unix.uid = get_uid(NULL, (yyvsp[0].number));
                    }
#line 4324 "src/y.tab.c"
    break;

  case 324:
#line 1145 "src/p.y"
                               {
                        Run.httpd.flags |= Httpd_UnixGid;
                        Run.httpd.socket.unix.gid = get_gid(NULL, (yyvsp[0].number));
                    }
#line 4333 "src/y.tab.c"
    break;

  case 325:
#line 1149 "src/p.y"
                                      {
                        Run.httpd.flags |= Httpd_UnixPermission;
                        Run.httpd.socket.unix.permission = check_perm((yyvsp[0].number));
                    }
#line 4342 "src/y.tab.c"
    break;

  case 330:
#line 1163 "src/p.y"
                             {
                        Run.httpd.flags |= Httpd_Signature;
                  }
#line 4350 "src/y.tab.c"
    break;

  case 331:
#line 1166 "src/p.y"
                             {
                        Run.httpd.flags &= ~Httpd_Signature;
                  }
#line 4358 "src/y.tab.c"
    break;

  case 332:
#line 1171 "src/p.y"
                                 {
                        Run.httpd.socket.net.address = (yyvsp[0].string);
                  }
#line 4366 "src/y.tab.c"
    break;

  case 333:
#line 1176 "src/p.y"
                                                 {
                        addcredentials((yyvsp[-3].string), (yyvsp[-1].string), Digest_Cleartext, (yyvsp[0].number));
                  }
#line 4374 "src/y.tab.c"
    break;

  case 334:
#line 1179 "src/p.y"
                                           {
#ifdef HAVE_LIBPAM
                        addpamauth((yyvsp[-1].string), (yyvsp[0].number));
#else
                        yyerror("PAM is not supported");
                        FREE((yyvsp[-1].string));
#endif
                  }
#line 4387 "src/y.tab.c"
    break;

  case 335:
#line 1187 "src/p.y"
                             {
                        addhtpasswdentry((yyvsp[0].string), NULL, Digest_Cleartext);
                        FREE((yyvsp[0].string));
                  }
#line 4396 "src/y.tab.c"
    break;

  case 336:
#line 1191 "src/p.y"
                                       {
                        addhtpasswdentry((yyvsp[0].string), NULL, Digest_Cleartext);
                        FREE((yyvsp[0].string));
                  }
#line 4405 "src/y.tab.c"
    break;

  case 337:
#line 1195 "src/p.y"
                                     {
                        addhtpasswdentry((yyvsp[0].string), NULL, Digest_Md5);
                        FREE((yyvsp[0].string));
                  }
#line 4414 "src/y.tab.c"
    break;

  case 338:
#line 1199 "src/p.y"
                                   {
                        addhtpasswdentry((yyvsp[0].string), NULL, Digest_Crypt);
                        FREE((yyvsp[0].string));
                  }
#line 4423 "src/y.tab.c"
    break;

  case 339:
#line 1203 "src/p.y"
                             {
                        htpasswd_file = (yyvsp[0].string);
                        digesttype = Digest_Cleartext;
                  }
#line 4432 "src/y.tab.c"
    break;

  case 340:
#line 1207 "src/p.y"
                                {
                        FREE(htpasswd_file);
                  }
#line 4440 "src/y.tab.c"
    break;

  case 341:
#line 1210 "src/p.y"
                                       {
                        htpasswd_file = (yyvsp[0].string);
                        digesttype = Digest_Cleartext;
                  }
#line 4449 "src/y.tab.c"
    break;

  case 342:
#line 1214 "src/p.y"
                                {
                        FREE(htpasswd_file);
                  }
#line 4457 "src/y.tab.c"
    break;

  case 343:
#line 1217 "src/p.y"
                                     {
                        htpasswd_file = (yyvsp[0].string);
                        digesttype = Digest_Md5;
                  }
#line 4466 "src/y.tab.c"
    break;

  case 344:
#line 1221 "src/p.y"
                                {
                        FREE(htpasswd_file);
                  }
#line 4474 "src/y.tab.c"
    break;

  case 345:
#line 1224 "src/p.y"
                                   {
                        htpasswd_file = (yyvsp[0].string);
                        digesttype = Digest_Crypt;
                  }
#line 4483 "src/y.tab.c"
    break;

  case 346:
#line 1228 "src/p.y"
                                {
                        FREE(htpasswd_file);
                  }
#line 4491 "src/y.tab.c"
    break;

  case 347:
#line 1231 "src/p.y"
                               {
                        if (! Engine_addAllow((yyvsp[0].string)))
                                yywarning2("invalid allow option: %s", (yyvsp[0].string));
                        FREE((yyvsp[0].string));
                  }
#line 4501 "src/y.tab.c"
    break;

  case 350:
#line 1242 "src/p.y"
                         {
                        addhtpasswdentry(htpasswd_file, (yyvsp[0].string), digesttype);
                        FREE((yyvsp[0].string));
                  }
#line 4510 "src/y.tab.c"
    break;

  case 351:
#line 1248 "src/p.y"
                              {
                        (yyval.number) = false;
                  }
#line 4518 "src/y.tab.c"
    break;

  case 352:
#line 1251 "src/p.y"
                           {
                        (yyval.number) = true;
                  }
#line 4526 "src/y.tab.c"
    break;

  case 353:
#line 1256 "src/p.y"
                                                     {
                        createservice(Service_Process, (yyvsp[-2].string), (yyvsp[0].string), check_process);
                  }
#line 4534 "src/y.tab.c"
    break;

  case 354:
#line 1259 "src/p.y"
                                                     {
                        createservice(Service_Process, (yyvsp[-2].string), (yyvsp[0].string), check_process);
                  }
#line 4542 "src/y.tab.c"
    break;

  case 355:
#line 1262 "src/p.y"
                                                     {
                        createservice(Service_Process, (yyvsp[-2].string), (yyvsp[0].string), check_process);
                        matchset.ignore = false;
                        matchset.match_path = NULL;
                        matchset.match_string = Str_dup((yyvsp[0].string));
                        addmatch(&matchset, Action_Ignored, 0);
                  }
#line 4554 "src/y.tab.c"
    break;

  case 356:
#line 1269 "src/p.y"
                                                   {
                        createservice(Service_Process, (yyvsp[-2].string), (yyvsp[0].string), check_process);
                        matchset.ignore = false;
                        matchset.match_path = NULL;
                        matchset.match_string = Str_dup((yyvsp[0].string));
                        addmatch(&matchset, Action_Ignored, 0);
                  }
#line 4566 "src/y.tab.c"
    break;

  case 357:
#line 1278 "src/p.y"
                                                     {
                        createservice(Service_File, (yyvsp[-2].string), (yyvsp[0].string), check_file);
                  }
#line 4574 "src/y.tab.c"
    break;

  case 358:
#line 1283 "src/p.y"
                                                        {
                        createservice(Service_Filesystem, (yyvsp[-2].string), (yyvsp[0].string), check_filesystem);
                  }
#line 4582 "src/y.tab.c"
    break;

  case 359:
#line 1286 "src/p.y"
                                                          {
                        createservice(Service_Filesystem, (yyvsp[-2].string), (yyvsp[0].string), check_filesystem);
                  }
#line 4590 "src/y.tab.c"
    break;

  case 360:
#line 1291 "src/p.y"
                                                    {
                        createservice(Service_Directory, (yyvsp[-2].string), (yyvsp[0].string), check_directory);
                  }
#line 4598 "src/y.tab.c"
    break;

  case 361:
#line 1296 "src/p.y"
                                                       {
                        createservice(Service_Host, (yyvsp[-2].string), (yyvsp[0].string), check_remote_host);
                  }
#line 4606 "src/y.tab.c"
    break;

  case 362:
#line 1301 "src/p.y"
                                                      {
                        if (Link_isGetByAddressSupported()) {
                                createservice(Service_Net, (yyvsp[-2].string), (yyvsp[0].string), check_net);
                                current->inf.net->stats = Link_createForAddress((yyvsp[0].string));
                        } else {
                                yyerror("Network monitoring by IP address is not supported on this platform, please use 'check network <foo> with interface <bar>' instead");
                        }
                  }
#line 4619 "src/y.tab.c"
    break;

  case 363:
#line 1309 "src/p.y"
                                                        {
                        createservice(Service_Net, (yyvsp[-2].string), (yyvsp[0].string), check_net);
                        current->inf.net->stats = Link_createForInterface((yyvsp[0].string));
                  }
#line 4628 "src/y.tab.c"
    break;

  case 364:
#line 1315 "src/p.y"
                                          {
                        char *servicename = (yyvsp[0].string);
                        if (Str_sub(servicename, "$HOST")) {
                                char hostname[STRLEN];
                                if (gethostname(hostname, sizeof(hostname))) {
                                        Log_error("System hostname error -- %s\n", STRERROR);
                                        cfg_errflag++;
                                } else {
                                        Util_replaceString(&servicename, "$HOST", hostname);
                                }
                        }
                        Run.system = createservice(Service_System, servicename, NULL, check_system); // The name given in the 'check system' statement overrides system hostname
                  }
#line 4646 "src/y.tab.c"
    break;

  case 365:
#line 1330 "src/p.y"
                                                     {
                        createservice(Service_Fifo, (yyvsp[-2].string), (yyvsp[0].string), check_fifo);
                  }
#line 4654 "src/y.tab.c"
    break;

  case 366:
#line 1335 "src/p.y"
                                                                               {
                        createservice(Service_Program, (yyvsp[-3].string), NULL, check_program);
                        current->program->timeout = (yyvsp[0].number);
                        current->program->lastOutput = StringBuffer_create(64);
                        current->program->inprogressOutput = StringBuffer_create(64);
                 }
#line 4665 "src/y.tab.c"
    break;

  case 367:
#line 1341 "src/p.y"
                                                                                              {
                        createservice(Service_Program, (yyvsp[-4].string), NULL, check_program);
                        current->program->timeout = (yyvsp[0].number);
                        current->program->lastOutput = StringBuffer_create(64);
                        current->program->inprogressOutput = StringBuffer_create(64);
                 }
#line 4676 "src/y.tab.c"
    break;

  case 368:
#line 1349 "src/p.y"
                                                  {
                        addcommand(START, (yyvsp[0].number));
                  }
#line 4684 "src/y.tab.c"
    break;

  case 369:
#line 1352 "src/p.y"
                                                                 {
                        addcommand(START, (yyvsp[0].number));
                  }
#line 4692 "src/y.tab.c"
    break;

  case 370:
#line 1357 "src/p.y"
                                                {
                        addcommand(STOP, (yyvsp[0].number));
                  }
#line 4700 "src/y.tab.c"
    break;

  case 371:
#line 1360 "src/p.y"
                                                               {
                        addcommand(STOP, (yyvsp[0].number));
                  }
#line 4708 "src/y.tab.c"
    break;

  case 372:
#line 1366 "src/p.y"
                                                      {
                        addcommand(RESTART, (yyvsp[0].number));
                  }
#line 4716 "src/y.tab.c"
    break;

  case 373:
#line 1369 "src/p.y"
                                                                     {
                        addcommand(RESTART, (yyvsp[0].number));
                  }
#line 4724 "src/y.tab.c"
    break;

  case 378:
#line 1382 "src/p.y"
                         {
                        addargument((yyvsp[0].string));
                  }
#line 4732 "src/y.tab.c"
    break;

  case 379:
#line 1385 "src/p.y"
                       {
                        addargument((yyvsp[0].string));
                  }
#line 4740 "src/y.tab.c"
    break;

  case 380:
#line 1390 "src/p.y"
                             {
                        addeuid(get_uid((yyvsp[0].string), 0));
                        FREE((yyvsp[0].string));
                  }
#line 4749 "src/y.tab.c"
    break;

  case 381:
#line 1394 "src/p.y"
                             {
                        addegid(get_gid((yyvsp[0].string), 0));
                        FREE((yyvsp[0].string));
                  }
#line 4758 "src/y.tab.c"
    break;

  case 382:
#line 1398 "src/p.y"
                             {
                        addeuid(get_uid(NULL, (yyvsp[0].number)));
                  }
#line 4766 "src/y.tab.c"
    break;

  case 383:
#line 1401 "src/p.y"
                             {
                        addegid(get_gid(NULL, (yyvsp[0].number)));
                  }
#line 4774 "src/y.tab.c"
    break;

  case 384:
#line 1406 "src/p.y"
                                    {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 4782 "src/y.tab.c"
    break;

  case 385:
#line 1409 "src/p.y"
                                  {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 4790 "src/y.tab.c"
    break;

  case 386:
#line 1414 "src/p.y"
                                  {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 4798 "src/y.tab.c"
    break;

  case 387:
#line 1419 "src/p.y"
                                  {
                        (yyval.string) = NULL;
                  }
#line 4806 "src/y.tab.c"
    break;

  case 388:
#line 1422 "src/p.y"
                                  {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 4814 "src/y.tab.c"
    break;

  case 389:
#line 1427 "src/p.y"
                                                                                            {
                        /* This is a workaround to support content match without having to create an URL object. 'urloption' creates the Request_T object we need minus the URL object, but with enough information to perform content test.
                           TODO: Parser is in need of refactoring */
                        portset.url_request = urlrequest;
                        portset.check_invers = false;
                        portset.responsetime.operator = responsetimeset.operator;
                        portset.responsetime.limit = responsetimeset.limit;
                        addeventaction(&(portset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addport(&(current->portlist), &portset);
                  }
#line 4829 "src/y.tab.c"
    break;

  case 390:
#line 1437 "src/p.y"
                                                                                               {
                        portset.url_request = urlrequest;
                        portset.check_invers = true;
                        portset.responsetime.operator = responsetimeset.operator;
                        portset.responsetime.limit = responsetimeset.limit;
                        addeventaction(&(portset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addport(&(current->portlist), &portset);
                  }
#line 4842 "src/y.tab.c"
    break;

  case 405:
#line 1465 "src/p.y"
                                                                                                   {
                        portset.check_invers = false;
                        portset.responsetime.operator = responsetimeset.operator;
                        portset.responsetime.limit = responsetimeset.limit;
                        prepare_urlrequest((yyvsp[-5].url));
                        addeventaction(&(portset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addport(&(current->portlist), &portset);
                  }
#line 4855 "src/y.tab.c"
    break;

  case 406:
#line 1473 "src/p.y"
                                                                                                      {
                        portset.check_invers = true;
                        portset.responsetime.operator = responsetimeset.operator;
                        portset.responsetime.limit = responsetimeset.limit;
                        prepare_urlrequest((yyvsp[-5].url));
                        addeventaction(&(portset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addport(&(current->portlist), &portset);
                  }
#line 4868 "src/y.tab.c"
    break;

  case 415:
#line 1495 "src/p.y"
                                                                                               {
                        portset.check_invers = false;
                        portset.responsetime.operator = responsetimeset.operator;
                        portset.responsetime.limit = responsetimeset.limit;
                        addeventaction(&(portset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addport(&(current->socketlist), &portset);
                  }
#line 4880 "src/y.tab.c"
    break;

  case 416:
#line 1502 "src/p.y"
                                                                                                  {
                        portset.check_invers = true;
                        portset.responsetime.operator = responsetimeset.operator;
                        portset.responsetime.limit = responsetimeset.limit;
                        addeventaction(&(portset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addport(&(current->socketlist), &portset);
                  }
#line 4892 "src/y.tab.c"
    break;

  case 425:
#line 1523 "src/p.y"
                                                                                          {
                        icmpset.family = Socket_Ip;
                        icmpset.check_invers = false;
                        icmpset.type = (yyvsp[-5].number);
                        icmpset.responsetime.operator = responsetimeset.operator;
                        icmpset.responsetime.limit = responsetimeset.limit;
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                  }
#line 4906 "src/y.tab.c"
    break;

  case 426:
#line 1532 "src/p.y"
                                                                                 {
                        icmpset.family = Socket_Ip;
                        icmpset.check_invers = false;
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                 }
#line 4917 "src/y.tab.c"
    break;

  case 427:
#line 1538 "src/p.y"
                                                                                  {
                        icmpset.family = Socket_Ip4;
                        icmpset.check_invers = false;
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                 }
#line 4928 "src/y.tab.c"
    break;

  case 428:
#line 1544 "src/p.y"
                                                                                  {
                        icmpset.family = Socket_Ip6;
                        icmpset.check_invers = false;
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                 }
#line 4939 "src/y.tab.c"
    break;

  case 429:
#line 1550 "src/p.y"
                                                                                             {
                        icmpset.family = Socket_Ip;
                        icmpset.check_invers = true;
                        icmpset.type = (yyvsp[-5].number);
                        icmpset.responsetime.operator = responsetimeset.operator;
                        icmpset.responsetime.limit = responsetimeset.limit;
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                  }
#line 4953 "src/y.tab.c"
    break;

  case 430:
#line 1559 "src/p.y"
                                                                                    {
                        icmpset.family = Socket_Ip;
                        icmpset.check_invers = true;
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                 }
#line 4964 "src/y.tab.c"
    break;

  case 431:
#line 1565 "src/p.y"
                                                                                     {
                        icmpset.family = Socket_Ip4;
                        icmpset.check_invers = true;
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                 }
#line 4975 "src/y.tab.c"
    break;

  case 432:
#line 1571 "src/p.y"
                                                                                     {
                        icmpset.family = Socket_Ip6;
                        icmpset.check_invers = true;
                        addeventaction(&(icmpset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addicmp(&icmpset);
                 }
#line 4986 "src/y.tab.c"
    break;

  case 439:
#line 1589 "src/p.y"
                              {
                        portset.hostname = Str_dup(current->type == Service_Host ? current->path : LOCALHOST);
                  }
#line 4994 "src/y.tab.c"
    break;

  case 440:
#line 1592 "src/p.y"
                              {
                        portset.hostname = (yyvsp[0].string);
                  }
#line 5002 "src/y.tab.c"
    break;

  case 441:
#line 1597 "src/p.y"
                              {
                        portset.target.net.port = (yyvsp[0].number);
                  }
#line 5010 "src/y.tab.c"
    break;

  case 442:
#line 1602 "src/p.y"
                                  {
                        portset.family = Socket_Unix;
                        portset.target.unix.pathname = (yyvsp[0].string);
                  }
#line 5019 "src/y.tab.c"
    break;

  case 443:
#line 1608 "src/p.y"
                       {
                        portset.family = Socket_Ip4;
                  }
#line 5027 "src/y.tab.c"
    break;

  case 444:
#line 1611 "src/p.y"
                       {
                        portset.family = Socket_Ip6;
                  }
#line 5035 "src/y.tab.c"
    break;

  case 445:
#line 1616 "src/p.y"
                           {
                        portset.type = Socket_Tcp;
                  }
#line 5043 "src/y.tab.c"
    break;

  case 446:
#line 1619 "src/p.y"
                                          { // The typelist is kept for backward compatibility (replaced by ssloptionlist)
                        portset.type = Socket_Tcp;
                        sslset.flags = SSL_Enabled;
                  }
#line 5052 "src/y.tab.c"
    break;

  case 447:
#line 1623 "src/p.y"
                           {
                        portset.type = Socket_Udp;
                  }
#line 5060 "src/y.tab.c"
    break;

  case 452:
#line 1636 "src/p.y"
                                 {
                        _parseOutgoingAddress((yyvsp[0].string), &(portset.outgoing));
                  }
#line 5068 "src/y.tab.c"
    break;

  case 453:
#line 1641 "src/p.y"
                                                         {
                        portset.protocol = Protocol_get(Protocol_APACHESTATUS);
                  }
#line 5076 "src/y.tab.c"
    break;

  case 454:
#line 1644 "src/p.y"
                                   {
                        portset.protocol = Protocol_get(Protocol_DEFAULT);
                  }
#line 5084 "src/y.tab.c"
    break;

  case 455:
#line 1647 "src/p.y"
                               {
                        portset.protocol = Protocol_get(Protocol_DNS);
                  }
#line 5092 "src/y.tab.c"
    break;

  case 456:
#line 1650 "src/p.y"
                                {
                        portset.protocol = Protocol_get(Protocol_DWP);
                  }
#line 5100 "src/y.tab.c"
    break;

  case 457:
#line 1653 "src/p.y"
                                    {
                        portset.protocol = Protocol_get(Protocol_FAIL2BAN);
                }
#line 5108 "src/y.tab.c"
    break;

  case 458:
#line 1656 "src/p.y"
                               {
                        portset.protocol = Protocol_get(Protocol_FTP);
                  }
#line 5116 "src/y.tab.c"
    break;

  case 459:
#line 1659 "src/p.y"
                                         {
                        portset.protocol = Protocol_get(Protocol_HTTP);
                  }
#line 5124 "src/y.tab.c"
    break;

  case 460:
#line 1662 "src/p.y"
                                          {
                        sslset.flags = SSL_Enabled;
                        portset.type = Socket_Tcp;
                        portset.protocol = Protocol_get(Protocol_HTTP);
                 }
#line 5134 "src/y.tab.c"
    break;

  case 461:
#line 1667 "src/p.y"
                                {
                        portset.protocol = Protocol_get(Protocol_IMAP);
                  }
#line 5142 "src/y.tab.c"
    break;

  case 462:
#line 1670 "src/p.y"
                                 {
                        sslset.flags = SSL_Enabled;
                        portset.type = Socket_Tcp;
                        portset.protocol = Protocol_get(Protocol_IMAP);
                  }
#line 5152 "src/y.tab.c"
    break;

  case 463:
#line 1675 "src/p.y"
                                  {
                        portset.protocol = Protocol_get(Protocol_CLAMAV);
                  }
#line 5160 "src/y.tab.c"
    break;

  case 464:
#line 1678 "src/p.y"
                                 {
                        portset.protocol = Protocol_get(Protocol_LDAP2);
                  }
#line 5168 "src/y.tab.c"
    break;

  case 465:
#line 1681 "src/p.y"
                                 {
                        portset.protocol = Protocol_get(Protocol_LDAP3);
                  }
#line 5176 "src/y.tab.c"
    break;

  case 466:
#line 1684 "src/p.y"
                                    {
                        portset.protocol = Protocol_get(Protocol_MONGODB);
                  }
#line 5184 "src/y.tab.c"
    break;

  case 467:
#line 1687 "src/p.y"
                                         {
                        portset.protocol = Protocol_get(Protocol_MQTT);
                  }
#line 5192 "src/y.tab.c"
    break;

  case 468:
#line 1690 "src/p.y"
                                           {
                        portset.protocol = Protocol_get(Protocol_MYSQL);
                  }
#line 5200 "src/y.tab.c"
    break;

  case 469:
#line 1693 "src/p.y"
                                            {
                        sslset.flags = SSL_StartTLS;
                        portset.protocol = Protocol_get(Protocol_MYSQL);
                  }
#line 5209 "src/y.tab.c"
    break;

  case 470:
#line 1697 "src/p.y"
                                       {
                        portset.protocol = Protocol_get(Protocol_SIP);
                  }
#line 5217 "src/y.tab.c"
    break;

  case 471:
#line 1700 "src/p.y"
                                {
                        portset.protocol = Protocol_get(Protocol_NNTP);
                  }
#line 5225 "src/y.tab.c"
    break;

  case 472:
#line 1703 "src/p.y"
                                 {
                        portset.protocol = Protocol_get(Protocol_NTP3);
                        portset.type = Socket_Udp;
                  }
#line 5234 "src/y.tab.c"
    break;

  case 473:
#line 1707 "src/p.y"
                                         {
                        portset.protocol = Protocol_get(Protocol_POSTFIXPOLICY);
                  }
#line 5242 "src/y.tab.c"
    break;

  case 474:
#line 1710 "src/p.y"
                               {
                        portset.protocol = Protocol_get(Protocol_POP);
                  }
#line 5250 "src/y.tab.c"
    break;

  case 475:
#line 1713 "src/p.y"
                                {
                        sslset.flags = SSL_Enabled;
                        portset.type = Socket_Tcp;
                        portset.protocol = Protocol_get(Protocol_POP);
                  }
#line 5260 "src/y.tab.c"
    break;

  case 476:
#line 1718 "src/p.y"
                                 {
                        portset.protocol = Protocol_get(Protocol_SIEVE);
                  }
#line 5268 "src/y.tab.c"
    break;

  case 477:
#line 1721 "src/p.y"
                                         {
                        portset.protocol = Protocol_get(Protocol_SMTP);
                  }
#line 5276 "src/y.tab.c"
    break;

  case 478:
#line 1724 "src/p.y"
                                          {
                        sslset.flags = SSL_Enabled;
                        portset.type = Socket_Tcp;
                        portset.protocol = Protocol_get(Protocol_SMTP);
                 }
#line 5286 "src/y.tab.c"
    break;

  case 479:
#line 1729 "src/p.y"
                                        {
                        portset.protocol = Protocol_get(Protocol_SPAMASSASSIN);
                  }
#line 5294 "src/y.tab.c"
    break;

  case 480:
#line 1732 "src/p.y"
                                {
                        portset.protocol = Protocol_get(Protocol_SSH);
                  }
#line 5302 "src/y.tab.c"
    break;

  case 481:
#line 1735 "src/p.y"
                                 {
                        portset.protocol = Protocol_get(Protocol_RDATE);
                  }
#line 5310 "src/y.tab.c"
    break;

  case 482:
#line 1738 "src/p.y"
                                  {
                        portset.protocol = Protocol_get(Protocol_REDIS);
                  }
#line 5318 "src/y.tab.c"
    break;

  case 483:
#line 1741 "src/p.y"
                                 {
                        portset.protocol = Protocol_get(Protocol_RSYNC);
                  }
#line 5326 "src/y.tab.c"
    break;

  case 484:
#line 1744 "src/p.y"
                               {
                        portset.protocol = Protocol_get(Protocol_TNS);
                  }
#line 5334 "src/y.tab.c"
    break;

  case 485:
#line 1747 "src/p.y"
                                 {
                        portset.protocol = Protocol_get(Protocol_PGSQL);
                  }
#line 5342 "src/y.tab.c"
    break;

  case 486:
#line 1750 "src/p.y"
                                {
                        portset.protocol = Protocol_get(Protocol_LMTP);
                  }
#line 5350 "src/y.tab.c"
    break;

  case 487:
#line 1753 "src/p.y"
                               {
                        portset.protocol = Protocol_get(Protocol_GPS);
                  }
#line 5358 "src/y.tab.c"
    break;

  case 488:
#line 1756 "src/p.y"
                                             {
                        portset.protocol = Protocol_get(Protocol_RADIUS);
                  }
#line 5366 "src/y.tab.c"
    break;

  case 489:
#line 1759 "src/p.y"
                                    {
                        portset.protocol = Protocol_get(Protocol_MEMCACHE);
                  }
#line 5374 "src/y.tab.c"
    break;

  case 490:
#line 1762 "src/p.y"
                                                   {
                        portset.protocol = Protocol_get(Protocol_WEBSOCKET);
                  }
#line 5382 "src/y.tab.c"
    break;

  case 491:
#line 1767 "src/p.y"
                              {
                        if (portset.protocol->check == check_default || portset.protocol->check == check_generic) {
                                portset.protocol = Protocol_get(Protocol_GENERIC);
                                addgeneric(&portset, (yyvsp[0].string), NULL);
                        } else {
                                yyerror("The SEND statement is not allowed in the %s protocol context", portset.protocol->name);
                        }
                  }
#line 5395 "src/y.tab.c"
    break;

  case 492:
#line 1775 "src/p.y"
                                {
                        if (portset.protocol->check == check_default || portset.protocol->check == check_generic) {
                                portset.protocol = Protocol_get(Protocol_GENERIC);
                                addgeneric(&portset, NULL, (yyvsp[0].string));
                        } else {
                                yyerror("The EXPECT statement is not allowed in the %s protocol context", portset.protocol->name);
                        }
                  }
#line 5408 "src/y.tab.c"
    break;

  case 495:
#line 1789 "src/p.y"
                                {
                        portset.parameters.websocket.origin = (yyvsp[0].string);
                  }
#line 5416 "src/y.tab.c"
    break;

  case 496:
#line 1792 "src/p.y"
                               {
                        portset.parameters.websocket.request = (yyvsp[0].string);
                  }
#line 5424 "src/y.tab.c"
    break;

  case 497:
#line 1795 "src/p.y"
                              {
                        portset.parameters.websocket.host = (yyvsp[0].string);
                  }
#line 5432 "src/y.tab.c"
    break;

  case 498:
#line 1798 "src/p.y"
                                    {
                        portset.parameters.websocket.version = (yyvsp[0].number);
                  }
#line 5440 "src/y.tab.c"
    break;

  case 501:
#line 1807 "src/p.y"
                           {
                        portset.parameters.smtp.username = (yyvsp[0].string);
                  }
#line 5448 "src/y.tab.c"
    break;

  case 502:
#line 1810 "src/p.y"
                           {
                        portset.parameters.smtp.password = (yyvsp[0].string);
                  }
#line 5456 "src/y.tab.c"
    break;

  case 505:
#line 1819 "src/p.y"
                           {
                        portset.parameters.mqtt.username = (yyvsp[0].string);
                  }
#line 5464 "src/y.tab.c"
    break;

  case 506:
#line 1822 "src/p.y"
                           {
                        portset.parameters.mqtt.password = (yyvsp[0].string);
                  }
#line 5472 "src/y.tab.c"
    break;

  case 509:
#line 1831 "src/p.y"
                           {
                        portset.parameters.mysql.username = (yyvsp[0].string);
                  }
#line 5480 "src/y.tab.c"
    break;

  case 510:
#line 1834 "src/p.y"
                           {
                        portset.parameters.mysql.password = (yyvsp[0].string);
                  }
#line 5488 "src/y.tab.c"
    break;

  case 511:
#line 1837 "src/p.y"
                                                          {
                        portset.parameters.mysql.rsaChecksum = (yyvsp[0].string);
                        switch (cleanup_hash_string(portset.parameters.mysql.rsaChecksum)) {
                                case 32:
                                        portset.parameters.mysql.rsaChecksumType = Hash_Md5;
                                        break;
                                case 40:
                                        portset.parameters.mysql.rsaChecksumType = Hash_Sha1;
                                        break;
                                default:
                                        yyerror2("Unknown checksum type: [%s] is not MD5 nor SHA1", portset.parameters.mysql.rsaChecksum);
                        }
                  }
#line 5506 "src/y.tab.c"
    break;

  case 512:
#line 1850 "src/p.y"
                                                                  {
                        portset.parameters.mysql.rsaChecksum = (yyvsp[0].string);
                        if (cleanup_hash_string(portset.parameters.mysql.rsaChecksum) != 32)
                                yyerror2("Unknown checksum type: [%s] is not MD5", portset.parameters.mysql.rsaChecksum);
                        portset.parameters.mysql.rsaChecksumType = Hash_Md5;
                  }
#line 5517 "src/y.tab.c"
    break;

  case 513:
#line 1856 "src/p.y"
                                                                   {
                        portset.parameters.mysql.rsaChecksum = (yyvsp[0].string);
                        if (cleanup_hash_string(portset.parameters.mysql.rsaChecksum) != 40)
                                yyerror2("Unknown checksum type: [%s] is not SHA1", portset.parameters.mysql.rsaChecksum);
                        portset.parameters.mysql.rsaChecksumType = Hash_Sha1;
                  }
#line 5528 "src/y.tab.c"
    break;

  case 514:
#line 1865 "src/p.y"
                                  {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 5536 "src/y.tab.c"
    break;

  case 515:
#line 1868 "src/p.y"
                                {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 5544 "src/y.tab.c"
    break;

  case 516:
#line 1873 "src/p.y"
                                    {
                        (yyval.number) = verifyMaxForward((yyvsp[0].number));
                  }
#line 5552 "src/y.tab.c"
    break;

  case 519:
#line 1882 "src/p.y"
                         {
                        portset.parameters.sip.target = (yyvsp[0].string);
                  }
#line 5560 "src/y.tab.c"
    break;

  case 520:
#line 1885 "src/p.y"
                             {
                        portset.parameters.sip.maxforward = (yyvsp[0].number);
                  }
#line 5568 "src/y.tab.c"
    break;

  case 523:
#line 1894 "src/p.y"
                           {
                        portset.parameters.http.username = (yyvsp[0].string);
                  }
#line 5576 "src/y.tab.c"
    break;

  case 524:
#line 1897 "src/p.y"
                           {
                        portset.parameters.http.password = (yyvsp[0].string);
                  }
#line 5584 "src/y.tab.c"
    break;

  case 531:
#line 1908 "src/p.y"
                                         {
                        if ((yyvsp[0].number) < 0) {
                                yyerror2("The status value must be greater or equal to 0");
                        }
                        portset.parameters.http.operator = (yyvsp[-1].number);
                        portset.parameters.http.status = (yyvsp[0].number);
                        portset.parameters.http.hasStatus = true;
                  }
#line 5597 "src/y.tab.c"
    break;

  case 532:
#line 1918 "src/p.y"
                             {
                        portset.parameters.http.method = Http_Get;
                  }
#line 5605 "src/y.tab.c"
    break;

  case 533:
#line 1921 "src/p.y"
                              {
                        portset.parameters.http.method = Http_Head;
                  }
#line 5613 "src/y.tab.c"
    break;

  case 534:
#line 1926 "src/p.y"
                               {
                        portset.parameters.http.request = Util_urlEncode((yyvsp[0].string), false);
                        FREE((yyvsp[0].string));
                  }
#line 5622 "src/y.tab.c"
    break;

  case 535:
#line 1930 "src/p.y"
                                 {
                        portset.parameters.http.request = Util_urlEncode((yyvsp[0].string), false);
                        FREE((yyvsp[0].string));
                  }
#line 5631 "src/y.tab.c"
    break;

  case 536:
#line 1936 "src/p.y"
                                  {
                        portset.parameters.http.checksum = (yyvsp[0].string);
                  }
#line 5639 "src/y.tab.c"
    break;

  case 537:
#line 1941 "src/p.y"
                                    {
                        addhttpheader(&portset, Str_cat("Host:%s", (yyvsp[0].string)));
                        FREE((yyvsp[0].string));
                  }
#line 5648 "src/y.tab.c"
    break;

  case 539:
#line 1948 "src/p.y"
                                            {
                        addhttpheader(&portset, (yyvsp[0].string));
                 }
#line 5656 "src/y.tab.c"
    break;

  case 540:
#line 1953 "src/p.y"
                                {
                        (yyval.string) = (yyvsp[0].string);
                  }
#line 5664 "src/y.tab.c"
    break;

  case 543:
#line 1962 "src/p.y"
                         {
                        portset.parameters.radius.secret = (yyvsp[0].string);
                  }
#line 5672 "src/y.tab.c"
    break;

  case 546:
#line 1971 "src/p.y"
                           {
                        portset.parameters.apachestatus.username = (yyvsp[0].string);
                  }
#line 5680 "src/y.tab.c"
    break;

  case 547:
#line 1974 "src/p.y"
                           {
                        portset.parameters.apachestatus.password = (yyvsp[0].string);
                  }
#line 5688 "src/y.tab.c"
    break;

  case 548:
#line 1977 "src/p.y"
                               {
                        portset.parameters.apachestatus.path = (yyvsp[0].string);
                  }
#line 5696 "src/y.tab.c"
    break;

  case 549:
#line 1980 "src/p.y"
                                                   {
                        portset.parameters.apachestatus.loglimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.loglimit = (yyvsp[-1].number);
                  }
#line 5705 "src/y.tab.c"
    break;

  case 550:
#line 1984 "src/p.y"
                                                     {
                        portset.parameters.apachestatus.closelimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.closelimit = (yyvsp[-1].number);
                  }
#line 5714 "src/y.tab.c"
    break;

  case 551:
#line 1988 "src/p.y"
                                                   {
                        portset.parameters.apachestatus.dnslimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.dnslimit = (yyvsp[-1].number);
                  }
#line 5723 "src/y.tab.c"
    break;

  case 552:
#line 1992 "src/p.y"
                                                         {
                        portset.parameters.apachestatus.keepalivelimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.keepalivelimit = (yyvsp[-1].number);
                  }
#line 5732 "src/y.tab.c"
    break;

  case 553:
#line 1996 "src/p.y"
                                                     {
                        portset.parameters.apachestatus.replylimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.replylimit = (yyvsp[-1].number);
                  }
#line 5741 "src/y.tab.c"
    break;

  case 554:
#line 2000 "src/p.y"
                                                       {
                        portset.parameters.apachestatus.requestlimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.requestlimit = (yyvsp[-1].number);
                  }
#line 5750 "src/y.tab.c"
    break;

  case 555:
#line 2004 "src/p.y"
                                                     {
                        portset.parameters.apachestatus.startlimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.startlimit = (yyvsp[-1].number);
                  }
#line 5759 "src/y.tab.c"
    break;

  case 556:
#line 2008 "src/p.y"
                                                    {
                        portset.parameters.apachestatus.waitlimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.waitlimit = (yyvsp[-1].number);
                  }
#line 5768 "src/y.tab.c"
    break;

  case 557:
#line 2012 "src/p.y"
                                                        {
                        portset.parameters.apachestatus.gracefullimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.gracefullimit = (yyvsp[-1].number);
                  }
#line 5777 "src/y.tab.c"
    break;

  case 558:
#line 2016 "src/p.y"
                                                       {
                        portset.parameters.apachestatus.cleanuplimitOP = (yyvsp[-2].number);
                        portset.parameters.apachestatus.cleanuplimit = (yyvsp[-1].number);
                  }
#line 5786 "src/y.tab.c"
    break;

  case 559:
#line 2022 "src/p.y"
                                                                   {
                        addeventaction(&(nonexistset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addnonexist(&nonexistset);
                  }
#line 5795 "src/y.tab.c"
    break;

  case 560:
#line 2026 "src/p.y"
                                                               {
                        addeventaction(&(existset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addexist(&existset);
                  }
#line 5804 "src/y.tab.c"
    break;

  case 561:
#line 2033 "src/p.y"
                                                    {
                        addeventaction(&(pidset).action, (yyvsp[0].number), Action_Ignored);
                        addpid(&pidset);
                  }
#line 5813 "src/y.tab.c"
    break;

  case 562:
#line 2039 "src/p.y"
                                                     {
                        addeventaction(&(ppidset).action, (yyvsp[0].number), Action_Ignored);
                        addppid(&ppidset);
                  }
#line 5822 "src/y.tab.c"
    break;

  case 563:
#line 2045 "src/p.y"
                                                                                     {
                        uptimeset.operator = (yyvsp[-6].number);
                        uptimeset.uptime = ((unsigned long long)(yyvsp[-5].number) * (yyvsp[-4].number));
                        addeventaction(&(uptimeset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        adduptime(&uptimeset);
                  }
#line 5833 "src/y.tab.c"
    break;

  case 564:
#line 2053 "src/p.y"
                                                           {
                        responsetimeset.operator = (yyvsp[-2].number);
                        responsetimeset.limit = (yyvsp[-1].number);
                  }
#line 5842 "src/y.tab.c"
    break;

  case 565:
#line 2057 "src/p.y"
                                                      {
                        responsetimeset.operator = (yyvsp[-2].number);
                        responsetimeset.limit = (yyvsp[-1].number) * 1000;
                  }
#line 5851 "src/y.tab.c"
    break;

  case 566:
#line 2063 "src/p.y"
                               {
                        icmpset.count = (yyvsp[0].number);
                 }
#line 5859 "src/y.tab.c"
    break;

  case 567:
#line 2068 "src/p.y"
                              {
                        icmpset.size = (yyvsp[0].number);
                        if (icmpset.size < 8) {
                                yyerror2("The minimum ping size is 8 bytes");
                        } else if (icmpset.size > 1492) {
                                yyerror2("The maximum ping size is 1492 bytes");
                        }
                 }
#line 5872 "src/y.tab.c"
    break;

  case 568:
#line 2078 "src/p.y"
                                        {
                        icmpset.timeout = (yyvsp[-1].number) * 1000; // timeout is in milliseconds internally
                    }
#line 5880 "src/y.tab.c"
    break;

  case 569:
#line 2083 "src/p.y"
                                 {
                        _parseOutgoingAddress((yyvsp[0].string), &(icmpset.outgoing));
                  }
#line 5888 "src/y.tab.c"
    break;

  case 570:
#line 2088 "src/p.y"
                              {
                        (yyval.number) = Run.limits.stopTimeout;
                  }
#line 5896 "src/y.tab.c"
    break;

  case 571:
#line 2091 "src/p.y"
                                        {
                        (yyval.number) = (yyvsp[-1].number) * 1000; // milliseconds internally
                  }
#line 5904 "src/y.tab.c"
    break;

  case 572:
#line 2096 "src/p.y"
                              {
                        (yyval.number) = Run.limits.startTimeout;
                  }
#line 5912 "src/y.tab.c"
    break;

  case 573:
#line 2099 "src/p.y"
                                        {
                        (yyval.number) = (yyvsp[-1].number) * 1000; // milliseconds internally
                  }
#line 5920 "src/y.tab.c"
    break;

  case 574:
#line 2104 "src/p.y"
                              {
                        (yyval.number) = Run.limits.restartTimeout;
                  }
#line 5928 "src/y.tab.c"
    break;

  case 575:
#line 2107 "src/p.y"
                                        {
                        (yyval.number) = (yyvsp[-1].number) * 1000; // milliseconds internally
                  }
#line 5936 "src/y.tab.c"
    break;

  case 576:
#line 2112 "src/p.y"
                              {
                        (yyval.number) = Run.limits.programTimeout;
                  }
#line 5944 "src/y.tab.c"
    break;

  case 577:
#line 2115 "src/p.y"
                                        {
                        (yyval.number) = (yyvsp[-1].number) * 1000; // milliseconds internally
                  }
#line 5952 "src/y.tab.c"
    break;

  case 578:
#line 2120 "src/p.y"
                              {
                        (yyval.number) = Run.limits.networkTimeout;
                  }
#line 5960 "src/y.tab.c"
    break;

  case 579:
#line 2123 "src/p.y"
                                        {
                        (yyval.number) = (yyvsp[-1].number) * 1000; // net timeout is in milliseconds internally
                  }
#line 5968 "src/y.tab.c"
    break;

  case 580:
#line 2128 "src/p.y"
                                          {
                        portset.timeout = (yyvsp[-1].number) * 1000; // timeout is in milliseconds internally
                    }
#line 5976 "src/y.tab.c"
    break;

  case 581:
#line 2133 "src/p.y"
                               {
                        portset.retry = (yyvsp[0].number);
                  }
#line 5984 "src/y.tab.c"
    break;

  case 582:
#line 2138 "src/p.y"
                                                              {
                        actionrateset.count = (yyvsp[-5].number);
                        actionrateset.cycle = (yyvsp[-3].number);
                        addeventaction(&(actionrateset).action, (yyvsp[0].number), Action_Alert);
                        addactionrate(&actionrateset);
                  }
#line 5995 "src/y.tab.c"
    break;

  case 583:
#line 2144 "src/p.y"
                                                              {
                        actionrateset.count = (yyvsp[-5].number);
                        actionrateset.cycle = (yyvsp[-3].number);
                        addeventaction(&(actionrateset).action, Action_Unmonitor, Action_Alert);
                        addactionrate(&actionrateset);
                  }
#line 6006 "src/y.tab.c"
    break;

  case 584:
#line 2152 "src/p.y"
                                             {
                        seturlrequest((yyvsp[-1].number), (yyvsp[0].string));
                        FREE((yyvsp[0].string));
                  }
#line 6015 "src/y.tab.c"
    break;

  case 585:
#line 2158 "src/p.y"
                           { (yyval.number) = Operator_Equal; }
#line 6021 "src/y.tab.c"
    break;

  case 586:
#line 2159 "src/p.y"
                           { (yyval.number) = Operator_NotEqual; }
#line 6027 "src/y.tab.c"
    break;

  case 587:
#line 2162 "src/p.y"
                                                {
                        mailset.events = Event_All;
                        addmail((yyvsp[-2].string), &mailset, &current->maillist);
                  }
#line 6036 "src/y.tab.c"
    break;

  case 588:
#line 2166 "src/p.y"
                                                                        {
                        addmail((yyvsp[-5].string), &mailset, &current->maillist);
                  }
#line 6044 "src/y.tab.c"
    break;

  case 589:
#line 2169 "src/p.y"
                                                                            {
                        mailset.events = ~mailset.events;
                        addmail((yyvsp[-6].string), &mailset, &current->maillist);
                  }
#line 6053 "src/y.tab.c"
    break;

  case 590:
#line 2173 "src/p.y"
                              {
                        addmail((yyvsp[0].string), &mailset, &current->maillist);
                  }
#line 6061 "src/y.tab.c"
    break;

  case 591:
#line 2178 "src/p.y"
                                 { (yyval.string) = (yyvsp[0].string); }
#line 6067 "src/y.tab.c"
    break;

  case 592:
#line 2181 "src/p.y"
                                   { (yyval.string) = (yyvsp[0].string); }
#line 6073 "src/y.tab.c"
    break;

  case 595:
#line 2188 "src/p.y"
                                  { mailset.events |= Event_Action; }
#line 6079 "src/y.tab.c"
    break;

  case 596:
#line 2189 "src/p.y"
                                  { mailset.events |= Event_ByteIn; }
#line 6085 "src/y.tab.c"
    break;

  case 597:
#line 2190 "src/p.y"
                                  { mailset.events |= Event_ByteOut; }
#line 6091 "src/y.tab.c"
    break;

  case 598:
#line 2191 "src/p.y"
                                  { mailset.events |= Event_Checksum; }
#line 6097 "src/y.tab.c"
    break;

  case 599:
#line 2192 "src/p.y"
                                  { mailset.events |= Event_Connection; }
#line 6103 "src/y.tab.c"
    break;

  case 600:
#line 2193 "src/p.y"
                                  { mailset.events |= Event_Content; }
#line 6109 "src/y.tab.c"
    break;

  case 601:
#line 2194 "src/p.y"
                                  { mailset.events |= Event_Data; }
#line 6115 "src/y.tab.c"
    break;

  case 602:
#line 2195 "src/p.y"
                                  { mailset.events |= Event_Exec; }
#line 6121 "src/y.tab.c"
    break;

  case 603:
#line 2196 "src/p.y"
                                  { mailset.events |= Event_Exist; }
#line 6127 "src/y.tab.c"
    break;

  case 604:
#line 2197 "src/p.y"
                                  { mailset.events |= Event_FsFlag; }
#line 6133 "src/y.tab.c"
    break;

  case 605:
#line 2198 "src/p.y"
                                  { mailset.events |= Event_Gid; }
#line 6139 "src/y.tab.c"
    break;

  case 606:
#line 2199 "src/p.y"
                                  { mailset.events |= Event_Icmp; }
#line 6145 "src/y.tab.c"
    break;

  case 607:
#line 2200 "src/p.y"
                                  { mailset.events |= Event_Instance; }
#line 6151 "src/y.tab.c"
    break;

  case 608:
#line 2201 "src/p.y"
                                  { mailset.events |= Event_Invalid; }
#line 6157 "src/y.tab.c"
    break;

  case 609:
#line 2202 "src/p.y"
                                  { mailset.events |= Event_Link; }
#line 6163 "src/y.tab.c"
    break;

  case 610:
#line 2203 "src/p.y"
                                  { mailset.events |= Event_NonExist; }
#line 6169 "src/y.tab.c"
    break;

  case 611:
#line 2204 "src/p.y"
                                  { mailset.events |= Event_PacketIn; }
#line 6175 "src/y.tab.c"
    break;

  case 612:
#line 2205 "src/p.y"
                                  { mailset.events |= Event_PacketOut; }
#line 6181 "src/y.tab.c"
    break;

  case 613:
#line 2206 "src/p.y"
                                  { mailset.events |= Event_Permission; }
#line 6187 "src/y.tab.c"
    break;

  case 614:
#line 2207 "src/p.y"
                                  { mailset.events |= Event_Pid; }
#line 6193 "src/y.tab.c"
    break;

  case 615:
#line 2208 "src/p.y"
                                  { mailset.events |= Event_PPid; }
#line 6199 "src/y.tab.c"
    break;

  case 616:
#line 2209 "src/p.y"
                                  { mailset.events |= Event_Resource; }
#line 6205 "src/y.tab.c"
    break;

  case 617:
#line 2210 "src/p.y"
                                  { mailset.events |= Event_Saturation; }
#line 6211 "src/y.tab.c"
    break;

  case 618:
#line 2211 "src/p.y"
                                  { mailset.events |= Event_Size; }
#line 6217 "src/y.tab.c"
    break;

  case 619:
#line 2212 "src/p.y"
                                  { mailset.events |= Event_Speed; }
#line 6223 "src/y.tab.c"
    break;

  case 620:
#line 2213 "src/p.y"
                                  { mailset.events |= Event_Status; }
#line 6229 "src/y.tab.c"
    break;

  case 621:
#line 2214 "src/p.y"
                                  { mailset.events |= Event_Timeout; }
#line 6235 "src/y.tab.c"
    break;

  case 622:
#line 2215 "src/p.y"
                                  { mailset.events |= Event_Timestamp; }
#line 6241 "src/y.tab.c"
    break;

  case 623:
#line 2216 "src/p.y"
                                  { mailset.events |= Event_Uid; }
#line 6247 "src/y.tab.c"
    break;

  case 624:
#line 2217 "src/p.y"
                                  { mailset.events |= Event_Uptime; }
#line 6253 "src/y.tab.c"
    break;

  case 629:
#line 2228 "src/p.y"
                                         { mailset.from = (yyvsp[-1].address); }
#line 6259 "src/y.tab.c"
    break;

  case 630:
#line 2229 "src/p.y"
                                            { mailset.replyto = (yyvsp[-1].address); }
#line 6265 "src/y.tab.c"
    break;

  case 631:
#line 2230 "src/p.y"
                              { mailset.subject = (yyvsp[0].string); }
#line 6271 "src/y.tab.c"
    break;

  case 632:
#line 2231 "src/p.y"
                           { mailset.message = (yyvsp[0].string); }
#line 6277 "src/y.tab.c"
    break;

  case 633:
#line 2234 "src/p.y"
                                     {
                        current->every.type = Every_SkipCycles;
                        current->every.spec.cycle.counter = current->every.spec.cycle.number = (yyvsp[-1].number);
                 }
#line 6286 "src/y.tab.c"
    break;

  case 634:
#line 2238 "src/p.y"
                                 {
                        current->every.type = Every_Cron;
                        current->every.spec.cron = (yyvsp[0].string);
                 }
#line 6295 "src/y.tab.c"
    break;

  case 635:
#line 2242 "src/p.y"
                                    {
                        current->every.type = Every_NotInCron;
                        current->every.spec.cron = (yyvsp[0].string);
                 }
#line 6304 "src/y.tab.c"
    break;

  case 636:
#line 2248 "src/p.y"
                              {
                        current->mode = Monitor_Active;
                  }
#line 6312 "src/y.tab.c"
    break;

  case 637:
#line 2251 "src/p.y"
                               {
                        current->mode = Monitor_Passive;
                  }
#line 6320 "src/y.tab.c"
    break;

  case 638:
#line 2254 "src/p.y"
                              {
                        // Deprecated since monit 5.18
                        current->onreboot = Onreboot_Laststate;
                  }
#line 6329 "src/y.tab.c"
    break;

  case 639:
#line 2260 "src/p.y"
                                 {
                        current->onreboot = Onreboot_Start;
                  }
#line 6337 "src/y.tab.c"
    break;

  case 640:
#line 2263 "src/p.y"
                                   {
                        current->onreboot = Onreboot_Nostart;
                        current->monitor = Monitor_Not;
                  }
#line 6346 "src/y.tab.c"
    break;

  case 641:
#line 2267 "src/p.y"
                                     {
                        current->onreboot = Onreboot_Laststate;
                  }
#line 6354 "src/y.tab.c"
    break;

  case 642:
#line 2272 "src/p.y"
                                   {
                        addservicegroup((yyvsp[0].string));
                        FREE((yyvsp[0].string));
                  }
#line 6363 "src/y.tab.c"
    break;

  case 646:
#line 2286 "src/p.y"
                              { adddependant((yyvsp[0].string)); }
#line 6369 "src/y.tab.c"
    break;

  case 647:
#line 2289 "src/p.y"
                                                                                {
                        statusset.initialized = true;
                        statusset.operator = (yyvsp[-5].number);
                        statusset.return_value = (yyvsp[-4].number);
                        addeventaction(&(statusset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addstatus(&statusset);
                   }
#line 6381 "src/y.tab.c"
    break;

  case 648:
#line 2296 "src/p.y"
                                                       {
                        statusset.initialized = false;
                        statusset.operator = Operator_Changed;
                        statusset.return_value = 0;
                        addeventaction(&(statusset).action, (yyvsp[0].number), Action_Ignored);
                        addstatus(&statusset);
                   }
#line 6393 "src/y.tab.c"
    break;

  case 649:
#line 2305 "src/p.y"
                                                                             {
                        addeventaction(&(resourceset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addresource(&resourceset);
                   }
#line 6402 "src/y.tab.c"
    break;

  case 659:
#line 2324 "src/p.y"
                                                                            {
                        addeventaction(&(resourceset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addresource(&resourceset);
                   }
#line 6411 "src/y.tab.c"
    break;

  case 666:
#line 2340 "src/p.y"
                                             {
                        resourceset.resource_id = Resource_CpuPercent;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 6421 "src/y.tab.c"
    break;

  case 667:
#line 2345 "src/p.y"
                                                  {
                        resourceset.resource_id = Resource_CpuPercentTotal;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 6431 "src/y.tab.c"
    break;

  case 668:
#line 2352 "src/p.y"
                                                       {
                        resourceset.resource_id = (yyvsp[-3].number);
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 6441 "src/y.tab.c"
    break;

  case 669:
#line 2359 "src/p.y"
                          {
                        if (systeminfo.statisticsAvailable & Statistics_CpuUser)
                                (yyval.number) = Resource_CpuUser;
                        else
                                yywarning2("The CPU user usage statistics is not available on this system\n");
                  }
#line 6452 "src/y.tab.c"
    break;

  case 670:
#line 2365 "src/p.y"
                            {
                        if (systeminfo.statisticsAvailable & Statistics_CpuSystem)
                                (yyval.number) = Resource_CpuSystem;
                        else
                                yywarning2("The CPU system usage statistics is not available on this system\n");
                  }
#line 6463 "src/y.tab.c"
    break;

  case 671:
#line 2371 "src/p.y"
                          {
                        if (systeminfo.statisticsAvailable & Statistics_CpuIOWait)
                                (yyval.number) = Resource_CpuWait;
                        else
                                yywarning2("The CPU I/O wait usage statistics is not available on this system\n");
                  }
#line 6474 "src/y.tab.c"
    break;

  case 672:
#line 2377 "src/p.y"
                          {
                        if (systeminfo.statisticsAvailable & Statistics_CpuNice)
                                (yyval.number) = Resource_CpuNice;
                        else
                                yywarning2("The CPU nice usage statistics is not available on this system\n");
                  }
#line 6485 "src/y.tab.c"
    break;

  case 673:
#line 2383 "src/p.y"
                             {
                        if (systeminfo.statisticsAvailable & Statistics_CpuHardIRQ)
                                (yyval.number) = Resource_CpuHardIRQ;
                        else
                                yywarning2("The CPU hardware IRQ usage statistics is not available on this system\n");
                  }
#line 6496 "src/y.tab.c"
    break;

  case 674:
#line 2389 "src/p.y"
                             {
                        if (systeminfo.statisticsAvailable & Statistics_CpuSoftIRQ)
                                (yyval.number) = Resource_CpuSoftIRQ;
                        else
                                yywarning2("The CPU software IRQ usage statistics is not available on this system\n");
                  }
#line 6507 "src/y.tab.c"
    break;

  case 675:
#line 2395 "src/p.y"
                           {
                        if (systeminfo.statisticsAvailable & Statistics_CpuSteal)
                                (yyval.number) = Resource_CpuSteal;
                        else
                                yywarning2("The CPU steal usage statistics is not available on this system\n");
                  }
#line 6518 "src/y.tab.c"
    break;

  case 676:
#line 2401 "src/p.y"
                           {
                        if (systeminfo.statisticsAvailable & Statistics_CpuGuest)
                                (yyval.number) = Resource_CpuGuest;
                        else
                                yywarning2("The CPU guest usage statistics is not available on this system\n");
                  }
#line 6529 "src/y.tab.c"
    break;

  case 677:
#line 2407 "src/p.y"
                               {
                        if (systeminfo.statisticsAvailable & Statistics_CpuGuestNice)
                                (yyval.number) = Resource_CpuGuestNice;
                        else
                                yywarning2("The CPU guest nice usage statistics is not available on this system\n");
                  }
#line 6540 "src/y.tab.c"
    break;

  case 678:
#line 2413 "src/p.y"
                      {
                        (yyval.number) = Resource_CpuPercent;
                  }
#line 6548 "src/y.tab.c"
    break;

  case 679:
#line 2418 "src/p.y"
                                             {
                        resourceset.resource_id = Resource_MemoryKbyte;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real) * (yyvsp[0].number);
                  }
#line 6558 "src/y.tab.c"
    break;

  case 680:
#line 2423 "src/p.y"
                                                {
                        resourceset.resource_id = Resource_MemoryPercent;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 6568 "src/y.tab.c"
    break;

  case 681:
#line 2430 "src/p.y"
                                             {
                        resourceset.resource_id = Resource_MemoryKbyte;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real) * (yyvsp[0].number);
                  }
#line 6578 "src/y.tab.c"
    break;

  case 682:
#line 2435 "src/p.y"
                                                {
                        resourceset.resource_id = Resource_MemoryPercent;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 6588 "src/y.tab.c"
    break;

  case 683:
#line 2440 "src/p.y"
                                                  {
                        resourceset.resource_id = Resource_MemoryKbyteTotal;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real) * (yyvsp[0].number);
                  }
#line 6598 "src/y.tab.c"
    break;

  case 684:
#line 2445 "src/p.y"
                                                      {
                        resourceset.resource_id = Resource_MemoryPercentTotal;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 6608 "src/y.tab.c"
    break;

  case 685:
#line 2452 "src/p.y"
                                           {
                        resourceset.resource_id = Resource_SwapKbyte;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real) * (yyvsp[0].number);
                  }
#line 6618 "src/y.tab.c"
    break;

  case 686:
#line 2457 "src/p.y"
                                              {
                        resourceset.resource_id = Resource_SwapPercent;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].real);
                  }
#line 6628 "src/y.tab.c"
    break;

  case 687:
#line 2464 "src/p.y"
                                          {
                        resourceset.resource_id = Resource_Threads;
                        resourceset.operator = (yyvsp[-1].number);
                        resourceset.limit = (yyvsp[0].number);
                  }
#line 6638 "src/y.tab.c"
    break;

  case 688:
#line 2471 "src/p.y"
                                           {
                        resourceset.resource_id = Resource_Children;
                        resourceset.operator = (yyvsp[-1].number);
                        resourceset.limit = (yyvsp[0].number);
                  }
#line 6648 "src/y.tab.c"
    break;

  case 689:
#line 2478 "src/p.y"
                                                                {
                        switch ((yyvsp[-3].number)) {
                                case Resource_LoadAverage1m:
                                        resourceset.resource_id = (yyvsp[-2].number) > 1 ? Resource_LoadAveragePerCore1m : (yyvsp[-3].number);
                                        break;
                                case Resource_LoadAverage5m:
                                        resourceset.resource_id = (yyvsp[-2].number) > 1 ? Resource_LoadAveragePerCore5m : (yyvsp[-3].number);
                                        break;
                                case Resource_LoadAverage15m:
                                        resourceset.resource_id = (yyvsp[-2].number) > 1 ? Resource_LoadAveragePerCore15m : (yyvsp[-3].number);
                                        break;
                                default:
                                        resourceset.resource_id = (yyvsp[-3].number);
                                        break;
                        }
                        resourceset.operator = (yyvsp[-1].number);
                        resourceset.limit = (yyvsp[0].real);
                  }
#line 6671 "src/y.tab.c"
    break;

  case 690:
#line 2498 "src/p.y"
                            { (yyval.number) = Resource_LoadAverage1m; }
#line 6677 "src/y.tab.c"
    break;

  case 691:
#line 2499 "src/p.y"
                            { (yyval.number) = Resource_LoadAverage5m; }
#line 6683 "src/y.tab.c"
    break;

  case 692:
#line 2500 "src/p.y"
                            { (yyval.number) = Resource_LoadAverage15m; }
#line 6689 "src/y.tab.c"
    break;

  case 693:
#line 2503 "src/p.y"
                              { (yyval.number) = 1; }
#line 6695 "src/y.tab.c"
    break;

  case 694:
#line 2504 "src/p.y"
                              { (yyval.number) = systeminfo.cpu.count; }
#line 6701 "src/y.tab.c"
    break;

  case 695:
#line 2508 "src/p.y"
                                                       {
                        resourceset.resource_id = Resource_ReadBytes;
                        resourceset.operator = (yyvsp[-3].number);
                        resourceset.limit = (yyvsp[-2].real) * (yyvsp[-1].number);
                  }
#line 6711 "src/y.tab.c"
    break;

  case 696:
#line 2513 "src/p.y"
                                                            {
                        resourceset.resource_id = Resource_ReadBytesPhysical;
                        resourceset.operator = (yyvsp[-3].number);
                        resourceset.limit = (yyvsp[-2].real) * (yyvsp[-1].number);
                  }
#line 6721 "src/y.tab.c"
    break;

  case 697:
#line 2518 "src/p.y"
                                                      {
                        resourceset.resource_id = Resource_ReadOperations;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].number);
                  }
#line 6731 "src/y.tab.c"
    break;

  case 698:
#line 2525 "src/p.y"
                                                        {
                        resourceset.resource_id = Resource_WriteBytes;
                        resourceset.operator = (yyvsp[-3].number);
                        resourceset.limit = (yyvsp[-2].real) * (yyvsp[-1].number);
                  }
#line 6741 "src/y.tab.c"
    break;

  case 699:
#line 2530 "src/p.y"
                                                             {
                        resourceset.resource_id = Resource_WriteBytesPhysical;
                        resourceset.operator = (yyvsp[-3].number);
                        resourceset.limit = (yyvsp[-2].real) * (yyvsp[-1].number);
                  }
#line 6751 "src/y.tab.c"
    break;

  case 700:
#line 2535 "src/p.y"
                                                       {
                        resourceset.resource_id = Resource_WriteOperations;
                        resourceset.operator = (yyvsp[-2].number);
                        resourceset.limit = (yyvsp[-1].number);
                  }
#line 6761 "src/y.tab.c"
    break;

  case 701:
#line 2542 "src/p.y"
                       { (yyval.real) = (yyvsp[0].real); }
#line 6767 "src/y.tab.c"
    break;

  case 702:
#line 2543 "src/p.y"
                         { (yyval.real) = (float) (yyvsp[0].number); }
#line 6773 "src/y.tab.c"
    break;

  case 703:
#line 2546 "src/p.y"
                        { (yyval.number) = Timestamp_Default; }
#line 6779 "src/y.tab.c"
    break;

  case 704:
#line 2547 "src/p.y"
                        { (yyval.number) = Timestamp_Access; }
#line 6785 "src/y.tab.c"
    break;

  case 705:
#line 2548 "src/p.y"
                        { (yyval.number) = Timestamp_Change; }
#line 6791 "src/y.tab.c"
    break;

  case 706:
#line 2549 "src/p.y"
                        { (yyval.number) = Timestamp_Modification; }
#line 6797 "src/y.tab.c"
    break;

  case 707:
#line 2552 "src/p.y"
                                                                                            {
                        timestampset.type = (yyvsp[-7].number);
                        timestampset.operator = (yyvsp[-6].number);
                        timestampset.time = ((yyvsp[-5].number) * (yyvsp[-4].number));
                        addeventaction(&(timestampset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addtimestamp(&timestampset);
                  }
#line 6809 "src/y.tab.c"
    break;

  case 708:
#line 2559 "src/p.y"
                                                              {
                        timestampset.type = (yyvsp[-3].number);
                        timestampset.test_changes = true;
                        addeventaction(&(timestampset).action, (yyvsp[0].number), Action_Ignored);
                        addtimestamp(&timestampset);
                  }
#line 6820 "src/y.tab.c"
    break;

  case 709:
#line 2567 "src/p.y"
                                 { (yyval.number) = Operator_Equal; }
#line 6826 "src/y.tab.c"
    break;

  case 710:
#line 2568 "src/p.y"
                                 { (yyval.number) = Operator_Greater; }
#line 6832 "src/y.tab.c"
    break;

  case 711:
#line 2569 "src/p.y"
                                 { (yyval.number) = Operator_GreaterOrEqual; }
#line 6838 "src/y.tab.c"
    break;

  case 712:
#line 2570 "src/p.y"
                                 { (yyval.number) = Operator_Less; }
#line 6844 "src/y.tab.c"
    break;

  case 713:
#line 2571 "src/p.y"
                                 { (yyval.number) = Operator_LessOrEqual; }
#line 6850 "src/y.tab.c"
    break;

  case 714:
#line 2572 "src/p.y"
                                 { (yyval.number) = Operator_Equal; }
#line 6856 "src/y.tab.c"
    break;

  case 715:
#line 2573 "src/p.y"
                                 { (yyval.number) = Operator_NotEqual; }
#line 6862 "src/y.tab.c"
    break;

  case 716:
#line 2574 "src/p.y"
                                 { (yyval.number) = Operator_Changed; }
#line 6868 "src/y.tab.c"
    break;

  case 717:
#line 2577 "src/p.y"
                              { (yyval.number) = Time_Second; }
#line 6874 "src/y.tab.c"
    break;

  case 718:
#line 2578 "src/p.y"
                              { (yyval.number) = Time_Second; }
#line 6880 "src/y.tab.c"
    break;

  case 719:
#line 2579 "src/p.y"
                              { (yyval.number) = Time_Minute; }
#line 6886 "src/y.tab.c"
    break;

  case 720:
#line 2580 "src/p.y"
                              { (yyval.number) = Time_Hour; }
#line 6892 "src/y.tab.c"
    break;

  case 721:
#line 2581 "src/p.y"
                              { (yyval.number) = Time_Day; }
#line 6898 "src/y.tab.c"
    break;

  case 722:
#line 2582 "src/p.y"
                              { (yyval.number) = Time_Month; }
#line 6904 "src/y.tab.c"
    break;

  case 723:
#line 2585 "src/p.y"
                              { (yyval.number) = Time_Minute; }
#line 6910 "src/y.tab.c"
    break;

  case 724:
#line 2586 "src/p.y"
                              { (yyval.number) = Time_Hour; }
#line 6916 "src/y.tab.c"
    break;

  case 725:
#line 2587 "src/p.y"
                              { (yyval.number) = Time_Day; }
#line 6922 "src/y.tab.c"
    break;

  case 726:
#line 2589 "src/p.y"
                              { (yyval.number) = Time_Second; }
#line 6928 "src/y.tab.c"
    break;

  case 727:
#line 2590 "src/p.y"
                              { (yyval.number) = Time_Second; }
#line 6934 "src/y.tab.c"
    break;

  case 728:
#line 2592 "src/p.y"
                              {
                        repeat = 0;
                  }
#line 6942 "src/y.tab.c"
    break;

  case 729:
#line 2595 "src/p.y"
                                     {
                        repeat = 1;
                  }
#line 6950 "src/y.tab.c"
    break;

  case 730:
#line 2598 "src/p.y"
                                            {
                        if ((yyvsp[-1].number) < 0) {
                                yyerror2("The number of repeat cycles must be greater or equal to 0");
                        }
                        repeat = (yyvsp[-1].number);
                  }
#line 6961 "src/y.tab.c"
    break;

  case 731:
#line 2606 "src/p.y"
                        {
                        (yyval.number) = Action_Alert;
                  }
#line 6969 "src/y.tab.c"
    break;

  case 732:
#line 2609 "src/p.y"
                                           {
                        (yyval.number) = Action_Exec;
                  }
#line 6977 "src/y.tab.c"
    break;

  case 733:
#line 2613 "src/p.y"
                  {
                        (yyval.number) = Action_Exec;
                  }
#line 6985 "src/y.tab.c"
    break;

  case 734:
#line 2616 "src/p.y"
                          {
                        (yyval.number) = Action_Restart;
                  }
#line 6993 "src/y.tab.c"
    break;

  case 735:
#line 2619 "src/p.y"
                        {
                        (yyval.number) = Action_Start;
                  }
#line 7001 "src/y.tab.c"
    break;

  case 736:
#line 2622 "src/p.y"
                       {
                        (yyval.number) = Action_Stop;
                  }
#line 7009 "src/y.tab.c"
    break;

  case 737:
#line 2625 "src/p.y"
                            {
                        (yyval.number) = Action_Unmonitor;
                  }
#line 7017 "src/y.tab.c"
    break;

  case 738:
#line 2630 "src/p.y"
                         {
                        (yyval.number) = (yyvsp[0].number);
                        if ((yyvsp[0].number) == Action_Exec && command) {
                                repeat1 = repeat;
                                repeat = 0;
                                command1 = command;
                                command = NULL;
                        }
                  }
#line 7031 "src/y.tab.c"
    break;

  case 739:
#line 2641 "src/p.y"
                         {
                        (yyval.number) = (yyvsp[0].number);
                        if ((yyvsp[0].number) == Action_Exec && command) {
                                repeat2 = repeat;
                                repeat = 0;
                                command2 = command;
                                command = NULL;
                        }
                  }
#line 7045 "src/y.tab.c"
    break;

  case 740:
#line 2652 "src/p.y"
                               {
                        if ((yyvsp[-1].number) < 1 || (unsigned long)(yyvsp[-1].number) > BITMAP_MAX) {
                                yyerror2("The number of cycles must be between 1 and %zu", BITMAP_MAX);
                        } else {
                                rate.count  = (yyvsp[-1].number);
                                rate.cycles = (yyvsp[-1].number);
                        }
                  }
#line 7058 "src/y.tab.c"
    break;

  case 741:
#line 2662 "src/p.y"
                                      {
                        if ((yyvsp[-1].number) < 1 || (unsigned long)(yyvsp[-1].number) > BITMAP_MAX) {
                                yyerror2("The number of cycles must be between 1 and %zu", BITMAP_MAX);
                        } else if ((yyvsp[-2].number) < 1 || (yyvsp[-2].number) > (yyvsp[-1].number)) {
                                yyerror2("The number of events must be between 1 and less then poll cycles");
                        } else {
                                rate.count  = (yyvsp[-2].number);
                                rate.cycles = (yyvsp[-1].number);
                        }
                  }
#line 7073 "src/y.tab.c"
    break;

  case 743:
#line 2675 "src/p.y"
                              {
                        rate1.count = rate.count;
                        rate1.cycles = rate.cycles;
                        reset_rateset(&rate);
                  }
#line 7083 "src/y.tab.c"
    break;

  case 744:
#line 2680 "src/p.y"
                               {
                        rate1.count = rate.count;
                        rate1.cycles = rate.cycles;
                        reset_rateset(&rate);
                }
#line 7093 "src/y.tab.c"
    break;

  case 746:
#line 2688 "src/p.y"
                              {
                        rate2.count = rate.count;
                        rate2.cycles = rate.cycles;
                        reset_rateset(&rate);
                  }
#line 7103 "src/y.tab.c"
    break;

  case 747:
#line 2693 "src/p.y"
                               {
                        rate2.count = rate.count;
                        rate2.cycles = rate.cycles;
                        reset_rateset(&rate);
                }
#line 7113 "src/y.tab.c"
    break;

  case 748:
#line 2700 "src/p.y"
                               {
                        (yyval.number) = Action_Alert;
                  }
#line 7121 "src/y.tab.c"
    break;

  case 749:
#line 2703 "src/p.y"
                               {
                        (yyval.number) = (yyvsp[0].number);
                  }
#line 7129 "src/y.tab.c"
    break;

  case 750:
#line 2706 "src/p.y"
                                                       {
                        (yyval.number) = (yyvsp[0].number);
                  }
#line 7137 "src/y.tab.c"
    break;

  case 751:
#line 2709 "src/p.y"
                                                    {
                        (yyval.number) = (yyvsp[0].number);
                  }
#line 7145 "src/y.tab.c"
    break;

  case 752:
#line 2712 "src/p.y"
                                                       {
                        (yyval.number) = (yyvsp[0].number);
                  }
#line 7153 "src/y.tab.c"
    break;

  case 753:
#line 2717 "src/p.y"
                               {
                        (yyval.number) = Action_Alert;
                  }
#line 7161 "src/y.tab.c"
    break;

  case 754:
#line 2720 "src/p.y"
                               {
                        (yyval.number) = (yyvsp[0].number);
                  }
#line 7169 "src/y.tab.c"
    break;

  case 755:
#line 2723 "src/p.y"
                                                    {
                        (yyval.number) = (yyvsp[0].number);
                  }
#line 7177 "src/y.tab.c"
    break;

  case 756:
#line 2728 "src/p.y"
                                                                                  {
                        addeventaction(&(checksumset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addchecksum(&checksumset);
                  }
#line 7186 "src/y.tab.c"
    break;

  case 757:
#line 2733 "src/p.y"
                                   {
                        snprintf(checksumset.hash, sizeof(checksumset.hash), "%s", (yyvsp[-4].string));
                        FREE((yyvsp[-4].string));
                        addeventaction(&(checksumset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addchecksum(&checksumset);
                  }
#line 7197 "src/y.tab.c"
    break;

  case 758:
#line 2739 "src/p.y"
                                                                  {
                        checksumset.test_changes = true;
                        addeventaction(&(checksumset).action, (yyvsp[0].number), Action_Ignored);
                        addchecksum(&checksumset);
                  }
#line 7207 "src/y.tab.c"
    break;

  case 759:
#line 2745 "src/p.y"
                              { checksumset.type = Hash_Unknown; }
#line 7213 "src/y.tab.c"
    break;

  case 760:
#line 2746 "src/p.y"
                              { checksumset.type = Hash_Md5; }
#line 7219 "src/y.tab.c"
    break;

  case 761:
#line 2747 "src/p.y"
                              { checksumset.type = Hash_Sha1; }
#line 7225 "src/y.tab.c"
    break;

  case 762:
#line 2750 "src/p.y"
                                                                               {
                        filesystemset.resource = Resource_Inode;
                        filesystemset.operator = (yyvsp[-5].number);
                        filesystemset.limit_absolute = (yyvsp[-4].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7237 "src/y.tab.c"
    break;

  case 763:
#line 2757 "src/p.y"
                                                                                      {
                        filesystemset.resource = Resource_Inode;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_percent = (yyvsp[-5].real);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7249 "src/y.tab.c"
    break;

  case 764:
#line 2764 "src/p.y"
                                                                                     {
                        filesystemset.resource = Resource_InodeFree;
                        filesystemset.operator = (yyvsp[-5].number);
                        filesystemset.limit_absolute = (yyvsp[-4].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7261 "src/y.tab.c"
    break;

  case 765:
#line 2771 "src/p.y"
                                                                                            {
                        filesystemset.resource = Resource_InodeFree;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_percent = (yyvsp[-5].real);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7273 "src/y.tab.c"
    break;

  case 766:
#line 2780 "src/p.y"
                                                                                   {
                        filesystemset.resource = Resource_Space;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (yyvsp[-5].real) * (yyvsp[-4].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7285 "src/y.tab.c"
    break;

  case 767:
#line 2787 "src/p.y"
                                                                                      {
                        filesystemset.resource = Resource_Space;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_percent = (yyvsp[-5].real);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7297 "src/y.tab.c"
    break;

  case 768:
#line 2794 "src/p.y"
                                                                                         {
                        filesystemset.resource = Resource_SpaceFree;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (yyvsp[-5].real) * (yyvsp[-4].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7309 "src/y.tab.c"
    break;

  case 769:
#line 2801 "src/p.y"
                                                                                            {
                        filesystemset.resource = Resource_SpaceFree;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_percent = (yyvsp[-5].real);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7321 "src/y.tab.c"
    break;

  case 770:
#line 2810 "src/p.y"
                                                                                              {
                        filesystemset.resource = Resource_ReadBytes;
                        filesystemset.operator = (yyvsp[-7].number);
                        filesystemset.limit_absolute = (yyvsp[-6].real) * (yyvsp[-5].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7333 "src/y.tab.c"
    break;

  case 771:
#line 2817 "src/p.y"
                                                                                        {
                        filesystemset.resource = Resource_ReadOperations;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (yyvsp[-5].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7345 "src/y.tab.c"
    break;

  case 772:
#line 2826 "src/p.y"
                                                                                               {
                        filesystemset.resource = Resource_WriteBytes;
                        filesystemset.operator = (yyvsp[-7].number);
                        filesystemset.limit_absolute = (yyvsp[-6].real) * (yyvsp[-5].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7357 "src/y.tab.c"
    break;

  case 773:
#line 2833 "src/p.y"
                                                                                         {
                        filesystemset.resource = Resource_WriteOperations;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (yyvsp[-5].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7369 "src/y.tab.c"
    break;

  case 774:
#line 2842 "src/p.y"
                                                                                                 {
                        filesystemset.resource = Resource_ServiceTime;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (yyvsp[-5].number);
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7381 "src/y.tab.c"
    break;

  case 775:
#line 2849 "src/p.y"
                                                                                           {
                        filesystemset.resource = Resource_ServiceTime;
                        filesystemset.operator = (yyvsp[-6].number);
                        filesystemset.limit_absolute = (yyvsp[-5].real) * 1000;
                        addeventaction(&(filesystemset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addfilesystem(&filesystemset);
                  }
#line 7393 "src/y.tab.c"
    break;

  case 776:
#line 2858 "src/p.y"
                                                       {
                        addeventaction(&(fsflagset).action, (yyvsp[0].number), Action_Ignored);
                        addfsflag(&fsflagset);
                  }
#line 7402 "src/y.tab.c"
    break;

  case 777:
#line 2864 "src/p.y"
                               { (yyval.number) = Unit_Byte; }
#line 7408 "src/y.tab.c"
    break;

  case 778:
#line 2865 "src/p.y"
                               { (yyval.number) = Unit_Byte; }
#line 7414 "src/y.tab.c"
    break;

  case 779:
#line 2866 "src/p.y"
                               { (yyval.number) = Unit_Kilobyte; }
#line 7420 "src/y.tab.c"
    break;

  case 780:
#line 2867 "src/p.y"
                               { (yyval.number) = Unit_Megabyte; }
#line 7426 "src/y.tab.c"
    break;

  case 781:
#line 2868 "src/p.y"
                               { (yyval.number) = Unit_Gigabyte; }
#line 7432 "src/y.tab.c"
    break;

  case 782:
#line 2871 "src/p.y"
                                                                                  {
                        permset.perm = check_perm((yyvsp[-4].number));
                        addeventaction(&(permset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addperm(&permset);
                  }
#line 7442 "src/y.tab.c"
    break;

  case 783:
#line 2876 "src/p.y"
                                                                            {
                        permset.test_changes = true;
                        addeventaction(&(permset).action, (yyvsp[-1].number), Action_Ignored);
                        addperm(&permset);
                  }
#line 7452 "src/y.tab.c"
    break;

  case 784:
#line 2883 "src/p.y"
                                                                 {
                        matchset.not = (yyvsp[-4].number) == Operator_Equal ? false : true;
                        matchset.ignore = false;
                        matchset.match_path = (yyvsp[-3].string);
                        matchset.match_string = NULL;
                        addmatchpath(&matchset, (yyvsp[0].number));
                        FREE((yyvsp[-3].string));
                  }
#line 7465 "src/y.tab.c"
    break;

  case 785:
#line 2891 "src/p.y"
                                                                   {
                        matchset.not = (yyvsp[-4].number) == Operator_Equal ? false : true;
                        matchset.ignore = false;
                        matchset.match_path = NULL;
                        matchset.match_string = (yyvsp[-3].string);
                        addmatch(&matchset, (yyvsp[0].number), 0);
                  }
#line 7477 "src/y.tab.c"
    break;

  case 786:
#line 2898 "src/p.y"
                                                  {
                        matchset.not = (yyvsp[-1].number) == Operator_Equal ? false : true;
                        matchset.ignore = true;
                        matchset.match_path = (yyvsp[0].string);
                        matchset.match_string = NULL;
                        addmatchpath(&matchset, Action_Ignored);
                        FREE((yyvsp[0].string));
                  }
#line 7490 "src/y.tab.c"
    break;

  case 787:
#line 2906 "src/p.y"
                                                    {
                        matchset.not = (yyvsp[-1].number) == Operator_Equal ? false : true;
                        matchset.ignore = true;
                        matchset.match_path = NULL;
                        matchset.match_string = (yyvsp[0].string);
                        addmatch(&matchset, Action_Ignored, 0);
                  }
#line 7502 "src/y.tab.c"
    break;

  case 788:
#line 2914 "src/p.y"
                                                                {
                        matchset.ignore = false;
                        matchset.match_path = (yyvsp[-3].string);
                        matchset.match_string = NULL;
                        addmatchpath(&matchset, (yyvsp[0].number));
                        FREE((yyvsp[-3].string));
                  }
#line 7514 "src/y.tab.c"
    break;

  case 789:
#line 2921 "src/p.y"
                                                                  {
                        matchset.ignore = false;
                        matchset.match_path = NULL;
                        matchset.match_string = (yyvsp[-3].string);
                        addmatch(&matchset, (yyvsp[0].number), 0);
                  }
#line 7525 "src/y.tab.c"
    break;

  case 790:
#line 2927 "src/p.y"
                                                 {
                        matchset.ignore = true;
                        matchset.match_path = (yyvsp[0].string);
                        matchset.match_string = NULL;
                        addmatchpath(&matchset, Action_Ignored);
                        FREE((yyvsp[0].string));
                  }
#line 7537 "src/y.tab.c"
    break;

  case 791:
#line 2934 "src/p.y"
                                                   {
                        matchset.ignore = true;
                        matchset.match_path = NULL;
                        matchset.match_string = (yyvsp[0].string);
                        addmatch(&matchset, Action_Ignored, 0);
                  }
#line 7548 "src/y.tab.c"
    break;

  case 792:
#line 2942 "src/p.y"
                              {
                        matchset.not = false;
                  }
#line 7556 "src/y.tab.c"
    break;

  case 793:
#line 2945 "src/p.y"
                      {
                        matchset.not = true;
                  }
#line 7564 "src/y.tab.c"
    break;

  case 794:
#line 2951 "src/p.y"
                                                                                   {
                        sizeset.operator = (yyvsp[-6].number);
                        sizeset.size = ((unsigned long long)(yyvsp[-5].number) * (yyvsp[-4].number));
                        addeventaction(&(sizeset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addsize(&sizeset);
                  }
#line 7575 "src/y.tab.c"
    break;

  case 795:
#line 2957 "src/p.y"
                                                     {
                        sizeset.test_changes = true;
                        addeventaction(&(sizeset).action, (yyvsp[0].number), Action_Ignored);
                        addsize(&sizeset);
                  }
#line 7585 "src/y.tab.c"
    break;

  case 796:
#line 2964 "src/p.y"
                                                                           {
                        uidset.uid = get_uid((yyvsp[-4].string), 0);
                        addeventaction(&(uidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        current->uid = adduid(&uidset);
                        FREE((yyvsp[-4].string));
                  }
#line 7596 "src/y.tab.c"
    break;

  case 797:
#line 2970 "src/p.y"
                                                                           {
                    uidset.uid = get_uid(NULL, (yyvsp[-4].number));
                    addeventaction(&(uidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                    current->uid = adduid(&uidset);
                  }
#line 7606 "src/y.tab.c"
    break;

  case 798:
#line 2977 "src/p.y"
                                                                            {
                        uidset.uid = get_uid((yyvsp[-4].string), 0);
                        addeventaction(&(uidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        current->euid = adduid(&uidset);
                        FREE((yyvsp[-4].string));
                  }
#line 7617 "src/y.tab.c"
    break;

  case 799:
#line 2983 "src/p.y"
                                                                            {
                        uidset.uid = get_uid(NULL, (yyvsp[-4].number));
                        addeventaction(&(uidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        current->euid = adduid(&uidset);
                  }
#line 7627 "src/y.tab.c"
    break;

  case 800:
#line 2990 "src/p.y"
                                                                                          {
                        addsecurityattribute((yyvsp[-4].string), (yyvsp[-1].number), (yyvsp[0].number));
                  }
#line 7635 "src/y.tab.c"
    break;

  case 801:
#line 2993 "src/p.y"
                                                                                        {
                        addsecurityattribute((yyvsp[-4].string), (yyvsp[-1].number), (yyvsp[0].number));
                  }
#line 7643 "src/y.tab.c"
    break;

  case 802:
#line 2998 "src/p.y"
                                                                                               {
                        if (systeminfo.statisticsAvailable & Statistics_FiledescriptorsPerSystem)
                                addfiledescriptors((yyvsp[-5].number), false, (long long)(yyvsp[-4].number), -1., (yyvsp[-1].number), (yyvsp[0].number));
                        else
                                yywarning("The per-system filedescriptors statistics is not available on this system\n");
                  }
#line 7654 "src/y.tab.c"
    break;

  case 803:
#line 3004 "src/p.y"
                                                                                                {
                        if (systeminfo.statisticsAvailable & Statistics_FiledescriptorsPerSystem)
                                addfiledescriptors((yyvsp[-6].number), false, -1LL, (yyvsp[-5].real), (yyvsp[-1].number), (yyvsp[0].number));
                        else
                                yywarning("The per-system filedescriptors statistics is not available on this system\n");
                  }
#line 7665 "src/y.tab.c"
    break;

  case 804:
#line 3012 "src/p.y"
                                                                                                {
                        if (systeminfo.statisticsAvailable & Statistics_FiledescriptorsPerProcess)
                                addfiledescriptors((yyvsp[-5].number), false, (long long)(yyvsp[-4].number), -1., (yyvsp[-1].number), (yyvsp[0].number));
                        else
                                yywarning("The per-process filedescriptors statistics is not available on this system\n");
                  }
#line 7676 "src/y.tab.c"
    break;

  case 805:
#line 3018 "src/p.y"
                                                                                                {
                        if (systeminfo.statisticsAvailable & Statistics_FiledescriptorsPerProcessMax)
                                addfiledescriptors((yyvsp[-6].number), false, -1LL, (yyvsp[-5].real), (yyvsp[-1].number), (yyvsp[0].number));
                        else
                                yywarning("The per-process filedescriptors maximum is not exposed on this system, so we cannot compute usage %%, please use the test with absolute value\n");
                  }
#line 7687 "src/y.tab.c"
    break;

  case 806:
#line 3026 "src/p.y"
                                                                                                           {
                        if (systeminfo.statisticsAvailable & Statistics_FiledescriptorsPerProcess)
                                addfiledescriptors((yyvsp[-5].number), true, (long long)(yyvsp[-4].number), -1., (yyvsp[-1].number), (yyvsp[0].number));
                        else
                                yywarning("The per-process filedescriptors statistics is not available on this system\n");
                  }
#line 7698 "src/y.tab.c"
    break;

  case 807:
#line 3034 "src/p.y"
                                                                           {
                        gidset.gid = get_gid((yyvsp[-4].string), 0);
                        addeventaction(&(gidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        current->gid = addgid(&gidset);
                        FREE((yyvsp[-4].string));
                  }
#line 7709 "src/y.tab.c"
    break;

  case 808:
#line 3040 "src/p.y"
                                                                           {
                        gidset.gid = get_gid(NULL, (yyvsp[-4].number));
                        addeventaction(&(gidset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        current->gid = addgid(&gidset);
                  }
#line 7719 "src/y.tab.c"
    break;

  case 809:
#line 3047 "src/p.y"
                                                                  { /* Deprecated */
                        addeventaction(&(linkstatusset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addlinkstatus(current, &linkstatusset);
                  }
#line 7728 "src/y.tab.c"
    break;

  case 810:
#line 3051 "src/p.y"
                                                                {
                        linkstatusset.check_invers = false;
                        addeventaction(&(linkstatusset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addlinkstatus(current, &linkstatusset);
                  }
#line 7738 "src/y.tab.c"
    break;

  case 811:
#line 3056 "src/p.y"
                                                              {
                        linkstatusset.check_invers = true;
                        addeventaction(&(linkstatusset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addlinkstatus(current, &linkstatusset);
                  }
#line 7748 "src/y.tab.c"
    break;

  case 812:
#line 3063 "src/p.y"
                                                                   {
                        addeventaction(&(linkspeedset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addlinkspeed(current, &linkspeedset);
                  }
#line 7757 "src/y.tab.c"
    break;

  case 813:
#line 3068 "src/p.y"
                                                                                           {
                        linksaturationset.operator = (yyvsp[-6].number);
                        linksaturationset.limit = (unsigned long long)(yyvsp[-5].number);
                        addeventaction(&(linksaturationset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addlinksaturation(current, &linksaturationset);
                  }
#line 7768 "src/y.tab.c"
    break;

  case 814:
#line 3076 "src/p.y"
                                                                                                 {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-6].number) * (yyvsp[-5].number));
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadbyteslist), &bandwidthset);
                  }
#line 7781 "src/y.tab.c"
    break;

  case 815:
#line 3084 "src/p.y"
                                                                                                     {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-6].number) * (yyvsp[-5].number));
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadbyteslist), &bandwidthset);
                  }
#line 7794 "src/y.tab.c"
    break;

  case 816:
#line 3092 "src/p.y"
                                                                                                            {
                        bandwidthset.operator = (yyvsp[-8].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-7].number) * (yyvsp[-6].number));
                        bandwidthset.rangecount = (yyvsp[-5].number);
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadbyteslist), &bandwidthset);
                  }
#line 7807 "src/y.tab.c"
    break;

  case 817:
#line 3100 "src/p.y"
                                                                                                   {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-6].number);
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadpacketslist), &bandwidthset);
                  }
#line 7820 "src/y.tab.c"
    break;

  case 818:
#line 3108 "src/p.y"
                                                                                                       {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-6].number);
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadpacketslist), &bandwidthset);
                  }
#line 7833 "src/y.tab.c"
    break;

  case 819:
#line 3116 "src/p.y"
                                                                                                              {
                        bandwidthset.operator = (yyvsp[-8].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-7].number);
                        bandwidthset.rangecount = (yyvsp[-5].number);
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->uploadpacketslist), &bandwidthset);
                  }
#line 7846 "src/y.tab.c"
    break;

  case 820:
#line 3126 "src/p.y"
                                                                                                   {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-6].number) * (yyvsp[-5].number));
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadbyteslist), &bandwidthset);
                  }
#line 7859 "src/y.tab.c"
    break;

  case 821:
#line 3134 "src/p.y"
                                                                                                       {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-6].number) * (yyvsp[-5].number));
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadbyteslist), &bandwidthset);
                  }
#line 7872 "src/y.tab.c"
    break;

  case 822:
#line 3142 "src/p.y"
                                                                                                              {
                        bandwidthset.operator = (yyvsp[-8].number);
                        bandwidthset.limit = ((unsigned long long)(yyvsp[-7].number) * (yyvsp[-6].number));
                        bandwidthset.rangecount = (yyvsp[-5].number);
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadbyteslist), &bandwidthset);
                  }
#line 7885 "src/y.tab.c"
    break;

  case 823:
#line 3150 "src/p.y"
                                                                                                     {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-6].number);
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadpacketslist), &bandwidthset);
                  }
#line 7898 "src/y.tab.c"
    break;

  case 824:
#line 3158 "src/p.y"
                                                                                                         {
                        bandwidthset.operator = (yyvsp[-7].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-6].number);
                        bandwidthset.rangecount = 1;
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadpacketslist), &bandwidthset);
                  }
#line 7911 "src/y.tab.c"
    break;

  case 825:
#line 3166 "src/p.y"
                                                                                                                {
                        bandwidthset.operator = (yyvsp[-8].number);
                        bandwidthset.limit = (unsigned long long)(yyvsp[-7].number);
                        bandwidthset.rangecount = (yyvsp[-5].number);
                        bandwidthset.range = (yyvsp[-4].number);
                        addeventaction(&(bandwidthset).action, (yyvsp[-1].number), (yyvsp[0].number));
                        addbandwidth(&(current->downloadpacketslist), &bandwidthset);
                  }
#line 7924 "src/y.tab.c"
    break;

  case 826:
#line 3176 "src/p.y"
                                { (yyval.number) = ICMP_ECHO; }
#line 7930 "src/y.tab.c"
    break;

  case 827:
#line 3179 "src/p.y"
                                        { mailset.reminder = 0; }
#line 7936 "src/y.tab.c"
    break;

  case 828:
#line 3180 "src/p.y"
                                        { mailset.reminder = (yyvsp[0].number); }
#line 7942 "src/y.tab.c"
    break;

  case 829:
#line 3181 "src/p.y"
                                        { mailset.reminder = (yyvsp[-1].number); }
#line 7948 "src/y.tab.c"
    break;


#line 7952 "src/y.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[+*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 3184 "src/p.y"



/* -------------------------------------------------------- Parser interface */


/**
 * Syntactic error routine
 *
 * This routine is automatically called by the lexer!
 */
void yyerror(const char *s, ...) {
        ASSERT(s);
        char *msg = NULL;
        va_list ap;
        va_start(ap, s);
        msg = Str_vcat(s, ap);
        va_end(ap);
        Log_error("%s:%i: %s '%s'\n", currentfile, lineno, msg, yytext);
        cfg_errflag++;
        FREE(msg);
}


/**
 * Syntactical warning routine
 */
void yywarning(const char *s, ...) {
        ASSERT(s);
        char *msg = NULL;
        va_list ap;
        va_start(ap, s);
        msg = Str_vcat(s, ap);
        va_end(ap);
        Log_warning("%s:%i: %s '%s'\n", currentfile, lineno, msg, yytext);
        FREE(msg);
}


/**
 * Argument error routine
 */
void yyerror2(const char *s, ...) {
        ASSERT(s);
        char *msg = NULL;
        va_list ap;
        va_start(ap, s);
        msg = Str_vcat(s, ap);
        va_end(ap);
        Log_error("%s:%i: %s '%s'\n", argcurrentfile, arglineno, msg, argyytext);
        cfg_errflag++;
        FREE(msg);
}


/**
 * Argument warning routine
 */
void yywarning2(const char *s, ...) {
        ASSERT(s);
        char *msg = NULL;
        va_list ap;
        va_start(ap, s);
        msg = Str_vcat(s, ap);
        va_end(ap);
        Log_warning("%s:%i: %s '%s'\n", argcurrentfile, arglineno, msg, argyytext);
        FREE(msg);
}


/*
 * The Parser hook - start parsing the control file
 * Returns true if parsing succeeded, otherwise false
 */
bool parse(char *controlfile) {
        ASSERT(controlfile);

        if ((yyin = fopen(controlfile,"r")) == (FILE *)NULL) {
                Log_error("Cannot open the control file '%s' -- %s\n", controlfile, STRERROR);
                return false;
        }

        currentfile = Str_dup(controlfile);

        available_statistics(&systeminfo);

        /*
         * Creation of the global service list is synchronized
         */
        LOCK(Run.mutex)
        {
                preparse();
                yyparse();
                fclose(yyin);
                postparse();
        }
        END_LOCK;

        FREE(currentfile);

        if (argyytext != NULL)
                FREE(argyytext);

        /*
         * Secure check the monitrc file. The run control file must have the
         * same uid as the REAL uid of this process, it must have permissions
         * no greater than 700 and it must not be a symbolic link.
         */
        if (! file_checkStat(controlfile, "control file", S_IRUSR|S_IWUSR|S_IXUSR))
                return false;

        return cfg_errflag == 0;
}


/* ----------------------------------------------------------------- Private */


/**
 * Initialize objects used by the parser.
 */
static void preparse() {
        servicelist = tail = current = NULL;
        /* Set instance incarnation ID */
        time(&Run.incarnation);
        /* Reset lexer */
        buffer_stack_ptr            = 0;
        lineno                      = 1;
        arglineno                   = 1;
        argcurrentfile              = NULL;
        argyytext                   = NULL;
        /* Reset parser */
        Run.limits.sendExpectBuffer  = LIMIT_SENDEXPECTBUFFER;
        Run.limits.fileContentBuffer = LIMIT_FILECONTENTBUFFER;
        Run.limits.httpContentBuffer = LIMIT_HTTPCONTENTBUFFER;
        Run.limits.programOutput     = LIMIT_PROGRAMOUTPUT;
        Run.limits.networkTimeout    = LIMIT_NETWORKTIMEOUT;
        Run.limits.programTimeout    = LIMIT_PROGRAMTIMEOUT;
        Run.limits.stopTimeout       = LIMIT_STOPTIMEOUT;
        Run.limits.startTimeout      = LIMIT_STARTTIMEOUT;
        Run.limits.restartTimeout    = LIMIT_RESTARTTIMEOUT;
        Run.onreboot                 = Onreboot_Start;
        Run.mmonitcredentials        = NULL;
        Run.httpd.flags              = Httpd_Disabled | Httpd_Signature;
        Run.httpd.credentials        = NULL;
        memset(&(Run.httpd.socket), 0, sizeof(Run.httpd.socket));
        Run.mailserver_timeout       = SMTP_TIMEOUT;
        Run.eventlist_dir            = NULL;
        Run.eventlist_slots          = -1;
        Run.system                   = NULL;
        Run.mmonits                  = NULL;
        Run.maillist                 = NULL;
        Run.mailservers              = NULL;
        Run.MailFormat.from          = NULL;
        Run.MailFormat.replyto       = NULL;
        Run.MailFormat.subject       = NULL;
        Run.MailFormat.message       = NULL;
        depend_list                  = NULL;
        Run.flags |= Run_HandlerInit | Run_MmonitCredentials;
        for (int i = 0; i <= Handler_Max; i++)
                Run.handler_queue[i] = 0;

        /*
         * Initialize objects
         */
        reset_uidset();
        reset_gidset();
        reset_statusset();
        reset_sizeset();
        reset_mailset();
        reset_sslset();
        reset_mailserverset();
        reset_mmonitset();
        reset_responsetimeset();
        reset_portset();
        reset_permset();
        reset_icmpset();
        reset_linkstatusset();
        reset_linkspeedset();
        reset_linksaturationset();
        reset_bandwidthset();
        reset_rateset(&rate);
        reset_rateset(&rate1);
        reset_rateset(&rate2);
        reset_filesystemset();
        reset_resourceset();
        reset_checksumset();
        reset_timestampset();
        reset_actionrateset();
}


/*
 * Check that values are reasonable after parsing
 */
static void postparse() {
        if (cfg_errflag)
                return;

        /* If defined - add the last service to the service list */
        if (current) {
                addservice(current);
                current = NULL;
        }

        /* Check that we do not start monit in daemon mode without having a poll time */
        if (! Run.polltime && ((Run.flags & Run_Daemon) || (Run.flags & Run_Foreground))) {
                Log_error("Poll time is invalid or not defined. Please define poll time in the control file\nas a number (> 0)  or use the -d option when starting monit\n");
                cfg_errflag++;
        }

        if (Run.files.log)
                Run.flags |= Run_Log;

        /* Add the default general system service if not specified explicitly: service name default to hostname */
        if (! Run.system) {
                char hostname[STRLEN];
                if (gethostname(hostname, sizeof(hostname))) {
                        Log_error("Cannot get system hostname -- please add 'check system <name>'\n");
                        cfg_errflag++;
                }
                if (Util_existService(hostname)) {
                        Log_error("'check system' not defined in control file, failed to add automatic configuration (service name %s is used already) -- please add 'check system <name>' manually\n", hostname);
                        cfg_errflag++;
                }
                Run.system = createservice(Service_System, Str_dup(hostname), NULL, check_system);
                addservice(Run.system);
        }
        addeventaction(&(Run.system->action_MONIT_START), Action_Start, Action_Ignored);
        addeventaction(&(Run.system->action_MONIT_STOP), Action_Stop,  Action_Ignored);

        if (Run.mmonits) {
                if (Run.httpd.flags & Httpd_Net) {
                        if (Run.flags & Run_MmonitCredentials) {
                                Auth_T c;
                                for (c = Run.httpd.credentials; c; c = c->next) {
                                        if (c->digesttype == Digest_Cleartext && ! c->is_readonly) {
                                                Run.mmonitcredentials = c;
                                                break;
                                        }
                                }
                                if (! Run.mmonitcredentials)
                                        Log_warning("M/Monit registration with credentials enabled, but no suitable credentials found in monit configuration file -- please add 'allow user:password' option to 'set httpd' statement\n");
                        }
                } else if (Run.httpd.flags & Httpd_Unix) {
                        Log_warning("M/Monit enabled but Monit httpd is using unix socket -- please change 'set httpd' statement to use TCP port in order to be able to manage services on Monit\n");
                } else {
                        Log_warning("M/Monit enabled but no httpd allowed -- please add 'set httpd' statement\n");
                }
        }

        /* Check the sanity of any dependency graph */
        check_depend();

#if defined HAVE_OPENSSL && defined OPENSSL_FIPS
        Ssl_setFipsMode(Run.flags & Run_FipsEnabled);
#endif

        Processor_setHttpPostLimit();
}


static bool _parseOutgoingAddress(const char *ip, Outgoing_T *outgoing) {
        struct addrinfo *result, hints = {.ai_flags = AI_NUMERICHOST};
        int status = getaddrinfo(ip, NULL, &hints, &result);
        if (status == 0) {
                outgoing->ip = (char *)ip;
                outgoing->addrlen = result->ai_addrlen;
                memcpy(&(outgoing->addr), result->ai_addr, result->ai_addrlen);
                freeaddrinfo(result);
                return true;
        } else {
                yyerror2("IP address parsing failed for %s -- %s", ip, status == EAI_SYSTEM ? STRERROR : gai_strerror(status));
        }
        return false;
}


/*
 * Create a new service object and add any current objects to the
 * service list.
 */
static Service_T createservice(Service_Type type, char *name, char *value, State_Type (*check)(Service_T s)) {
        ASSERT(name);

        check_name(name);

        if (current)
                addservice(current);

        NEW(current);
        current->type = type;
        switch (type) {
                case Service_Directory:
                        NEW(current->inf.directory);
                        break;
                case Service_Fifo:
                        NEW(current->inf.fifo);
                        break;
                case Service_File:
                        NEW(current->inf.file);
                        break;
                case Service_Filesystem:
                        NEW(current->inf.filesystem);
                        break;
                case Service_Net:
                        NEW(current->inf.net);
                        break;
                case Service_Process:
                        NEW(current->inf.process);
                        break;
                default:
                        break;
        }
        Util_resetInfo(current);

        if (type == Service_Program) {
                NEW(current->program);
                current->program->args = command;
                command = NULL;
                current->program->timeout = Run.limits.programTimeout;
        }

        /* Set default values */
        current->onrebootRestored = false;
        current->mode     = Monitor_Active;
        current->monitor  = Monitor_Init;
        current->onreboot = Run.onreboot;
        current->name     = name;
        current->name_urlescaped = Util_urlEncode(name, false);
        current->name_htmlescaped = escapeHTML(StringBuffer_create(16), name);
        current->check    = check;
        current->path     = value;

        /* Initialize general event handlers */
        addeventaction(&(current)->action_DATA,     Action_Alert,     Action_Alert);
        addeventaction(&(current)->action_EXEC,     Action_Alert,     Action_Alert);
        addeventaction(&(current)->action_INVALID,  Action_Restart,   Action_Alert);

        /* Initialize internal event handlers */
        addeventaction(&(current)->action_ACTION,       Action_Alert, Action_Ignored);

        gettimeofday(&current->collected, NULL);

        return current;
}


/*
 * Add a service object to the servicelist
 */
static void addservice(Service_T s) {
        ASSERT(s);

        // Test sanity check
        switch (s->type) {
                case Service_Host:
                        // Verify that a remote service has a port or an icmp list
                        if (! s->portlist && ! s->icmplist) {
                                Log_error("'check host' statement is incomplete: Please specify a port number to test\n or an icmp test at the remote host: '%s'\n", s->name);
                                cfg_errflag++;
                        }
                        break;
                case Service_Program:
                        // Verify that a program test has a status test
                        if (! s->statuslist) {
                                Log_error("'check program %s' is incomplete: Please add an 'if status != n' test\n", s->name);
                                cfg_errflag++;
                        }
                        char program[PATH_MAX];
                        strncpy(program, s->program->args->arg[0], sizeof(program) - 1);
                        // Require that the program exist before creating the Command object
                        if (File_isExecutable(program)) {
                                s->program->C = Command_new(program, NULL);
                                for (int i = 1; i < s->program->args->length; i++) {
                                        Command_appendArgument(s->program->C, s->program->args->arg[i]);
                                        snprintf(program + strlen(program), sizeof(program) - strlen(program) - 1, " %s", s->program->args->arg[i]);
                                }
                                s->path = Str_dup(program);
                                if (s->program->args->has_uid)
                                        Command_setUid(s->program->C, s->program->args->uid);
                                if (s->program->args->has_gid)
                                        Command_setGid(s->program->C, s->program->args->gid);
                                // Set environment
                                Command_setEnv(s->program->C, "MONIT_SERVICE", s->name);
                        } else {
                                Log_error("A 'check program' statement requires the program to exist '%s'\n", program);
                                cfg_errflag++;
                        }
                        break;
                case Service_Net:
                        if (! s->linkstatuslist) {
                                // Add link status test if not defined
                                addeventaction(&(linkstatusset).action, Action_Alert, Action_Alert);
                                addlinkstatus(s, &linkstatusset);
                        }
                        break;
                case Service_Filesystem:
                        if (! s->nonexistlist && ! s->existlist) {
                                // Add non-existence test if not defined
                                addeventaction(&(nonexistset).action, Action_Restart, Action_Alert);
                                addnonexist(&nonexistset);
                        }
                        if (! s->fsflaglist) {
                                // Add filesystem flags change test if not defined
                                addeventaction(&(fsflagset).action, Action_Alert, Action_Ignored);
                                addfsflag(&fsflagset);
                        }
                        break;
                case Service_Directory:
                case Service_Fifo:
                case Service_File:
                case Service_Process:
                        if (! s->nonexistlist && ! s->existlist) {
                                // Add existence test if not defined
                                addeventaction(&(nonexistset).action, Action_Restart, Action_Alert);
                                addnonexist(&nonexistset);
                        }
                        break;
                default:
                        break;
        }

        /* Add the service to the end of the service list */
        if (tail != NULL) {
                tail->next = s;
                tail->next_conf = s;
        } else {
                servicelist = s;
                servicelist_conf = s;
        }
        tail = s;
}


/*
 * Add entry to service group list
 */
static void addservicegroup(char *name) {
        ServiceGroup_T g;

        ASSERT(name);

        /* Check if service group with the same name is defined already */
        for (g = servicegrouplist; g; g = g->next)
                if (IS(g->name, name))
                        break;

        if (! g) {
                NEW(g);
                g->name = Str_dup(name);
                g->members = List_new();
                g->next = servicegrouplist;
                servicegrouplist = g;
        }

        List_append(g->members, current);
}


/*
 * Add a dependant entry to the current service dependant list
 */
static void adddependant(char *dependant) {
        Dependant_T d;

        ASSERT(dependant);

        NEW(d);

        if (current->dependantlist)
                d->next = current->dependantlist;

        d->dependant = dependant;
        d->dependant_urlescaped = Util_urlEncode(dependant, false);
        d->dependant_htmlescaped = escapeHTML(StringBuffer_create(16), dependant);
        current->dependantlist = d;

}


/*
 * Add the given mailaddress with the appropriate alert notification
 * values and mail attributes to the given mailinglist.
 */
static void addmail(char *mailto, Mail_T f, Mail_T *l) {
        Mail_T m;

        ASSERT(mailto);

        NEW(m);
        m->to       = mailto;
        m->from     = f->from;
        m->replyto  = f->replyto;
        m->subject  = f->subject;
        m->message  = f->message;
        m->events   = f->events;
        m->reminder = f->reminder;

        m->next = *l;
        *l = m;

        reset_mailset();
}


/*
 * Add the given portset to the current service's portlist
 */
static void addport(Port_T *list, Port_T port) {
        ASSERT(port);

        if (port->protocol->check == check_radius && port->type != Socket_Udp)
                yyerror("Radius protocol test supports UDP only");

        Port_T p;
        NEW(p);
        p->is_available       = Connection_Init;
        p->check_invers       = port->check_invers;
        p->type               = port->type;
        p->socket             = port->socket;
        p->family             = port->family;
        p->action             = port->action;
        p->timeout            = port->timeout;
        p->retry              = port->retry;
        p->protocol           = port->protocol;
        p->hostname           = port->hostname;
        p->url_request        = port->url_request;
        p->outgoing           = port->outgoing;

        if (p->family == Socket_Unix) {
                p->target.unix.pathname = port->target.unix.pathname;
        } else {
                p->target.net.port = port->target.net.port;
                if (sslset.flags) {
#ifdef HAVE_OPENSSL
                        p->target.net.ssl.certificate.minimumDays = port->target.net.ssl.certificate.minimumDays;
                        if (sslset.flags && (p->target.net.port == 25 || p->target.net.port == 143 || p->target.net.port == 587))
                                sslset.flags = SSL_StartTLS;
                        _setSSLOptions(&(p->target.net.ssl.options));
#else
                        yyerror("SSL check cannot be activated -- Monit was not built with SSL support");
#endif
                }
        }
        memcpy(&p->parameters, &port->parameters, sizeof(port->parameters));

        if (p->protocol->check == check_http) {
                if (p->parameters.http.checksum) {
                        cleanup_hash_string(p->parameters.http.checksum);
                        if (strlen(p->parameters.http.checksum) == 32)
                                p->parameters.http.hashtype = Hash_Md5;
                        else if (strlen(p->parameters.http.checksum) == 40)
                                p->parameters.http.hashtype = Hash_Sha1;
                        else
                                yyerror2("invalid checksum [%s]", p->parameters.http.checksum);
                } else {
                        p->parameters.http.hashtype = Hash_Unknown;
                }
                if (! p->parameters.http.method) {
                        p->parameters.http.method = Http_Get;
                } else if (p->parameters.http.method == Http_Head) {
                        // Sanity check: if content or checksum test is used, the method Http_Head is not allowed, as we need the content
                        if ((p->url_request && p->url_request->regex) || p->parameters.http.checksum) {
                                yyerror2("if response content or checksum test is enabled, the HEAD method is not allowed");
                        }
                }
        } else if (p->protocol->check == check_mysql) {
                if (p->parameters.mysql.rsaChecksum) {
                        if (! p->parameters.mysql.username)
                                yyerror2("the rsakey checksum test requires credentials to be defined");
                        if (p->target.net.ssl.options.flags != SSL_Disabled)
                                yyerror2("the rsakey checksum test can be used just with unsecured mysql protocol");
                }
        }

        p->responsetime.limit    = responsetimeset.limit;
        p->responsetime.current  = responsetimeset.current;
        p->responsetime.operator = responsetimeset.operator;

        p->next = *list;
        *list = p;

        reset_sslset();
        reset_responsetimeset();
        reset_portset();

}


static void addhttpheader(Port_T port, const char *header) {
        if (! port->parameters.http.headers) {
                port->parameters.http.headers = List_new();
        }
        if (Str_startsWith(header, "Connection:") && ! Str_sub(header, "close")) {
                yywarning("We don't recommend setting the Connection header. Monit will always close the connection even if 'keep-alive' is set\n");
        }
        List_append(port->parameters.http.headers, (char *)header);
}


/*
 * Add a new resource object to the current service resource list
 */
static void addresource(Resource_T rr) {
        ASSERT(rr);
        if (Run.flags & Run_ProcessEngineEnabled) {
                Resource_T r;
                NEW(r);
                r->resource_id = rr->resource_id;
                r->limit       = rr->limit;
                r->action      = rr->action;
                r->operator    = rr->operator;
                r->next        = current->resourcelist;
                current->resourcelist = r;
        } else {
                yywarning("Cannot activate service check. The process status engine was disabled. On certain systems you must run monit as root to utilize this feature)\n");
        }
        reset_resourceset();
}


/*
 * Add a new file object to the current service timestamp list
 */
static void addtimestamp(Timestamp_T ts) {
        ASSERT(ts);

        Timestamp_T t;
        NEW(t);
        t->type         = ts->type;
        t->operator     = ts->operator;
        t->time         = ts->time;
        t->action       = ts->action;
        t->test_changes = ts->test_changes;

        t->next = current->timestamplist;
        current->timestamplist = t;

        reset_timestampset();
}


/*
 * Add a new object to the current service actionrate list
 */
static void addactionrate(ActionRate_T ar) {
        ActionRate_T a;

        ASSERT(ar);

        if (ar->count > ar->cycle)
                yyerror2("The number of restarts must be less than poll cycles");
        if (ar->count <= 0 || ar->cycle <= 0)
                yyerror2("Zero or negative values not allowed in a action rate statement");

        NEW(a);
        a->count  = ar->count;
        a->cycle  = ar->cycle;
        a->action = ar->action;

        a->next = current->actionratelist;
        current->actionratelist = a;

        reset_actionrateset();
}



/*
 * Add a new Size object to the current service size list
 */
static void addsize(Size_T ss) {
        Size_T s;
        struct stat buf;

        ASSERT(ss);

        NEW(s);
        s->operator     = ss->operator;
        s->size         = ss->size;
        s->action       = ss->action;
        s->test_changes = ss->test_changes;
        /* Get the initial size for future comparison, if the file exists */
        if (s->test_changes) {
                s->initialized = ! stat(current->path, &buf);
                if (s->initialized)
                        s->size = (unsigned long long)buf.st_size;
        }

        s->next = current->sizelist;
        current->sizelist = s;

        reset_sizeset();
}


/*
 * Add a new Uptime object to the current service uptime list
 */
static void adduptime(Uptime_T uu) {
        Uptime_T u;

        ASSERT(uu);

        NEW(u);
        u->operator = uu->operator;
        u->uptime = uu->uptime;
        u->action = uu->action;

        u->next = current->uptimelist;
        current->uptimelist = u;

        reset_uptimeset();
}


/*
 * Add a new Pid object to the current service pid list
 */
static void addpid(Pid_T pp) {
        ASSERT(pp);

        Pid_T p;
        NEW(p);
        p->action = pp->action;

        p->next = current->pidlist;
        current->pidlist = p;

        reset_pidset();
}


/*
 * Add a new PPid object to the current service ppid list
 */
static void addppid(Pid_T pp) {
        ASSERT(pp);

        Pid_T p;
        NEW(p);
        p->action = pp->action;

        p->next = current->ppidlist;
        current->ppidlist = p;

        reset_ppidset();
}


/*
 * Add a new Fsflag object to the current service fsflag list
 */
static void addfsflag(FsFlag_T ff) {
        ASSERT(ff);

        FsFlag_T f;
        NEW(f);
        f->action = ff->action;

        f->next = current->fsflaglist;
        current->fsflaglist = f;

        reset_fsflagset();
}


/*
 * Add a new Nonexist object to the current service list
 */
static void addnonexist(NonExist_T ff) {
        ASSERT(ff);

        NonExist_T f;
        NEW(f);
        f->action = ff->action;

        f->next = current->nonexistlist;
        current->nonexistlist = f;

        reset_nonexistset();
}


static void addexist(Exist_T rule) {
        ASSERT(rule);
        Exist_T r;
        NEW(r);
        r->action = rule->action;
        r->next = current->existlist;
        current->existlist = r;
        reset_existset();
}


/*
 * Set Checksum object in the current service
 */
static void addchecksum(Checksum_T cs) {
        ASSERT(cs);

        cs->initialized = true;

        if (STR_UNDEF(cs->hash)) {
                if (cs->type == Hash_Unknown)
                        cs->type = Hash_Default;
                if (! (Checksum_getChecksum(current->path, cs->type, cs->hash, sizeof(cs->hash)))) {
                        /* If the file doesn't exist, set dummy value */
                        snprintf(cs->hash, sizeof(cs->hash), cs->type == Hash_Md5 ? "00000000000000000000000000000000" : "0000000000000000000000000000000000000000");
                        cs->initialized = false;
                        yywarning2("Cannot compute a checksum for file %s", current->path);
                }
        }

        int len = cleanup_hash_string(cs->hash);
        if (cs->type == Hash_Unknown) {
                if (len == 32) {
                        cs->type = Hash_Md5;
                } else if (len == 40) {
                        cs->type = Hash_Sha1;
                } else {
                        yyerror2("Unknown checksum type [%s] for file %s", cs->hash, current->path);
                        reset_checksumset();
                        return;
                }
        } else if ((cs->type == Hash_Md5 && len != 32) || (cs->type == Hash_Sha1 && len != 40)) {
                yyerror2("Invalid checksum [%s] for file %s", cs->hash, current->path);
                reset_checksumset();
                return;
        }

        Checksum_T c;
        NEW(c);
        c->type         = cs->type;
        c->test_changes = cs->test_changes;
        c->initialized  = cs->initialized;
        c->action       = cs->action;
        snprintf(c->hash, sizeof(c->hash), "%s", cs->hash);

        current->checksum = c;

        reset_checksumset();

}


/*
 * Set Perm object in the current service
 */
static void addperm(Perm_T ps) {
        ASSERT(ps);

        Perm_T p;
        NEW(p);
        p->action = ps->action;
        p->test_changes = ps->test_changes;
        if (p->test_changes) {
                if (! File_exist(current->path))
                        DEBUG("The path '%s' used in the PERMISSION statement refer to a non-existing object\n", current->path);
                else if ((p->perm = File_mod(current->path)) < 0)
                        yyerror2("Cannot get the timestamp for '%s'", current->path);
                else
                        p->perm &= 07777;
        } else {
                p->perm = ps->perm;
        }
        current->perm = p;
        reset_permset();
}


static void addlinkstatus(Service_T s, LinkStatus_T L) {
        ASSERT(L);

        LinkStatus_T l;

        // Sanity check: we don't support link up/down tests mix
        for (l = s->linkstatuslist; l; l = l->next) {
                if (l->check_invers != L->check_invers)
                        yyerror2("Mixing link up and down tests is not supported");
        }
                        
        if (L->check_invers)
                s->inverseStatus = true;

        NEW(l);
        l->check_invers = L->check_invers;
        l->action = L->action;

        l->next = s->linkstatuslist;
        s->linkstatuslist = l;

        reset_linkstatusset();
}


static void addlinkspeed(Service_T s, LinkSpeed_T L) {
        ASSERT(L);

        LinkSpeed_T l;
        NEW(l);
        l->action = L->action;

        l->next = s->linkspeedlist;
        s->linkspeedlist = l;

        reset_linkspeedset();
}


static void addlinksaturation(Service_T s, LinkSaturation_T L) {
        ASSERT(L);

        LinkSaturation_T l;
        NEW(l);
        l->operator = L->operator;
        l->limit = L->limit;
        l->action = L->action;

        l->next = s->linksaturationlist;
        s->linksaturationlist = l;

        reset_linksaturationset();
}


/*
 * Return Bandwidth object
 */
static void addbandwidth(Bandwidth_T *list, Bandwidth_T b) {
        ASSERT(list);
        ASSERT(b);

        if (b->rangecount * b->range > 24 * Time_Hour) {
                yyerror2("Maximum range for total test is 24 hours");
        } else if (b->range == Time_Minute && b->rangecount > 60) {
                yyerror2("Maximum value for [minute(s)] unit is 60");
        } else if (b->range == Time_Hour && b->rangecount > 24) {
                yyerror2("Maximum value for [hour(s)] unit is 24");
        } else if (b->range == Time_Day && b->rangecount > 1) {
                yyerror2("Maximum value for [day(s)] unit is 1");
        } else {
                if (b->range == Time_Day) {
                        // translate last day -> last 24 hours
                        b->rangecount = 24;
                        b->range = Time_Hour;
                }
                Bandwidth_T bandwidth;
                NEW(bandwidth);
                bandwidth->operator = b->operator;
                bandwidth->limit = b->limit;
                bandwidth->rangecount = b->rangecount;
                bandwidth->range = b->range;
                bandwidth->action = b->action;
                bandwidth->next = *list;
                *list = bandwidth;
        }
        reset_bandwidthset();
}


static void appendmatch(Match_T *list, Match_T item) {
        if (*list) {
                /* Find the end of the list (keep the same patterns order as in the config file) */
                Match_T last;
                for (last = *list; last->next; last = last->next)
                        ;
                last->next = item;
        } else {
                *list = item;
        }
}


/*
 * Set Match object in the current service
 */
static void addmatch(Match_T ms, int actionnumber, int linenumber) {
        Match_T m;

        ASSERT(ms);

        NEW(m);
        NEW(m->regex_comp);

        m->match_string = ms->match_string;
        m->match_path   = ms->match_path ? Str_dup(ms->match_path) : NULL;
        m->action       = ms->action;
        m->not          = ms->not;
        m->ignore       = ms->ignore;
        m->next         = NULL;

        addeventaction(&(m->action), actionnumber, Action_Ignored);

        int reg_return = regcomp(m->regex_comp, ms->match_string, REG_NOSUB|REG_EXTENDED);

        if (reg_return != 0) {
                char errbuf[STRLEN];
                regerror(reg_return, ms->regex_comp, errbuf, STRLEN);
                if (m->match_path != NULL)
                        yyerror2("Regex parsing error: %s on line %i of", errbuf, linenumber);
                else
                        yyerror2("Regex parsing error: %s", errbuf);
        }
        appendmatch(m->ignore ? &current->matchignorelist : &current->matchlist, m);
}


static void addmatchpath(Match_T ms, Action_Type actionnumber) {
        ASSERT(ms->match_path);

        FILE *handle = fopen(ms->match_path, "r");
        if (handle == NULL) {
                yyerror2("Cannot read regex match file (%s)", ms->match_path);
                return;
        }

        // The addeventaction() called from addmatch() will reset the command1 to NULL, but we need to duplicate the command for each line, thus need to save it here
        command_t savecommand = command1;
        for (int linenumber = 1; ! feof(handle); linenumber++) {
                char buf[2048];

                if (! fgets(buf, sizeof(buf), handle))
                        continue;

                size_t len = strlen(buf);

                if (len == 0 || buf[0] == '\n')
                        continue;

                if (buf[len - 1] == '\n')
                        buf[len - 1] = 0;

                ms->match_string = Str_dup(buf);

                if (actionnumber == Action_Exec) {
                        if (command1 == NULL) {
                                ASSERT(savecommand);
                                command1 = copycommand(savecommand);
                        }
                }

                addmatch(ms, actionnumber, linenumber);
        }
        if (actionnumber == Action_Exec && savecommand)
                gccmd(&savecommand);

        fclose(handle);
}


/*
 * Set exit status test object in the current service
 */
static void addstatus(Status_T status) {
        Status_T s;
        ASSERT(status);
        NEW(s);
        s->initialized = status->initialized;
        s->return_value = status->return_value;
        s->operator = status->operator;
        s->action = status->action;
        s->next = current->statuslist;
        current->statuslist = s;

        reset_statusset();
}


/*
 * Set Uid object in the current service
 */
static Uid_T adduid(Uid_T u) {
        ASSERT(u);

        Uid_T uid;
        NEW(uid);
        uid->uid = u->uid;
        uid->action = u->action;
        reset_uidset();
        return uid;
}


/*
 * Set Gid object in the current service
 */
static Gid_T addgid(Gid_T g) {
        ASSERT(g);

        Gid_T gid;
        NEW(gid);
        gid->gid = g->gid;
        gid->action = g->action;
        reset_gidset();
        return gid;
}


/*
 * Add a new filesystem to the current service's filesystem list
 */
static void addfilesystem(FileSystem_T ds) {
        FileSystem_T dev;

        ASSERT(ds);

        NEW(dev);
        dev->resource           = ds->resource;
        dev->operator           = ds->operator;
        dev->limit_absolute     = ds->limit_absolute;
        dev->limit_percent      = ds->limit_percent;
        dev->action             = ds->action;

        dev->next               = current->filesystemlist;
        current->filesystemlist = dev;

        reset_filesystemset();

}


/*
 * Add a new icmp object to the current service's icmp list
 */
static void addicmp(Icmp_T is) {
        Icmp_T icmp;

        ASSERT(is);

        NEW(icmp);
        icmp->family        = is->family;
        icmp->type          = is->type;
        icmp->size          = is->size;
        icmp->count         = is->count;
        icmp->timeout       = is->timeout;
        icmp->action        = is->action;
        icmp->outgoing      = is->outgoing;
        icmp->check_invers  = is->check_invers;
        icmp->is_available  = Connection_Init;

        icmp->responsetime.limit    = responsetimeset.limit;
        icmp->responsetime.current  = responsetimeset.current;
        icmp->responsetime.operator = responsetimeset.operator;

        icmp->next          = current->icmplist;
        current->icmplist   = icmp;

        reset_responsetimeset();
        reset_icmpset();
}


/*
 * Set EventAction object
 */
static void addeventaction(EventAction_T *_ea, Action_Type failed, Action_Type succeeded) {
        EventAction_T ea;

        ASSERT(_ea);

        NEW(ea);
        NEW(ea->failed);
        NEW(ea->succeeded);

        ea->failed->id = failed;
        ea->failed->repeat = repeat1;
        ea->failed->count = rate1.count;
        ea->failed->cycles = rate1.cycles;
        if (failed == Action_Exec) {
                ASSERT(command1);
                ea->failed->exec = command1;
                command1 = NULL;
        }

        ea->succeeded->id = succeeded;
        ea->succeeded->repeat = repeat2;
        ea->succeeded->count = rate2.count;
        ea->succeeded->cycles = rate2.cycles;
        if (succeeded == Action_Exec) {
                ASSERT(command2);
                ea->succeeded->exec = command2;
                command2 = NULL;
        }
        *_ea = ea;
        reset_rateset(&rate);
        reset_rateset(&rate1);
        reset_rateset(&rate2);
        repeat = repeat1 = repeat2 = 0;
}


/*
 * Add a generic protocol handler to
 */
static void addgeneric(Port_T port, char *send, char *expect) {
        Generic_T g = port->parameters.generic.sendexpect;
        if (! g) {
                NEW(g);
                port->parameters.generic.sendexpect = g;
        } else {
                while (g->next)
                        g = g->next;
                NEW(g->next);
                g = g->next;
        }
        if (send) {
                g->send = send;
                g->expect = NULL;
        } else if (expect) {
                int reg_return;
                NEW(g->expect);
                reg_return = regcomp(g->expect, expect, REG_NOSUB|REG_EXTENDED);
                FREE(expect);
                if (reg_return != 0) {
                        char errbuf[STRLEN];
                        regerror(reg_return, g->expect, errbuf, STRLEN);
                        yyerror2("Regex parsing error: %s", errbuf);
                }
                g->send = NULL;
        }
}


/*
 * Add the current command object to the current service object's
 * start or stop program.
 */
static void addcommand(int what, unsigned int timeout) {

        switch (what) {
                case START:   current->start = command; break;
                case STOP:    current->stop = command; break;
                case RESTART: current->restart = command; break;
        }

        command->timeout = timeout;

        command = NULL;

}


/*
 * Add a new argument to the argument list
 */
static void addargument(char *argument) {

        ASSERT(argument);

        if (! command) {
                check_exec(argument);
                NEW(command);
        }

        command->arg[command->length++] = argument;
        command->arg[command->length] = NULL;

        if (command->length >= ARGMAX)
                yyerror("Exceeded maximum number of program arguments");

}


/*
 * Setup a url request for the current port object
 */
static void prepare_urlrequest(URL_T U) {

        ASSERT(U);

        /* Only the HTTP protocol is supported for URLs currently. See also the lexer if this is to be changed in the future */
        portset.protocol = Protocol_get(Protocol_HTTP);

        if (urlrequest == NULL)
                NEW(urlrequest);
        urlrequest->url = U;
        portset.hostname = Str_dup(U->hostname);
        portset.target.net.port = U->port;
        portset.url_request = urlrequest;
        portset.type = Socket_Tcp;
        portset.parameters.http.request = Str_cat("%s%s%s", U->path, U->query ? "?" : "", U->query ? U->query : "");
        if (IS(U->protocol, "https"))
                sslset.flags = SSL_Enabled;
}


/*
 * Set the url request for a port
 */
static void  seturlrequest(int operator, char *regex) {

        ASSERT(regex);

        if (! urlrequest)
                NEW(urlrequest);
        urlrequest->operator = operator;
        int reg_return;
        NEW(urlrequest->regex);
        reg_return = regcomp(urlrequest->regex, regex, REG_NOSUB|REG_EXTENDED);
        if (reg_return != 0) {
                char errbuf[STRLEN];
                regerror(reg_return, urlrequest->regex, errbuf, STRLEN);
                yyerror2("Regex parsing error: %s", errbuf);
        }
}


/*
 * Add a new data recipient server to the mmonit server list
 */
static void addmmonit(Mmonit_T mmonit) {
        ASSERT(mmonit->url);

        Mmonit_T c;
        NEW(c);
        c->url = mmonit->url;
        c->compress = MmonitCompress_Init;
        _setSSLOptions(&(c->ssl));
        if (IS(c->url->protocol, "https")) {
#ifdef HAVE_OPENSSL
                c->ssl.flags = SSL_Enabled;
#else
                yyerror("SSL check cannot be activated -- SSL disabled");
#endif
        }
        c->timeout = mmonit->timeout;
        c->next = NULL;

        if (Run.mmonits) {
                Mmonit_T C;
                for (C = Run.mmonits; C->next; C = C->next)
                        /* Empty */ ;
                C->next = c;
        } else {
                Run.mmonits = c;
        }
        reset_sslset();
        reset_mmonitset();
}


/*
 * Add a new smtp server to the mail server list
 */
static void addmailserver(MailServer_T mailserver) {

        MailServer_T s;

        ASSERT(mailserver->host);

        NEW(s);
        s->host        = mailserver->host;
        s->port        = mailserver->port;
        s->username    = mailserver->username;
        s->password    = mailserver->password;

        if (sslset.flags && (mailserver->port == 25 || mailserver->port == 587))
                sslset.flags = SSL_StartTLS;
        _setSSLOptions(&(s->ssl));

        s->next = NULL;

        if (Run.mailservers) {
                MailServer_T l;
                for (l = Run.mailservers; l->next; l = l->next)
                        /* empty */;
                l->next = s;
        } else {
                Run.mailservers = s;
        }
        reset_mailserverset();
}


/*
 * Return uid if found on the system. If the parameter user is NULL
 * the uid parameter is used for looking up the user id on the system,
 * otherwise the user parameter is used.
 */
static uid_t get_uid(char *user, uid_t uid) {
        char buf[4096];
        struct passwd pwd, *result = NULL;
        if (user) {
                if (getpwnam_r(user, &pwd, buf, sizeof(buf), &result) != 0 || ! result) {
                        yyerror2("Requested user not found on the system");
                        return(0);
                }
        } else {
                if (getpwuid_r(uid, &pwd, buf, sizeof(buf), &result) != 0 || ! result) {
                        yyerror2("Requested uid not found on the system");
                        return(0);
                }
        }
        return(pwd.pw_uid);
}


/*
 * Return gid if found on the system. If the parameter group is NULL
 * the gid parameter is used for looking up the group id on the system,
 * otherwise the group parameter is used.
 */
static gid_t get_gid(char *group, gid_t gid) {
        struct group *grd;

        if (group) {
                grd = getgrnam(group);

                if (! grd) {
                        yyerror2("Requested group not found on the system");
                        return(0);
                }

        } else {

                if (! (grd = getgrgid(gid))) {
                        yyerror2("Requested gid not found on the system");
                        return(0);
                }

        }

        return(grd->gr_gid);

}


/*
 * Add a new user id to the current command object.
 */
static void addeuid(uid_t uid) {
        if (! getuid()) {
                command->has_uid = true;
                command->uid = uid;
        } else {
                yyerror("UID statement requires root privileges");
        }
}


/*
 * Add a new group id to the current command object.
 */
static void addegid(gid_t gid) {
        if (! getuid()) {
                command->has_gid = true;
                command->gid = gid;
        } else {
                yyerror("GID statement requires root privileges");
        }
}


/*
 * Reset the logfile if changed
 */
static void setlogfile(char *logfile) {
        if (Run.files.log) {
                if (IS(Run.files.log, logfile)) {
                        FREE(logfile);
                        return;
                } else {
                        FREE(Run.files.log);
                }
        }
        Run.files.log = logfile;
}


/*
 * Reset the pidfile if changed
 */
static void setpidfile(char *pidfile) {
        if (Run.files.pid) {
                if (IS(Run.files.pid, pidfile)) {
                        FREE(pidfile);
                        return;
                } else {
                        FREE(Run.files.pid);
                }
        }
        Run.files.pid = pidfile;
}


/*
 * Read a apache htpasswd file and add credentials found for username
 */
static void addhtpasswdentry(char *filename, char *username, Digest_Type dtype) {
        char *ht_username = NULL;
        char *ht_passwd = NULL;
        char buf[STRLEN];
        FILE *handle = NULL;
        int credentials_added = 0;

        ASSERT(filename);

        handle = fopen(filename, "r");

        if (handle == NULL) {
                if (username != NULL)
                        yyerror2("Cannot read htpasswd (%s) for user %s", filename, username);
                else
                        yyerror2("Cannot read htpasswd (%s)", filename);
                return;
        }

        while (! feof(handle)) {
                char *colonindex = NULL;

                if (! fgets(buf, STRLEN, handle))
                        continue;

                Str_rtrim(buf);
                Str_curtail(buf, "#");

                if (NULL == (colonindex = strchr(buf, ':')))
                continue;

                ht_passwd = Str_dup(colonindex+1);
                *colonindex = '\0';

                /* In case we have a file in /etc/passwd or /etc/shadow style we
                 *  want to remove ":.*$" and Crypt and MD5 hashed dont have a colon
                 */

                if ((NULL != (colonindex = strchr(ht_passwd, ':'))) && (dtype != Digest_Cleartext))
                        *colonindex = '\0';

                ht_username = Str_dup(buf);

                if (username == NULL) {
                        if (addcredentials(ht_username, ht_passwd, dtype, false))
                                credentials_added++;
                } else if (Str_cmp(username, ht_username) == 0)  {
                        if (addcredentials(ht_username, ht_passwd, dtype, false))
                                credentials_added++;
                } else {
                        FREE(ht_passwd);
                        FREE(ht_username);
                }
        }

        if (credentials_added == 0) {
                if (username == NULL)
                        yywarning2("htpasswd file (%s) has no usable credentials", filename);
                else
                        yywarning2("htpasswd file (%s) has no usable credentials for user %s", filename, username);
        }
        fclose(handle);
}


#ifdef HAVE_LIBPAM
static void addpamauth(char* groupname, int readonly) {
        Auth_T prev = NULL;

        ASSERT(groupname);

        if (! Run.httpd.credentials)
                NEW(Run.httpd.credentials);

        Auth_T c = Run.httpd.credentials;
        do {
                if (c->groupname != NULL && IS(c->groupname, groupname)) {
                        yywarning2("PAM group %s was added already, entry ignored", groupname);
                        FREE(groupname);
                        return;
                }
                prev = c;
                c = c->next;
        } while (c != NULL);

        NEW(prev->next);
        c = prev->next;

        c->next        = NULL;
        c->uname       = NULL;
        c->passwd      = NULL;
        c->groupname   = groupname;
        c->digesttype  = Digest_Pam;
        c->is_readonly = readonly;

        DEBUG("Adding PAM group '%s'\n", groupname);

        return;
}
#endif


/*
 * Add Basic Authentication credentials
 */
static bool addcredentials(char *uname, char *passwd, Digest_Type dtype, bool readonly) {
        Auth_T c;

        ASSERT(uname);
        ASSERT(passwd);

        if (strlen(passwd) > Str_compareConstantTimeStringLength) {
                yyerror2("Password for user %s is too long, maximum %d allowed", uname, Str_compareConstantTimeStringLength);
                FREE(uname);
                FREE(passwd);
                return false;
        }

        if (! Run.httpd.credentials) {
                NEW(Run.httpd.credentials);
                c = Run.httpd.credentials;
        } else {
                if (Util_getUserCredentials(uname) != NULL) {
                        yywarning2("Credentials for user %s were already added, entry ignored", uname);
                        FREE(uname);
                        FREE(passwd);
                        return false;
                }
                c = Run.httpd.credentials;
                while (c->next != NULL)
                        c = c->next;
                NEW(c->next);
                c = c->next;
        }

        c->next        = NULL;
        c->uname       = uname;
        c->passwd      = passwd;
        c->groupname   = NULL;
        c->digesttype  = dtype;
        c->is_readonly = readonly;

        DEBUG("Adding credentials for user '%s'\n", uname);

        return true;

}


/*
 * Set the syslog and the facilities to be used
 */
static void setsyslog(char *facility) {

        if (! Run.files.log || ihp.logfile) {
                ihp.logfile = true;
                setlogfile(Str_dup("syslog"));
                Run.flags |= Run_UseSyslog;
                Run.flags |= Run_Log;
        }

        if (facility) {
                if (IS(facility,"log_local0"))
                        Run.facility = LOG_LOCAL0;
                else if (IS(facility, "log_local1"))
                        Run.facility = LOG_LOCAL1;
                else if (IS(facility, "log_local2"))
                        Run.facility = LOG_LOCAL2;
                else if (IS(facility, "log_local3"))
                        Run.facility = LOG_LOCAL3;
                else if (IS(facility, "log_local4"))
                        Run.facility = LOG_LOCAL4;
                else if (IS(facility, "log_local5"))
                        Run.facility = LOG_LOCAL5;
                else if (IS(facility, "log_local6"))
                        Run.facility = LOG_LOCAL6;
                else if (IS(facility, "log_local7"))
                        Run.facility = LOG_LOCAL7;
                else if (IS(facility, "log_daemon"))
                        Run.facility = LOG_DAEMON;
                else
                        yyerror2("Invalid syslog facility");
        } else {
                Run.facility = LOG_USER;
        }

}


/*
 * Reset the current sslset for reuse
 */
static void reset_sslset() {
        memset(&sslset, 0, sizeof(struct SslOptions_T));
        sslset.version = sslset.verify = sslset.allowSelfSigned = -1;
}


/*
 * Reset the current mailset for reuse
 */
static void reset_mailset() {
        memset(&mailset, 0, sizeof(struct Mail_T));
}


/*
 * Reset the mailserver set to default values
 */
static void reset_mailserverset() {
        memset(&mailserverset, 0, sizeof(struct MailServer_T));
        mailserverset.port = PORT_SMTP;
}


/*
 * Reset the mmonit set to default values
 */
static void reset_mmonitset() {
        memset(&mmonitset, 0, sizeof(struct Mmonit_T));
        mmonitset.timeout = Run.limits.networkTimeout;
}


/*
 * Reset the Port set to default values
 */
static void reset_portset() {
        memset(&portset, 0, sizeof(struct Port_T));
        portset.check_invers = false;
        portset.socket = -1;
        portset.type = Socket_Tcp;
        portset.family = Socket_Ip;
        portset.timeout = Run.limits.networkTimeout;
        portset.retry = 1;
        portset.protocol = Protocol_get(Protocol_DEFAULT);
        urlrequest = NULL;
}


/*
 * Reset the Proc set to default values
 */
static void reset_resourceset() {
        resourceset.resource_id = 0;
        resourceset.limit = 0;
        resourceset.action = NULL;
        resourceset.operator = Operator_Equal;
}


/*
 * Reset the Timestamp set to default values
 */
static void reset_timestampset() {
        timestampset.type = Timestamp_Default;
        timestampset.operator = Operator_Equal;
        timestampset.time = 0;
        timestampset.test_changes = false;
        timestampset.initialized = false;
        timestampset.action = NULL;
}


/*
 * Reset the ActionRate set to default values
 */
static void reset_actionrateset() {
        actionrateset.count = 0;
        actionrateset.cycle = 0;
        actionrateset.action = NULL;
}


/*
 * Reset the Size set to default values
 */
static void reset_sizeset() {
        sizeset.operator = Operator_Equal;
        sizeset.size = 0;
        sizeset.test_changes = false;
        sizeset.action = NULL;
}


/*
 * Reset the Uptime set to default values
 */
static void reset_uptimeset() {
        uptimeset.operator = Operator_Equal;
        uptimeset.uptime = 0;
        uptimeset.action = NULL;
}


static void reset_responsetimeset() {
        responsetimeset.operator = Operator_Less;
        responsetimeset.current = 0.;
        responsetimeset.limit = -1.;
}


static void reset_linkstatusset() {
        linkstatusset.check_invers = false;
        linkstatusset.action = NULL;
}


static void reset_linkspeedset() {
        linkspeedset.action = NULL;
}


static void reset_linksaturationset() {
        linksaturationset.limit = 0.;
        linksaturationset.operator = Operator_Equal;
        linksaturationset.action = NULL;
}


/*
 * Reset the Bandwidth set to default values
 */
static void reset_bandwidthset() {
        bandwidthset.operator = Operator_Equal;
        bandwidthset.limit = 0ULL;
        bandwidthset.action = NULL;
}


/*
 * Reset the Pid set to default values
 */
static void reset_pidset() {
        pidset.action = NULL;
}


/*
 * Reset the PPid set to default values
 */
static void reset_ppidset() {
        ppidset.action = NULL;
}


/*
 * Reset the Fsflag set to default values
 */
static void reset_fsflagset() {
        fsflagset.action = NULL;
}


/*
 * Reset the Nonexist set to default values
 */
static void reset_nonexistset() {
        nonexistset.action = NULL;
}


static void reset_existset() {
        existset.action = NULL;
}


/*
 * Reset the Checksum set to default values
 */
static void reset_checksumset() {
        checksumset.type         = Hash_Unknown;
        checksumset.test_changes = false;
        checksumset.action       = NULL;
        *checksumset.hash        = 0;
}


/*
 * Reset the Perm set to default values
 */
static void reset_permset() {
        permset.test_changes = false;
        permset.perm = 0;
        permset.action = NULL;
}


/*
 * Reset the Status set to default values
 */
static void reset_statusset() {
        statusset.initialized = false;
        statusset.return_value = 0;
        statusset.operator = Operator_Equal;
        statusset.action = NULL;
}


/*
 * Reset the Uid set to default values
 */
static void reset_uidset() {
        uidset.uid = 0;
        uidset.action = NULL;
}


/*
 * Reset the Gid set to default values
 */
static void reset_gidset() {
        gidset.gid = 0;
        gidset.action = NULL;
}


/*
 * Reset the Filesystem set to default values
 */
static void reset_filesystemset() {
        filesystemset.resource = 0;
        filesystemset.operator = Operator_Equal;
        filesystemset.limit_absolute = -1;
        filesystemset.limit_percent = -1.;
        filesystemset.action = NULL;
}


/*
 * Reset the ICMP set to default values
 */
static void reset_icmpset() {
        icmpset.type = ICMP_ECHO;
        icmpset.size = ICMP_SIZE;
        icmpset.count = ICMP_ATTEMPT_COUNT;
        icmpset.timeout = Run.limits.networkTimeout;
        icmpset.check_invers = false;
        icmpset.action = NULL;
}


/*
 * Reset the Rate set to default values
 */
static void reset_rateset(struct rate_t *r) {
        r->count = 1;
        r->cycles = 1;
}


/* ---------------------------------------------------------------- Checkers */


/*
 * Check for unique service name
 */
static void check_name(char *name) {
        ASSERT(name);

        if (Util_existService(name) || (current && IS(name, current->name)))
                yyerror2("Service name conflict, %s already defined", name);
        if (name && *name == '/')
                yyerror2("Service name '%s' must not start with '/' -- ", name);
}


/*
 * Permission statement semantic check
 */
static int check_perm(int perm) {
        int result;
        char *status;
        char buf[STRLEN];

        snprintf(buf, STRLEN, "%d", perm);

        result = (int)strtol(buf, &status, 8);

        if (*status != '\0' || result < 0 || result > 07777)
                yyerror2("Permission statements must have an octal value between 0 and 7777");

        return result;
}


/*
 * Check the dependency graph for errors
 * by doing a topological sort, thereby finding any cycles.
 * Assures that graph is a Directed Acyclic Graph (DAG).
 */
static void check_depend() {
        Service_T depends_on = NULL;
        Service_T* dlt = &depend_list; /* the current tail of it                                 */
        bool done;                /* no unvisited nodes left?                               */
        bool found_some;          /* last iteration found anything new ?                    */
        depend_list = NULL;            /* depend_list will be the topological sorted servicelist */

        do {
                done = true;
                found_some = false;
                for (Service_T s = servicelist; s; s = s->next) {
                        Dependant_T d;
                        if (s->visited)
                                continue;
                        done = false; // still unvisited nodes
                        depends_on = NULL;
                        for (d = s->dependantlist; d; d = d->next) {
                                Service_T dp = Util_getService(d->dependant);
                                if (! dp) {
                                        Log_error("Depending service '%s' is not defined in the control file\n", d->dependant);
                                        exit(1);
                                }
                                if (! dp->visited) {
                                        depends_on = dp;
                                }
                        }

                        if (! depends_on) {
                                s->visited = true;
                                found_some = true;
                                *dlt = s;
                                dlt = &s->next_depend;
                        }
                }
        } while (found_some && ! done);

        if (! done) {
                ASSERT(depends_on);
                Log_error("Found a depend loop in the control file involving the service '%s'\n", depends_on->name);
                exit(1);
        }

        ASSERT(depend_list);
        servicelist = depend_list;

        for (Service_T s = depend_list; s; s = s->next_depend)
                s->next = s->next_depend;
}


// Check and warn if the executable does not exist
static void check_exec(char *exec) {
        if (! File_exist(exec))
                yywarning2("Program does not exist:");
        else if (! File_isExecutable(exec))
                yywarning2("Program is not executable:");
}


/* Return a valid max forward value for SIP header */
static int verifyMaxForward(int mf) {
        if (mf == 0) {
                return INT_MAX; // Differentiate uninitialized (0) and explicit zero
        } else if (mf > 0 && mf <= 255) {
                return mf;
        }
        yywarning2("SIP max forward is outside the range [0..255]. Setting max forward to 70");
        return 70;
}


/* -------------------------------------------------------------------- Misc */


/*
 * Cleans up a hash string, tolower and remove byte separators
 */
static int cleanup_hash_string(char *hashstring) {
        int i = 0, j = 0;

        ASSERT(hashstring);

        while (hashstring[i]) {
                if (isxdigit((int)hashstring[i])) {
                        hashstring[j] = tolower((int)hashstring[i]);
                        j++;
                }
                i++;
        }
        hashstring[j] = 0;
        return j;
}


/* Return deep copy of the command */
static command_t copycommand(command_t source) {
        int i;
        command_t copy = NULL;

        NEW(copy);
        copy->length = source->length;
        copy->has_uid = source->has_uid;
        copy->uid = source->uid;
        copy->has_gid = source->has_gid;
        copy->gid = source->gid;
        copy->timeout = source->timeout;
        for (i = 0; i < copy->length; i++)
                copy->arg[i] = Str_dup(source->arg[i]);
        copy->arg[copy->length] = NULL;

        return copy;
}


static void _setPEM(char **store, char *path, const char *description, bool isFile) {
        if (*store) {
                yyerror2("Duplicate %s", description);
                FREE(path);
        } else if (! File_exist(path)) {
                yyerror2("%s doesn't exist", description);
                FREE(path);
        } else if (! (isFile ? File_isFile(path) : File_isDirectory(path))) {
                yyerror2("%s is not a %s", description, isFile ? "file" : "directory");
                FREE(path);
        } else if (! File_isReadable(path)) {
                yyerror2("Cannot read %s", description);
                FREE(path);
        } else {
                sslset.flags = SSL_Enabled;
                *store = path;
        }
}


static void _setSSLOptions(SslOptions_T options) {
        options->allowSelfSigned = sslset.allowSelfSigned;
        options->CACertificateFile = sslset.CACertificateFile;
        options->CACertificatePath = sslset.CACertificatePath;
        options->checksum = sslset.checksum;
        options->checksumType = sslset.checksumType;
        options->ciphers = sslset.ciphers;
        options->clientpemfile = sslset.clientpemfile;
        options->flags = sslset.flags;
        options->pemfile = sslset.pemfile;
        options->pemchain = sslset.pemchain;
        options->pemkey = sslset.pemkey;
        options->verify = sslset.verify;
        options->version = sslset.version;
        reset_sslset();
}


#ifdef HAVE_OPENSSL
static void _setSSLVersion(short version) {
        sslset.flags = SSL_Enabled;
        if (sslset.version == -1)
                sslset.version = version;
        else
                sslset.version |= version;
}
#endif


static void _unsetSSLVersion(short version) {
        if (sslset.version != -1)
                sslset.version &= ~version;
}


static void addsecurityattribute(char *value, Action_Type failed, Action_Type succeeded) {
        SecurityAttribute_T attr;
        NEW(attr);
        addeventaction(&(attr->action), failed, succeeded);
        attr->attribute = value;
        attr->next = current->secattrlist;
        current->secattrlist = attr;
}

static void addfiledescriptors(Operator_Type operator, bool total, long long value_absolute, float value_percent, Action_Type failed, Action_Type succeeded) {
        Filedescriptors_T fds;
        NEW(fds);
        addeventaction(&(fds->action), failed, succeeded);
        fds->total = total;
        fds->limit_absolute = value_absolute;
        fds->limit_percent = value_percent;
        fds->operator = operator;
        fds->next = current->filedescriptorslist;
        current->filedescriptorslist = fds;
}

